---------------------------------------------------------------------------------------------------
Version: 2.0.42
Date: ????
---------------------------------------------------------------------------------------------------
Version: 2.0.41
Date: 12. 03. 2025
  Bugfixes:
    - Fixed extra spidertron ghost being created when ghost-building spidertron snapped to existing spidertron ghost (https://forums.factorio.com/119776)
    - Fixed deconstruction planner would not respect deconstruction alternatives when they were inside of entity ghost. (https://forums.factorio.com/127414)
    - Fixed a desync when cancelling deconstruction of frozen underground belts or frozen splitters.
    - Fixed a crash when trying to create a blueprint out of space platform hub which has wait condition with empty item field.
---------------------------------------------------------------------------------------------------
Version: 2.0.40
Date: 12. 03. 2025
  Bugfixes:
    - Fixed splash screen progress bar size not scaling with the UI.
    - Fixed that the can't-reach wire sprite would get drawn under some entities. (https://forums.factorio.com/124590)
    - Fixed that the chart drag hotkey did not work. (https://forums.factorio.com/127287)
    - Fixed that pre-2.0 map exchange strings were able to disable cliffs on all planets. (https://forums.factorio.com/127071)
    - Fixed a crash when a tile cannot be placed due to a missing foundation with default not given. (https://forums.factorio.com/127087)
    - Fixed rail signal selection box when selection box is off-center. (https://forums.factorio.com/119778)
    - Fixed that beacon fast-replace would allow modules the beacon did not accept. (https://forums.factorio.com/125352)
    - Fixed that water cane had the wrong icon. (https://forums.factorio.com/123473)
    - Fixed that building vehicles with pre-configured equipment grids did not always work correctly. (https://forums.factorio.com/123758)
    - Fixed another bug related to smart underground belt building.
    - [space-age] Fixed some recipes would recycle to wrong items when playing with quality only. (https://forums.factorio.com/127370)
    - Fixed parametrisation into requests which would lead into duplicate requests wasn't handled. (https://forums.factorio.com/119628)
    - Fixed that personal lasers would be offset incorrectly while having a tesla gun equipped. (https://forums.factorio.com/122006)
    - Fixed a crash related to modded enemy behavior. (https://forums.factorio.com/127314)
    - Fixed ghosts of non-blueprintable entities being ghost-buildable in normal mode (e.g. in remote view). (https://forums.factorio.com/127375)
    - Fixed missing blueprint parametrisation number context for ticks waiting in station schedule condition. (https://forums.factorio.com/119806)
    - Fixed GPU-accelerated compressed mipmaps on Apple Silicon Macs. (https://forums.factorio.com/127316)
    - Fixed that the infinity cargo wagon showed in Factoriopedia. (https://forums.factorio.com/127394)
    - Fixed a graphics artifact when drawing ghost rocket silos. (https://forums.factorio.com/126888)
    - Fixed nauvis_uranium_processing menu simulation not loading properly in the demo. (https://forums.factorio.com/124048)
    - Fixed that some frozen rocket silos could get stuck. (https://forums.factorio.com/126779)
    - Fixed a crash when upgrading underground belts manually through remote view. (https://forums.factorio.com/127385)
  Modding:
    - Added ElectricPolePrototype::rewire_neighbours_when_destroying.
    - Moved the agricultural tower growth area radius to the prototype as growth_area_radius. (https://forums.factorio.com/127340)
---------------------------------------------------------------------------------------------------
Version: 2.0.39
Date: 05. 03. 2025
  Changes:
    - Added extra info about the evaluation order and dependencies into the blueprint parametrisation UI.
  Bugfixes:
    - Fixed not being able to interact with GUI elements behind transparent parts of other windows. (https://forums.factorio.com/119608)
    - Fixed display panels not drawing text correctly at larger GUI scales. (https://forums.factorio.com/122533)
    - Fixed a crash related to placing cargo landing pads on space platforms. (https://forums.factorio.com/127260)
    - Fixed a crash when rendering thrusters without fire plumes defined. (https://forums.factorio.com/127265)
    - Fixed that fast-transfer of ghost modules did not work for out of reach entities. (https://forums.factorio.com/122150)
    - Fixed that trains with the same stop in their schedule would not move between stops even if the one it is waiting at is disabled. (https://forums.factorio.com/118475)
    - Fixed decider combinator GUI signals tables getting squashed too much when there are a lot of conditions/outputs. (https://forums.factorio.com/126808)
    - Fixed intro sound not respecting music-muted and master-muted settings. (https://forums.factorio.com/127154)
    - Fixed graphical issue happening when lightning attractor's collection range boundary was touching larger range attractor's collection range boundary from the inside. (https://forums.factorio.com/122739)
    - Fixed incorrect lightning protection visualisation when surface lightning search range was larger than attractor's protection range.
    - Fixed overbuilding ghost with module requests with physical entity of different quality would not retain the module requests. (https://forums.factorio.com/125374)
    - Fixed normal building underground belts and pipes in remote view would deconstruct rocks, trees and cliffs. (https://forums.factorio.com/123925)
    - Fixed normal building underground belts and pipes in remote view would have missing tiles autofilled. (https://forums.factorio.com/123817)
    - Fixed crash in latency when upgrading ghost of elevated rails to different quality (https://forums.factorio.com/120345, https://forums.factorio.com/124222)
    - Fixed crash when car would collide with 0 health entity in latency (https://forums.factorio.com/126295)
    - Fixed finish game achievements showing as obtainable on saves that has already finished the game (https://forums.factorio.com/122592)
---------------------------------------------------------------------------------------------------
Version: 2.0.38
Date: 04. 03. 2025
  Changes:
    - Space platform "request missing materials for construction" will no longer request items for entity ghosts which can't yet be built. (https://forums.factorio.com/122185)
      This should help to prevent over filling of hubs while larger platforms are being built.
    - Increased minimum sprite atlas size to 4096 even when sprite resolution is set to medium. (https://forums.factorio.com/127086)
  Bugfixes:
    - Fixed a lua doc error with LuaSchedule::add_wait_condition(). (https://forums.factorio.com/127153)
    - Fixed a crash when changing the station in some wait conditions. (https://forums.factorio.com/127123)
    - Fixed that the mining dril status would be incorrect when out of resources and pointing at an entity to be deconstructed. (https://forums.factorio.com/125167)
    - Fixed that inserters would not show target full for space platform hubs. (https://forums.factorio.com/121920)
    - Fixed a crash when opening the changelog while trying to connect to a multiplayer game. (https://forums.factorio.com/118795)
    - Fixed that LuaSchedule::add_record() did not support rail_direction. (https://forums.factorio.com/127171)
    - Fixed that vehicle weapon tooltips did not show bonuses. (https://forums.factorio.com/122386)
    - Fixed that steamrolled achievement couldn't be earned while driving remotely. (https://forums.factorio.com/120247)
    - Fixed lab was not creating trash inventory of proper size when LabPrototype::trash_inventory_size was given. (https://forums.factorio.com/127218)
    - Fixed that the side menu buttons did not update when a player would change forces. (https://forums.factorio.com/122088)
    - Fixed that the filter selection GUI would get closed when a ghost buffer chest was built. (https://forums.factorio.com/122514)
    - Improved issue with fast moving bots sometime appearing on screen instead of flying in from off screen. (https://forums.factorio.com/124268)
    - Fixed issue which sometimes resulted in incorrect lightning protection visualisation for marginal setups (https://forums.factorio.com/126780)
    - Fixed cutting tiles marked for deconstruction could produce superfluous deconstructible tile proxies (https://forums.factorio.com/124155)
    - Fixed Steam achievements synchronisation issues. (https://forums.factorio.com/118242)
    - Fixed that having a camera widget on screen would cause issues with the rail plan finder. (https://forums.factorio.com/122679)
    - Fixed that resources with no minable products would not show a name when hovering in the map view.
    - Fixed some almost transparent pixels in the car and production group icons. (https://forums.factorio.com/127227)
    - Fixed that researching a technology would cause the input fields in constant combinators and requester chests to lose focus. (https://forums.factorio.com/123241)
  Modding:
    - Added the "infinity-cargo-wagon" entity type.
    - Added the "proxy-container" entity type.
    - Added SpiderVehicleGraphicsSet::default_color.
    - Unified entity_renderer_search_box_limits to 6 from all sides due to reduced update rate optimization of robots.
    - Reduced light_renderer_search_distance_limit to 20 to compensate for entity_renderer_search_box_limits change.
  Scripting:
    - Added LuaSchedule::get_records(), set_records(), clear_records(), get_interrupts(), set_interrupts(), clear_interrupts().
    - Changed LuaSchedule::add_record() to purely add without any extra behavior.
    - Changed LuaSchedule::add_record() to accept index saying where the record is added.
    - Added LuaProxyContainerControlBehavior.
    - Added defines.inventory.proxy_main.
    - Added LuaEntity::proxy_target_entity and proxy_target_inventory.
    - Added LuaEntity::get_cargo_bays().
    - Added LuaPlayer::add_pin().
    - Added LuaPrototypeBase::factoriopedia_description read.
    - Added factoriopedia_alternative reads to all LuaPrototypes that support it.
---------------------------------------------------------------------------------------------------
Version: 2.0.37
Date: 26. 02. 2025
  Bugfixes:
    - Fixed that inserters could get stuck when interacting with trains if the train arrived at a station without physically moving. (https://forums.factorio.com/127134)
    - Fixed that LuaSchedule::add_wait_condition, remove_wait_condition, and change_wait_condition expected a table of arguments instead of direct arguments.
---------------------------------------------------------------------------------------------------
Version: 2.0.36
Date: 26. 02. 2025
  Minor Features:
    - Added an option to mute sound categories in sound settings. (https://forums.factorio.com/126735)
    - Added an option to control the volume of Programmable speaker sounds via circuit network. (https://forums.factorio.com/112852)
    - Added an option to stop playing sounds of Programmable speaker when input signal changes instead of waiting for the sounds to finish playing. (https://forums.factorio.com/112852)
    - Added an option for Programmable speaker to use Cyclic sounds. (https://forums.factorio.com/112852)
    - Decider combinator output constant can be changed.
  Changes:
    - Added missing open/close GUI sounds and fixed incorrect open/close GUI sounds for various entities. (https://forums.factorio.com/126967)
    - Changed the "Train stop names" checkbox in the blueprint ui to be always on by default.
  Graphics:
    - Updated space platform related icon like the hub, starter pack, icon for the surface and the tech icon.
    - Used the new virtual signal icon for research also for the research icon in the production graphs.
  Optimizations:
    - Improved belt reader performance.
  Bugfixes:
    - Fixed that a small empty UI box was visible on the main menu. (https://forums.factorio.com/126989)
    - Fixed a crash when generating a variable track would encounter a filesystem error.
    - Fixed sound accents could play when they shouldn't on switching between machine GUIs. (https://forums.factorio.com/122518)
    - Fixed a crash when changing some modded assembling machine recipes. (https://forums.factorio.com/126995)
    - Fixed a failing SegmentedUnit-related consistency check when loading some saves. (https://forums.factorio.com/126642)
    - Fixed that the building preview and actual build position could differ at some resolutions and zooms. (https://forums.factorio.com/118896)
    - Fixed a crash when trying to drop items onto game's title bar.
    - Fixed LuaWireConnector was returning wrong values of the electric network index. (https://forums.factorio.com/127085)
    - Fixed that clicking on a station in train GUI created unexpected browse history entries. (https://forums.factorio.com/119527)
    - Fixed that traversing train GUI browse history entries didn't preserve centered locomotive.
    - Fixed that going back in history to remote driving didn't change player surface. (https://forums.factorio.com/118006)
    - Fixed LuaSurface::calculate_tile_properties() not ignoring unknown variables. (https://forums.factorio.com/126849)
    - Restored signal-ghost virtual signal. (https://forums.factorio.com/126713)
    - Fixed decider combinator gui could show old input or output signals when fps < ups and last signals change happened at skipped frame.
    - Fixed construction robots storing incorrect items in a filtered storage chest if their upgrade job was cancelled. (https://forums.factorio.com/125750)
    - Fixed that changing the volume of a Programmable speaker wouldn't update the volume of a playing sound with Surface playback mode.
    - Fixed that changing playback mode of a Programmable speaker wouldn't affect currently playing sounds.
    - Fixed that trivial smokes for player effect could cause new chunks to be generated when looking at the map. (https://forums.factorio.com/127011)
    - Fixed missing walking sounds for rails. (https://forums.factorio.com/127117)
    - Fixed that undo removal of tile ghosts did not set the last user. (https://forums.factorio.com/127084)
  Modding:
    - Added optional ProgrammableSpeakerNote::cyclic_sound. (https://forums.factorio.com/112852)
  Scripting:
    - Added optional 'stop_playing_sounds' parameter to LuaEntity::play_note().
    - Added LuaSchedule.
    - Added LuaSpacePlatform::get_schedule().
    - Added LuaTrain::get_schedule().
---------------------------------------------------------------------------------------------------
Version: 2.0.35
Date: 20. 02. 2025
  Minor Features:
    - GUIs can now also be navigated with D-pad in controller input method.
    - Added drag-to-reorder to pins.
    - Added drag-to-reorder turret priorities.
    - Added drag-to-reorder to infinity chest filters.
    - Added drag-to-reorder to editor infinity filters.
    - Added drag-to-reorder to deconstruction planner filters.
    - Added drag-to-reorder to upgrade planner filters.
    - Added drag-to-reorder to module upgrade settings inside upgrade planner destination UI.
    - Added drag-to-reorder to inserter, loader, and asteroid collector filters.
    - Furnaces can be connected to circuit network.
    - Added fluid temperatures to Factoriopedia ingredients and products where relevant. (https://forums.factorio.com/119927)
    - Make drop item hotkey work the same way in GUI as it does in the game world.
  Changes:
    - Adjusted how walking and driving sounds attenuate with zoom level.
    - Added missing walking sounds and fixed incorrect walking sounds for various decoratives.
    - Linked fluidbox connections will no longer show a fluid icon.
  Bugfixes:
    - Fixed that reading localised strings through some methods did not work correctly. (https://forums.factorio.com/126626)
    - Fixed that unpowered inserters could pick up fish. (https://forums.factorio.com/126522)
    - Fixed that spoiled items in modded rocket silos couldn't be removed by inserters. (https://forums.factorio.com/126403)
    - Fixed that virtual items like green-wire or spidertron-remote had recycling recipes. (https://forums.factorio.com/124333)
    - Fixed that deleting a surface with off-chunk segmented units could cause consistency checks to fail. (https://forums.factorio.com/126642)
    - Fixed a desync when deleting chart tags pinned by other players. (https://forums.factorio.com/126681)
    - Fixed consistency issues in deconstruction planner UI when toggling "Trees/rocks only" checkbox and tile mode dropdown.
    - Fixed space platforms not updating last activity time when advancing schedule to the same planet. (https://forums.factorio.com/126640)
    - Fixed missing frames in fusion generator animation. (https://forums.factorio.com/126526)
    - Fixed a consistency issue when a mod adds fluid to a frozen fluid box. (https://forums.factorio.com/126685)
    - Fixed that LuaFluidBox functions would not work correctly with a frozen fluid box.
    - Fixed that frozen fluid boxes would not show the fluid they contained.
    - Fixed schedule GUI not updating temporary station status when interrupt triggers from a temporary station which is last in schedule. (https://forums.factorio.com/120355)
    - Fixed furnaces could report as being able to craft certain recipes when they had not enough item ingredient slots. (https://forums.factorio.com/116147)
    - Fixed assemblers could report as being able to craft certain recipes with custom fluidbox indexes when assembler had not enough fluidboxes.
    - Fixed furnaces were able to craft recipes with more item products than size of furnace's products inventory.
    - Added more detailed healing values for entities healing < 10/s. (https://forums.factorio.com/125223)
    - Fixed a crash when migrating assembler with control behavior into different entity type.
    - Fixed that crafting machines with high speeds would not scale input fluid amounts. (https://forums.factorio.com/126722)
    - Fixed a crash in latency when character with exoskeletons moves onto ungenerated chunks.
    - Fixed that items spoiling in cargo pods would not run spoil triggers. (https://forums.factorio.com/126796)
    - Fixed that entities upgraded on platforms would not fire the on_space_platform_built_entity event. (https://forums.factorio.com/126800)
    - Fixed that equipment in map editor armor did not work. (https://forums.factorio.com/126814)
    - Fixed consistency issue related to setting signals with with quality only. (https://forums.factorio.com/126855)
    - Fixed a consistency issue when underground belts with items are cloned. (https://forums.factorio.com/126843)
    - Fixed a consistency issue when robots deconstruct heat pipes keeping roboports from freezing. (https://forums.factorio.com/122880)
    - Fixed a crash when flipping an entity with linked fluidbox connections. (https://forums.factorio.com/121887)
    - Fixed a scaling performance issue related to blueprints with asteroid collector and thruster count on space platforms. (https://forums.factorio.com/126903)
    - Fixed that LuaRecord::contents did not accurately reflect the positions of the children.
    - Fixed that canceling mod updates would not re-enable the "Update selected" button. (https://forums.factorio.com/126192)
    - Fixed a crash when placing ghost rail signal on top of existing rail signals that is marked to be upgraded. (https://forums.factorio.com/126921)
    - Fixed that copy-settings undo/redo action descriptions would use the wrong surface. (https://forums.factorio.com/126957)
    - Fixed that the map editor tile paint bucket tool did not highlight tiles correctly. (https://forums.factorio.com/126959)
    - Fixed that platform inactivity was not updated when sending cargo to planets. (https://forums.factorio.com/126891)
  Modding:
    - Added FurnacePrototype::circuit_connector, circuit_connector_flipped, circuit_wire_max_distance, default_recipe_finished_signal, default_working_signal.
    - Added AssemblingMachinePrototype::circuit_connector_flipped.
    - Added AssemblingMachinePrototype::max_item_product_count.
    - Added LoaderPrototype::adjustable_belt_stack_size.
  Scripting:
    - Added LuaFurnaceControlBehavior.
    - Added LuaTransportLine::force_insert_at.
    - Added LuaEntity::loader_belt_stack_size_override read/write.
    - Added LuaEntityPrototype::loader_max_belt_stack_size read.
    - Added LuaEntityPrototype::loader_adjustable_belt_stack_size read.
    - Added on_cargo_pod_finished_descending and on_cargo_pod_delivered_cargo events.
    - Added LuaRecord::contents_size read.
    - Added CustomInputEvent::cursor_direction.
    - Added on_singleplayer_init and on_multiplayer_init.
    - Added defines.inventory.assembling_machine_trash and defines.inventory.furnace_trash.
---------------------------------------------------------------------------------------------------
Version: 2.0.34
Date: 06. 02. 2025
  Minor Features:
    - Extended the virtual signals, and unified/changed graphics of some of the existing ones.
    - Added an ability to pin the selected resource patch directly from map view.
  Balancing:
    - [space-age] Oil Refinery now collides with ice platform (https://forums.factorio.com/124163)
    - water-mud and water-shallow are now landfillable in vanilla (already landfillable in space age) (https://forums.factorio.com/123169)
  Changes:
    - Added speed values to the description of demolishers. (https://forums.factorio.com/119588)
    - Drag building produces one merge undo action per the whole drag, instead of the individual undo actions for every entity built.
  Optimizations:
    - Cargo pod performance when launching from platforms to planets is roughly 687 times faster. (https://forums.factorio.com/126455)
    - Cargo pod performance when landing in cargo bays attached to landing pads is roughly 187 times faster.
    - Improved cargo pod and rocket silo rocket performance when waiting in rocket silos by 100%.
    - Improved inserter performance when removing items from space platform hubs.
  Bugfixes:
    - Fixed wrong behaviour in smart belt building over an obstacle with belts soon after the obstacle.
    - Fixed smart belt building over an obstacle when there is perpendicular underground belt in the way.
    - Fixed a crash when wrapping a rich text image in color tags and pressing backspace. (https://forums.factorio.com/120837)
    - Fixed that changing the force of a segment did not in fact change the force of the entire segmented unit. (https://forums.factorio.com/126385)
    - Fixed demolisher simulation in Factoriopedia.
    - Fixed that roboport read-requests could output signals when they weren't actually being requested. (https://forums.factorio.com/118396)
    - Fixed missing link between vehicles and guns in Factoriopedia. (https://forums.factorio.com/120410)
    - Fixed that async saving would freeze the game. (https://forums.factorio.com/126407)
    - Fixed a crash when changing GUI scale with the production statistics open. (https://forums.factorio.com/126341)
    - Fixed textboxes not clearing mouse drag selection when something is typed. (https://forums.factorio.com/126355)
    - Fixed that issuing valid navigation commands to UnitGroups would sometimes fail or succeed immediately. (https://forums.factorio.com/118082)
    - Fixed that attack area commands issued to UnitGroups were not finding valid targets in the attack area. (https://forums.factorio.com/118082)
    - Fixed that super-forced building over belts ignored planned upgrade when adding underground belts. (https://forums.factorio.com/119986)
    - Fixed modifier icon in technology icons would cause the technology icons to draw smaller and off center. (https://forums.factorio.com/126414)
    - Fixed stack inserter not dropping held item that does not match filters when filters were enabled. (https://forums.factorio.com/126468)
    - Fixed yellow tinted rectangles around rail tracks and other sprites on Mac. (https://forums.factorio.com/116387)
    - Fixed Galaxy Of Fame upload timeout errors for bigger saves
    - Fixed a crash with a working sound containing an empty main sound. (https://forums.factorio.com/126563)
    - Fixed the research completed sound being played multiple times when multiple researches finish on the same tick. (https://forums.factorio.com/124424)
    - Fixed "Send to orbit automatically" tooltip being incorrect when playing Space Age with mods. (https://forums.factorio.com/126570)
    - Fixed a space platform destination inconsistency when pasting space platform hub settings. (https://forums.factorio.com/125892)
    - Fixed Schedule interrupts not reading any-signal signal counts sent to train correctly. (https://forums.factorio.com/126480)
    - Fixed car orientation being lost when exporting and reimporting blueprint string. (https://forums.factorio.com/125221)
    - Fixed being able to remotely drive enemy vehicles (https://forums.factorio.com/122610)
    - Fixed unrotatable furnaces being rotated when overbuilt with a blueprint (https://forums.factorio.com/126373)
    - Fixed including any filter into deconstruction planner would make it ignore vehicle ghosts (https://forums.factorio.com/119793)
    - Fixed removing tile ghost would sometimes not remove supported entity ghost in the margins (https://forums.factorio.com/126504)
    - Fixed that deconstructing cargo bays connected to cargo landing pads could delete items. (https://forums.factorio.com/126593)
    - Fixed a desync when upgrading underground belts in some cases.
    - Fixed a roboport network becoming overfilled with robots when a stationing robot went to a roboport which was being refilled by inserters and the network was full.
    - Fixed that a robot didn't resume bobbing after unsuccessful stationing attempt.
    - Fixed space platform's asteroid nav mesh could use wrong max tether value when after mods were changed. (https://forums.factorio.com/126590)
    - Fixed a consistency crash related to super force building and underground belts. (https://forums.factorio.com/126394)
    - Fixed that tile prototype's placeable_by.count was ignored when building manually (https://forums.factorio.com/123322)
    - Modified Railgun Turret projectile spawning location such that it would no longer unexpectedly destroy nearby friendly entities (https://forums.factorio.com/121660)
    - Fixed that character light rendering would be wrong when paused while in remote view. (https://forums.factorio.com/126542)
    - Fixed issue which allowed player to get tile ghost over tile of same type (leading to stuck robots) (https://forums.factorio.com/122905)
    - Fixed entities with protected_from_tile_building = false would block tile ghost revival (https://forums.factorio.com/125189 and https://forums.factorio.com/126504)
    - Fixed overbuilding of storage chests with blueprint of different quality storage chest with filter set would result in unneeded deconstruction (https://forums.factorio.com/124388)
    - Fixed that space connections on the starmap would not use the shortest route if the route passed above the star. (https://forums.factorio.com/123035)
    - Fixed autofilled tile ghosts not raising on_built_entity triggers (https://forums.factorio.com/126116)
  Scripting:
    - Added LuaRecord::preview_icons read/write.
    - Added record to on_player_setup_blueprint and on_player_deconstructed_area. (https://forums.factorio.com/88100)
    - Added LuaEntity::create_cargo_pod().
    - Added LuaEntity::cargo_hatches read.
    - Added LuaEntity::cargo_pod_state read.
    - Added LuaEntity::cargo_pod_destination read/write.
    - Added LuaCargoHatch.
    - Added Luaentity::attached_cargo_pod read.
    - Added LuaEntity::rocket read.
    - Added LuaSpacePlatform::can_leave_current_location().
    - Added LuaSpacePlatform::distance read/write.
    - Added LuaSpacePlatform::space_connection read/write.
    - Changed LuaSpacePlatform::space_location to read/write.
---------------------------------------------------------------------------------------------------
Version: 2.0.33
Date: 28. 01. 2025
  Minor Features:
    - Show a warning in the blueprint library if it's using a lot of RAM.
    - Show a warning in blueprint and blueprint book tooltips if they are using a lot of RAM.
    - Added fluid contents to the pumpjack tooltip. (https://forums.factorio.com/117211)
  Changes:
    - Added hatch count info to platform hub, landing pad and rocket silo.
    - Reduced how much you can zoom out in god controller.
    - Multiplayer selection rectangles will only show the player name if the player's character is not visible on-screen.
    - Moved biter egg handling to be required by promethium science pack instead of quantum processors because that's when they are really needed.
  Graphics:
    - Fixed reflections on water being broken. (https://forums.factorio.com/124269)
    - Baked in shadows of decaying enemies to have them draw better when on transport belts, and also to save on VRAM. (https://forums.factorio.com/116164)
    - Tweaked some colours of recipes in biochambers so they're a bit easier to tell apart.
    - Added destroyed graphics for crushers, and improved their graphics a little bit.
    - Added destroyed graphics for space platform thrusters.
    - Improved icons of cargo pod.
    - Added icon for the technology effect of elevated rails.
    - Removed unused spritesheets from the game data folder.
  Optimizations:
    - Demolishers are now no longer simulated when they are irrelevant to gameplay, and off-screen demolishers are now only partially simulated. (https://forums.factorio.com/120275)
  Bugfixes:
    - Fixed that modded rocket silo ingredients that could spoil would not be inserted into the rocket silo crafting inventory. (https://forums.factorio.com/123081)
    - Fixed that some startup errors would cause the mod list to be set to "enable all". (https://forums.factorio.com/126164)
    - Fixed that a demolisher dying to a nuclear reactor meltdown didn't count as a player kill for statistics or achievements. (https://forums.factorio.com/124442)
    - Fixed scaled rich text was not rendered properly. (https://forums.factorio.com/126092)
    - Removed duplicated frame in the fusion generator animation. (https://forums.factorio.com/123796)
    - Fixed that the rail planner did not work on the edges of larger screens. (https://forums.factorio.com/126120)
    - Fixed that LuaPlayer::set_controller would erroneously toggle double-remote view, causing corrupted remote driving states. (https://forums.factorio.com/121791)
    - Fixed "Any planet import zero" wait condition not ignoring requests with zero amount. (https://forums.factorio.com/119181)
    - Fixed request satisfied item selection list showing all qualities. (https://forums.factorio.com/125577)
    - Fixed large amounts of unfulfilled requests blocking delivery of available items. (https://forums.factorio.com/124909)
    - Fixed that turbo splitters used slightly less energy than other splitters to not freeze. (https://forums.factorio.com/126163)
    - Fixed rocket silo tooltip was not aggregating similar items from rocket inventory. (https://forums.factorio.com/123590)
    - Fixed that you couldn't re-select the same item when opening the remote view ghost picker. (https://forums.factorio.com/125403)
    - Fixed that calling LuaGuiElement::remove_tab would not remove the tab content in some cases. (https://forums.factorio.com/115901)
    - Fixed that LuaGuiElement::selected_tab_index would not update when a tab was removed. (https://forums.factorio.com/115901)
    - Fixed that hovering asteroids in a space route in Factoriopedia with a controller didn't highlight the relevant line in the graph.
    - Fixed lamps with 'always_on' set in the prototype would still show the checkbox in the lamp GUI. (https://forums.factorio.com/126104)
    - Fixed train stop GUI recentering when trains count goes to 0. (https://forums.factorio.com/125861)
    - Fixed surface list not updating platform position icons when passing a space location without stopping. (https://forums.factorio.com/123977)
    - Fixed assembling machine recipe tooltip not showing ingredients with quality. (https://forums.factorio.com/125089)
    - Fixed edit pin GUI clipping out of the screen at large GUI scales. (https://forums.factorio.com/118040)
    - Fixed mod info panes retaining scroll distance between selection. (https://forums.factorio.com/108172)
    - Fixed map generator GUI scrollpane clipping the resource richness sliders. (https://forums.factorio.com/116539)
    - Fixed spidertron preview zooming in and out in the spidertron UI while walking. (https://forums.factorio.com/125602)
    - Fixed that the cheat mode crafting GUI didn't show quality options at all times. (https://forums.factorio.com/126049)
    - Fixed that CLI arguments would not be preserved when restarting due to a mod load error. (https://forums.factorio.com/109458)
    - Fixed tight spot script crashing when in remote controller. (https://forums.factorio.com/126242)
    - Fixed LuaSimulation API crashing the game when used incorrectly. (https://forums.factorio.com/125402)
    - Fixed that space locations marked as hidden were visible in space platform schedule and platform creation GUI. (https://forums.factorio.com/125418)
    - Fixed that the game would close if a filename-related error was raised in the save game dialog with async saving enabled. (https://forums.factorio.com/114794)
    - Fixed that quitting from the server console while an async save was running would deadlock the server. (https://forums.factorio.com/102240)
    - Fixed that clicking "yes" in the crash dialog would not correctly terminate the Factorio process on Linux. (https://forums.factorio.com/117480)
    - Fixed that roboports marked for deconstruction still wanted to fulfill robot requests. (https://forums.factorio.com/121024)
    - Fixed that attacking biter bases directly or with artillery could award the "It stinks and they don't like it" achievement. (https://forums.factorio.com/121625)
    - Fixed that attacking pentapod bases directly or with artillery could award the "It stinks and they do like it" achievement. (https://forums.factorio.com/121625)
    - Fixed spitters could get stuck attacking trees and rocks blocking their path without dealing any damage to them. (https://forums.factorio.com/126283)
    - Fixed that module replacement logic on space platforms didn't keep the old module if the new module wasn't available. (https://forums.factorio.com/124042)
    - Fixed an issue with asteroid collectors reading content when qualities have level changed. (https://forums.factorio.com/126282)
    - Fixed that rocket turrets and railgun turrets had the wrong fast-replace groups. (https://forums.factorio.com/125205)
    - Fixed that players in cargo pods would activate gates. (https://forums.factorio.com/126329)
    - Fixed util.combine_icons calculated scale from icon_size incorrectly. (https://forums.factorio.com/119797)
    - Fixed that flying text was shown on all surfaces in some cases. (https://forums.factorio.com/118096)
    - Fixed 'speed' parameter of LuaPlayer::create_local_flying_text() not behaving as documented. (https://forums.factorio.com/118866)
    - Fixed quality of held tile item not being visible when showing placement preview. (https://forums.factorio.com/121665)
    - Fixed that technology GUI allowed opening console in multiplayer. (https://forums.factorio.com/119709)
    - Removed several unused sprites. (https://forums.factorio.com/123454)
    - Fixed that prototype defined lamp colors didn't work. (https://forums.factorio.com/124548)
    - Fixed that hidden surface properties would still show in tooltips. (https://forums.factorio.com/117432)
  Modding:
    - Renamed WorkingSound::max_sounds_per_type to WorkingSound::max_sounds_per_prototype. The limit is now applied per prototype.
    - Removed WorkingSound::apparent_volume.
    - Removed WorkingSound::audible_distance_modifier, MainSound::audible_distance_modifier and SoundAccent::audible_distance_modifier. Sound::audible_distance_modifier is used instead.
    - Removed PlaySoundTriggerEffectItem::volume_modifier and PlaySoundTriggerEffectItem::audible_distance_modifier.
  Scripting:
    - Added LuaEntityPrototype::get_pumping_speed. LuaEntityPrototype::pumping_speed is deprecated and should not be used.
    - Added optional 'surface' parameter to LuaPlayer::create_local_flying_text().
---------------------------------------------------------------------------------------------------
Version: 2.0.32
Date: 20. 01. 2025
  Optimizations:
    - Improved performance when removing roboports in large active networks by 60%. (https://forums.factorio.com/126004)
  Graphics:
    - Removed reflections from lava. Tile transitions to lava now use the foam channel instead to keep their appearance. (https://forums.factorio.com/125097)
  Bugfixes:
    - Fixed rocket silo GUI not fitting on small screens. (https://forums.factorio.com/119785)
    - Fixed a crash when writing LuaItem::entity_filters. (https://forums.factorio.com/126017)
    - Fixed that blueprint preview rendering did not work correctly. (https://forums.factorio.com/103953)
    - Fixed a crash with positional GuiEffect sounds with aggregation when dedicated UI sound resources were exhausted. (https://forums.factorio.com/126057)
    - Fixed upgraded blueprint entities would have their flip reverted (https://forums.factorio.com/124584)
    - Fixed worm shooting at fast moving target sometimes created multiple acid puddles with single spit and even outside of its range. (https://forums.factorio.com/77071)
    - Fixed that labs could try to research trigger based technologies. (https://forums.factorio.com/120370)
    - Fixed LuaEntity::get_logistic_sections was not always working with entity ghosts. (https://forums.factorio.com/126097)
    - Fixed selector combinator was using wrong open and close sounds. (https://forums.factorio.com/123464)
    - Fixed remote item requests leaving a visual deconstruction/ghost mark when inserters interacted with the slot. (https://forums.factorio.com/121577)
    - Fixed issue related to rendering items on belts when a belt was also rendered through a camera widget. (https://forums.factorio.com/124058)
    - Fixed that assembler input slots could exceed stack limits. (https://forums.factorio.com/116644)
    - Fixed a crash in assembling machine GUI when the output was full and a recipe containing a research progress product was being crafted. (https://forums.factorio.com/126094)
    - Fixed shooting actions missing vibrations when playing with a controller.
  Scripting:
    - Added connection_category to LuaFluidboxPrototype::pipe_connections.
  Modding:
    - Added FluidStream::target_initial_position_only. It's used by worm acid spit.
---------------------------------------------------------------------------------------------------
Version: 2.0.31
Date: 16. 01. 2025
  Changes:
    - Disabled achievements "It stinks and they don't like it", "It stinks and they do like it", and "Get off my lawn" in peaceful mode and no enemies mode. (https://forums.factorio.com/125581)
    - Adding more effect info to yumako, mash, jellynut, jelly, bioflux and slowdown capsule tooltips.
  Bugfixes:
    - Fixed mouse cursor showing up when exiting Steam Big Picture in controller input method. (https://forums.factorio.com/115242)
    - Fixed belts under elevated rails were not being removed when building a pair of undergrounds. (https://forums.factorio.com/125789)
    - Fixed that inserters could grab items from belts that crafting machines no longer wanted. (https://forums.factorio.com/125825)
    - Fixed taking screenshot could crash in some cases. (https://forums.factorio.com/125845)
    - Fixed that select list background drawing was incorrect for the first row. (https://forums.factorio.com/125864)
    - Fixed that inventory rendering did not work correctly if part of it was off the left or right side of the screen. (https://forums.factorio.com/125902)
    - Fixed that reset technology effects would clear in-progress research triggers. (https://forums.factorio.com/125790)
    - Fixed that writing "nil" to storage_filter did not work correctly. (https://forums.factorio.com/125856)
    - Fixed that UI sounds would not play when dedicated UI sound resources were exhausted. (https://forums.factorio.com/125831)
    - Fixed display panel text and player names were not covered by onboard rocket/cargo pod flight cutscene. (https://forums.factorio.com/120496)
    - Fixed that upgrading pairs of underground belts could transform one end of the belt. (https://forums.factorio.com/125896)
    - Fixed visualisation of asteroid collector range sometimes being drawn wrong. (https://forums.factorio.com/122048)
    - Fixed upgrading a blueprint could fail to upgrade preview icons if the upgrade only changed quality. (https://forums.factorio.com/125484)
    - Fixed clicking space connections in factoriopedia would not update selected items. (https://forums.factorio.com/125394)
    - Fixed that on_equipment_removed did not fire for robots removing equipment. (https://forums.factorio.com/125919)
    - Fixed that some hidden items would show in Factoriopedia. (https://forums.factorio.com/124957)
    - Fixed that Sound::audible_distance_modifier and SoundPrototype::audible_distance_modifier would be effectively applied twice.
    - Fixed pentapod eggs default import surface. (https://forums.factorio.com/125355)
    - Fixed that loading old save files created from a freeplay custom scenario would not load because of outdated scripts. (https://forums.factorio.com/119410)
    - Fixed trunk of a specific tree flickered when moving while zoomed out. (https://forums.factorio.com/125036)
    - Fixed "Open character logistics/info/crafting" hotkeys sometimes not closing the character gui. (https://forums.factorio.com/118493)
    - Fixed a desync related to cliffs and deleting multiple chunks in the same tick. (https://forums.factorio.com/125941)
    - Don't auto-focus blueprint parameter fields when using a controller. (https://forums.factorio.com/123006)
    - Fixed a crash when interacting with GUIs while auto-save runs. (https://forums.factorio.com/125930)
    - Fixed that the steam 'low steam remote storage' warning would show even if all steam remote storage options were disabled. (https://forums.factorio.com/125958)
    - Fixed that player.render_mode didn't report chart_zoomed_in for the remote controller. (https://forums.factorio.com/125942)
    - Fixed crash when clicking a shortcut rich text link in controller input method.
    - Fixed BP of storage chest with filters would be incorectly overbuilt over non-storage logistic chests (https://forums.factorio.com/124387)
    - Fixed quality icon being shown twice in in-world icons for blacklist quality filter (without entity)
    - Fixed a crash when building entities with linked pipe connections in multiplayer latency. (https://forums.factorio.com/123266)
    - Fixed that manually launching items to space platforms would wrongly say some combination of items wouldn't fit. (https://forums.factorio.com/125713)
    - Fixed that map rendering would wrongly show your player as on the map when paused. (https://forums.factorio.com/124338)
    - Fixed that going back in browse history didn't return to player location if the character was in space platform hub.
    - Fixed an audible click at certain zoom levels when playing positional sounds with custom zoom attenuation and aggregation.
    - Fixed offshore pump underwater patch was not rendered under water.
    - Fixed issue where plants were not being destroyed when (super)force building entities that autofill tiles that collide with them (https://forums.factorio.com/122632)
    - Fixed loading of scenarios when entities were configured with difficulty settings. (https://forums.factorio.com/125927)
    - Fixed biters and pentapods getting frozen mid-attack. (https://forums.factorio.com/118055)
    - Fixed infinity container parametrization could set empty filters causing crash on saving.
  Scripting:
    - ItemPrototype::spoil_result and spoil_to_trigger_result can now be used at the same time.
---------------------------------------------------------------------------------------------------
Version: 2.0.30
Date: 10. 01. 2025
  Changes:
    - Changed map generated lightning attractors to always produce full-health items when mined. (https://forums.factorio.com/125629)
    - Reordered results of scrap recycling to make the recycler stack them on belts more efficiently. (https://mods.factorio.com/mod/better-scrap-stacking) (https://forums.factorio.com/125706)
    - Agricultural Tower now clears preexisting trees from its entire range, not just around planting spots. (https://forums.factorio.com/125189)
  Bugfixes:
    - Fixed that item request proxies would show bad "missing materials for construction" counts. (https://forums.factorio.com/124613)
    - Fixed a crash when creating a ghost assembling machine with a pre-set recipe through script. (https://forums.factorio.com/125634)
    - Fixed a multiplayer latency related crash when deleting surfaces. (https://forums.factorio.com/125574)
    - Fixed crash due to division by zero when line_length of sheet definition of SpriteVariations was 0. (https://forums.factorio.com/125493)
    - Fixed quality filter comparators did not dim at night. (https://forums.factorio.com/125109)
    - Fixed ammo turrets with target leading would undershoot ammo with range modifier. (https://forums.factorio.com/124963)
    - Fixed opening a train stop on another surface from a tag would show the wrong trains. (https://forums.factorio.com/125253)
    - Fixed only pings from last message in a given tick were being recognized. (https://forums.factorio.com/125672)
    - Fixed circuit condition signal selection title was "Set the filter" instead of "Select a signal". (https://forums.factorio.com/124589)
    - Fixed asteroid collector could fail to grab some chunks if there were no other chunks nearby. (https://forums.factorio.com/124971)
    - Fixed a crash when interacting with ghost assembling machines after migrating recipes. (https://forums.factorio.com/125669)
    - Fixed crash when using the same sprite as both decal and decorative. (https://forums.factorio.com/125106)
    - Fixed that cycling quality did not work while the mouse was over scrollable widgets. (https://forums.factorio.com/121609)
    - Fixed that logistic groups could get broken when mining and un-doing ghost logistic containers. (https://forums.factorio.com/124026)
    - Fixed long custom ending text would not fit in the victory screen. (https://forums.factorio.com/123818)
    - Fixed that hidden surfaces would show in the evolution command. (https://forums.factorio.com/124561)
    - Fixed a crash when hovering some widgets at very small resolutions. (https://forums.factorio.com/125734)
    - Fixed that orbital request weight tooltips wouldn't show any decimal values. (https://forums.factorio.com/119405)
    - Fixed a crash when quitting abnormally in multiplayer while the menu was visible. (https://forums.factorio.com/124954)
    - Fixed that labs would consume power for one tick when not working. (https://forums.factorio.com/125737)
    - Fixed that the mods GUI did not fit on small screens such as the Steam Deck. (https://forums.factorio.com/118372)
    - Fixed crash when frame count of animation layer definition using stripes didn't match frame count of previous layer. (https://forums.factorio.com/125728)
    - Fixed hovering cursor over undo button could change rail planner start location. (https://forums.factorio.com/125739)
    - Fixed missing Ў character in the game font. (https://forums.factorio.com/119359)
    - Fixed yet another issue with flow statistics. (https://forums.factorio.com/125742)
    - Fixed script rendering objects targeting an entity didn't draw at render position of the entity. (https://forums.factorio.com/125393)
    - Fixed issue of incorrect undo of deconstruction of multiple tile ghost with common dependent entity ghost (https://forums.factorio.com/123389)
    - Fixed macOS Game Mode not activating for the non-Steam version of the game.
    - Fixed that items would end up in crafing machine trash slots when it wasn't desired. (https://forums.factorio.com/125212)
  Scripting:
    - Added LuaEntity::inserter_spoil_priority read/write.
---------------------------------------------------------------------------------------------------
Version: 2.0.29
Date: 06. 01. 2025
  Minor Features:
    - Added smart pipette for items on the ground.
  Graphics:
    - Improved graphics of Recyclers.
    - Added corpse graphics for Asteroid Collectors.
  Bugfixes:
    - Fixed a crash when mods define heat pipes with heating_radius of 0.
    - Fixed that deleting a surface with global electric network would leak an electric network. (https://forums.factorio.com/124953)
    - Fixed blueprint could be configured with invalid set of grid size and absolute grid position. (https://forums.factorio.com/124937)
    - Fixed that the space map would not show when unlocking space-locations. (https://forums.factorio.com/124314)
    - Fixed map artifacts on space platforms when removing in-progress builds. (https://forums.factorio.com/118405)
    - Fixed that frozen radars still worked. (https://forums.factorio.com/125006)
    - Fixed that instant blueprint over-building would not auto fulfill item requests. (https://forums.factorio.com/124805)
    - Fixed that marking a space platform to be deleted while a starter pack is on the way would break the platform state. (https://forums.factorio.com/124249)
    - Fixed statistics would not include values from a newest sample that is still being created. (https://forums.factorio.com/125025)
    - Fixed an issue with memory management in some cases when rotating entities. (https://forums.factorio.com/125108)
    - Fixed a crash related to modded triggers on spider legs. (https://forums.factorio.com/125102)
    - Fixed that hidden mining drills would still show in "mined by" in resource tooltips. (https://forums.factorio.com/125126)
    - Fixed that the artillery wagon auto-targeting checkbox was not shown when the artillery had an equipment grid. (https://forums.factorio.com/121511)
    - Fixed LuaTransportLine::get_line_item_position would return incorrect positions. (https://forums.factorio.com/125232)
    - Fixed that writing to LuaPlayer::opened did not update the GUI in multiplayer. (https://forums.factorio.com/121678)
    - Fixed pumps were setting filter when given negative fluid signals. (https://forums.factorio.com/124825)
    - Fixed a crash related to merging forces and gui. (https://forums.factorio.com/125317)
    - Fixed trains could switch to manual when due to interrupts the schedule became empty. (https://forums.factorio.com/119054)
    - Fixed math expressions were not accepting numbers with positive exponent and + sign. (https://forums.factorio.com/125225)
    - Fixed a desync related to worker robots charging when force has worker robot battery bonus set.
    - Fixed a crash when installing mods with almost-cyclic dependencies. (https://forums.factorio.com/125281)
    - Fixed that changing surface::localised_name did not update the surfaces list in remote view. (https://forums.factorio.com/121352)
    - Fixed that quality could add a supply area to an electric pole without one. (https://forums.factorio.com/124841)
    - Fixed that the LAN games browser would not show anything if the public-games filter was set to only show favorites. (https://forums.factorio.com/124594)
    - Fixed a crash related to cargo pods when loading older save files. (https://forums.factorio.com/124932)
    - Fixed bad rendering logic for space platform trash slots. (https://forums.factorio.com/124916)
    - Fixed that flying robots did not render quality indicators correctly. (https://forums.factorio.com/122584)
    - Fixed arithmetic combinator gui not refreshing circuit network selection when combinator parameters are changed externally. (https://forums.factorio.com/124115)
    - Fixed solar panels bonus description didn't display correctly. (https://forums.factorio.com/123191)
    - Fixed copy source was cleared when source entity was built from ghost or destroyed leaving ghost. (https://forums.factorio.com/124328)
    - Fixed that tesla turret chain bolts could damage protected biter spawners. (https://forums.factorio.com/121679)
    - Fixed that some actions would still be processed while the game was paused. (https://forums.factorio.com/123309)
    - Fixed a latency armor related crash. (https://forums.factorio.com/125422)
    - Fixed that some remote view GUI elements did not align correctly. (https://forums.factorio.com/118564)
    - Fixed that Factoriopedia would claim some recipes as exclusive to a given planet/location when they weren't. (https://forums.factorio.com/125424)
    - Fixed that the blueprint GUI didn't render vehicles correctly. (https://forums.factorio.com/125454)
    - Fixed that you could launch yourself to a platform in flight. (https://forums.factorio.com/124935)
    - Fixed that changing loader direction through script could cause transport lines to become inconsistent. (https://forums.factorio.com/125377)
    - Fixed that plants would show the wrong expected amount in deconstruction planner totals. (https://forums.factorio.com/125509)
    - Fixed that map pipeline rendering would show other forces pipes. (https://forums.factorio.com/124720)
    - Fixed that pipette over tiles would always override other actions bound to the same hotkey. (https://forums.factorio.com/124692)
    - Fixed that vehicles would get stuck as 'reserved by remote driver' if they died while being remote driven. (https://forums.factorio.com/125429)
    - Fixed inserters would keep using filters after migration when new prototypes disallowed usage of filters. (https://forums.factorio.com/125591)
  Scripting:
    - Added LuaRecord::get_active_index.
    - Added LuaEntityPrototype::science_pack_drain_rate_percent read.
    - Added LuaEntityPrototype::get_fluid_usage_per_tick. LuaEntityPrototype::fluid_usage_per_tick is deprecated and should not be used.
    - Added LuaEntityPrototype::get_max_power_output. LuaEntityPrototype::max_power_output is deprecated and should not be used.
    - LuaEntity::combinator_description supports ghosts of combinators.
    - Added LuaDefines::car_trash read. (https://forums.factorio.com/124950)
    - Added asteroid collector support to LuaEntity::get_filter, set_filter, and filter_slot_count.
    - Added LuaPlayer::clear_recipe_notification().
    - Changed LuaEntity::get_passenger() to give the character in cargo pods. (https://forums.factorio.com/121766)
    - Added LuaControl::hub read.
    - Changed LuaEntity::cargo_pod read into LuaControl::cargo_pod read and made it work for players in cargo pods.
    - Changed LuaEntity::get_logistic_point() and LuaEntity::get_logistic_sections() to work with ghosts.
  Modding:
    - Added CargoWagonPrototype::quality_affects_inventory_size.
    - Added FluidWagonPrototype::quality_affects_capacity.
---------------------------------------------------------------------------------------------------
Version: 2.0.28
Date: 20. 12. 2024
  Optimizations:
    - Improved GUI performance when logistics status diode is part of the structure. (https://forums.factorio.com/124660)
  Bugfixes:
    - Fixed a crash when units spawned by an enemy spawner are destroyed by script during created effect.
---------------------------------------------------------------------------------------------------
Version: 2.0.27
Date: 18. 12. 2024
  Changes:
    - Wrigglers will no longer proactively attack pollen emitters. However, they will still respond to artillery.
    - Attack groups containing stompers or strafers will now contain fewer units.
    - Large egg rafts will try to have at least one stomper or strafer spawned at a time.
    - Small egg rafts no longer absorb pollution because they will never produce stompers or strafers.
    - Gleba water cane no longer blocks landfill or foundation.
    - Added detailed description to Factoriopedia for Blueprint, Blueprint book, Deconstruction item and Upgrade item. (https://forums.factorio.com/119322)
  Graphics:
    - Aquilo icebergs have longer shadows to integrate with the world better.
  Bugfixes:
    - Fixed that the asteroid collectors circuit condition referred to inserters. (https://forums.factorio.com/118721)
    - Fixed that hidden planets still showed in the map preview GUI. (https://forums.factorio.com/124471)
    - Fixed a crash when loading new modded tips and tricks with a "dependencies met" trigger but no dependencies.
    - Fixed a crash when interacting with modded equipment ghosts. (https://forums.factorio.com/123973)
    - Fixed that a robot wouldn't play a tile mined_sound when deconstructing it.
    - Fixed that a robot would play a deconstruct sound regardless of whether the deconstruction succeeded or not. (https://forums.factorio.com/124188)
    - Fixed a consistency issue related to loading script rendered animations when animation is no longer available. (https://forums.factorio.com/124044)
    - Fixed a desync related to asteroid collectors and distant chunks optimization when asteroid collector is destroyed. (https://forums.factorio.com/124608)
    - Fixed a crash when opening an audio stream encounters a filesystem error. (https://forums.factorio.com/124578)
    - Fixed a performance issue when exiting the game while large modded entities exist. (https://forums.factorio.com/121313)
    - Fixed that the personal logistics area would render incorrectly when the game was paused. (https://forums.factorio.com/123438)
    - Fixed that quality science packs would show "100%" remaining. (https://forums.factorio.com/123076)
    - Fixed that the open-factoriopedia hotkey did not work in some cases. (https://forums.factorio.com/121411)
    - Fixed that fog of war was not rendered while dead. (https://forums.factorio.com/124251)
    - Fixed that opening the technology GUI while dragging the map would continue to drag the map. (https://forums.factorio.com/117950)
    - Fixed a crash when deleting a space platform which had cargo bays built in a specific order. (https://forums.factorio.com/124433)
  Modding:
    - TipsAndTricksItem requires at least one dependency if it has a `dependencies-met` trigger.
    - Added UnitAISettings::size_in_group and UnitAISettings::join_attacks.
    - Added LuaAISettings::size_in_group and LuaAISettings::join_attacks.
    - Added EnemySpawnerPrototype::max_count_of_owned_defensive_units and EnemySpawnerPrototype::max_defensive_friends_around_to_spawn.
    - Added LuaEntityPrototype::max_count_of_owned_defensive_units and LuaEntityPrototype::max_defensive_friends_around_to_spawn.
  Scripting:
    - Added LuaSurface::ignore_surface_conditions.
---------------------------------------------------------------------------------------------------
Version: 2.0.26
Date: 16. 12. 2024
  Minor Features:
    - Re-added the sandbox scenario questionnaire.
  Changes:
    - Space age mods no longer count as "has mods" in the server browser. (https://forums.factorio.com/117812)
    - Removed default secondary keybinding for redo action on AZERTY keyboards as it collided with super force building while moving up. (https://forums.factorio.com/124377)
  Optimizations:
    - Improved asteroid collector performance - we estimate it should be 5x - 15x faster when there are thousands of asteroid chunks on the map. (https://forums.factorio.com/118736)
    - Improved asteroid update performance by up to 20%.
  Bugfixes:
    - Fixed a crash at startup when mods would define fluid with no fuel value as a fluid energy source fuel. (https://forums.factorio.com/124177)
    - Fixed that LuaPlayer::opened did not work with equipment grids. (https://forums.factorio.com/123922)
    - [space-age] Fixed some asteroid graphic variations were defined twice. (https://forums.factorio.com/123453)
    - Fixed that it was possible to click the update selected mods button while update data was being fetched. (https://forums.factorio.com/124094)
    - Fixed several edge cases where the mod explore results table selection would get out of sync with the mod info pane. (https://forums.factorio.com/123992)
    - Changed graphics setting turret-overdraw-scale-threshold to turret-overdraw-estimated-pixel-overdraw-threshold to fix artillery range overdraw performance. (https://forums.factorio.com/123380)
    - [space-age] Fixed fulgorite pieces icon had empty mipmaps. (https://forums.factorio.com/121347)
    - Fixed that rocket silos would not launch quickly when there were platform requests that couldn't be satisfied. (https://forums.factorio.com/122321)
    - Fixed a crash when building terrain in remote view. (https://forums.factorio.com/124420)
    - Fixed that layered quality icons did not work correctly in recipe overlays. (https://forums.factorio.com/122184)
    - Fixed that "hidden in factoriopedia" technologies still showed in Factoriopedia. (https://forums.factorio.com/123695)
    - Fixed a crash when mods set ItemRequestProxy::active to false. (https://forums.factorio.com/124022)
    - Fixed incorrect space platform bounds and weight when space platform foundations were covered by other tiles.
    - Fixed a crash when mining closed power switch. (https://forums.factorio.com/124455)
    - Fixed a performance issue when rendering radar minimap visualization. (https://forums.factorio.com/124400)
    - Fixed a crash when clicking give-item technology modifiers in the technology GUI. (https://forums.factorio.com/124525)
    - Fixed a crash when a recipe has a research-progress result. (https://forums.factorio.com/124509)
  Scripting:
    - Added LuaEntity::minable_flag read/write. Write to LuaEntity::minable is now deprecated.
    - Added LuaEntity::is_updatable read, disabled_by_script read/write, disabled_by_control_behavior read and disabled_by_recipe read.
    - Added LuaEntity::is_freezable read and frozen read.
---------------------------------------------------------------------------------------------------
Version: 2.0.25
Date: 12. 12. 2024
  Minor Features:
    - Dragging and dropping a blueprint file into the game window will import the file contents as a blueprint string.
    - Dragging and dropping text into the game window on X11 will import the text as a blueprint string.
    - Factoriopedia now shows recycling recipes for each item.
    - Cargo pod scheduling reworked to send larger and more spaced out deliveries. This should improve the frequency of trickling space science and material drops.
  Changes:
    - Inserters (especially ghost long handed ones) spawn in stretched to an appropriate distance.
    - Reverted fix for god controller being able to zoom out to map view. (https://forums.factorio.com/123675)
    - Changed selector combinator circuit wire reach to be the same as wire reach of other combinators.
  Graphics:
    - Asteroid collector tentacles have less colourful rainbow effect on them.
  Bugfixes:
    - [space-age] Fixed that victory condition didn't trigger when the platform was paused or didn't stop at solar system edge. (https://forums.factorio.com/122446)
    - Fixed a crash when copying logistic filters into blueprints. (https://forums.factorio.com/123606)
    - Fixed that Factoriopedia would close if a GUI behind it was changed. (https://forums.factorio.com/117404)
    - Fixed a crash when fast-replacing the platform hub. (https://forums.factorio.com/123802)
    - Fixed that the mod manager would not account for mods hidden by search when browsing dependencies. (https://forums.factorio.com/119498)
    - Fixed a crash on Mac when driving a car in multiplayer when the player has no character. (https://forums.factorio.com/123682)
    - Fixed a crash when drawing EntityButtons with entities with inverted selection boxes. (https://forums.factorio.com/121455)
    - Fixed that pumps would run endlessly if the input fluid was incompatible. (https://forums.factorio.com/120461)
    - Fixed station list could be sometimes sorted incorrectly. (https://forums.factorio.com/123125)
    - Fixed trashing logic would not run after cancelling deconstruction of entity. (https://forums.factorio.com/123596)
    - Fixed reverting technologies with recipe unlocks would lock recipe that is still unlocked by other technology. (https://forums.factorio.com/122723)
    - Fixed railgun turret would not draw out of power when ammo was inserted. (https://forums.factorio.com/122329)
    - Fixed that logistic network content tooltips didn't show nice numbers. (https://forums.factorio.com/123982)
    - Fixed blueprint export to string would create malformed blueprint if it contained decider combinator with empty conditions or empty output. (https://forums.factorio.com/122190)
    - Fixed consistency issue when power switch was destroyed leaving a ghost. (https://forums.factorio.com/122282)
    - Fixed inserters could in some cases interact with elevated cargo wagons. (https://forums.factorio.com/123544)
    - Fixed mods could specify an assembling machine with fixed quality without specifying fixed recipe. (https://forums.factorio.com/123072)
    - Fixed research was not correctly counted in total item production statistics. (https://forums.factorio.com/121799)
    - Fixed rocket silo control behavior would not update outputs when connecting wire. (https://forums.factorio.com/122053)
    - Fixed that fast-replacing crafting machines would not preserve the mirrored orientation of the original machine. (https://forums.factorio.com/122481)
    - Fixed that burner inserters would load too much fuel when fed by inserters. (https://forums.factorio.com/123927)
    - Fixed nuclear power achievement could be obtained without burning uranium fuel cell if it was consumed for crafting. (https://forums.factorio.com/122753)
    - Fixed that clicking the sort buttons in the save-map GUI would reset the save name field. (https://forums.factorio.com/123926)
    - Fixed demolisher in vulcanus crossing menu simulations would sometimes render health bar. (https://forums.factorio.com/121990)
    - Fixed a crash when opening the console while a platform tooltip was shown. (https://forums.factorio.com/124061)
    - Fixed that the cursor theme was not being respected when running on GNOME Wayland. (https://forums.factorio.com/113202)
    - Fixed loader was able to insert items into asteroid collector. (https://forums.factorio.com/124025)
    - Fixed flamethrower turret sound still playing after being deactivated or destroyed with its ghost created. (https://forums.factorio.com/124142)
    - Fixed cars and tanks would keep their speed through a ghost when dying. (https://forums.factorio.com/124122)
    - Fixed fluid parameters were not showing when selecting fluids for wait condition. (https://forums.factorio.com/123748)
    - Fixed gleba tree sprites still had blue line at their upper edge under some conditions. (https://forums.factorio.com/119943)
    - Fixed deconstruction planner would not mark rails for deconstruction if they were dependency of a rail support that was instantly removed. (https://forums.factorio.com/123751)
    - Fixed cargo pods with passenger would select landing spots using incorrect bounding box. (https://forums.factorio.com/123754)
    - Fixed blueprint parametrization would allow selecting hidden recipe that can be crafted. (https://forums.factorio.com/123759)
    - Fixed that writing invalid font names to custom GUI elements would crash the game to desktop. (https://forums.factorio.com/124162)
    - Fixed cryogenic science pack recipe was incorrectly considering entire fluoroketone input as a catalyst. (https://forums.factorio.com/123797)
    - Fixed fish breeding recipe was applying productivity to catalyst. (https://forums.factorio.com/123819)
    - Fixed a crash when trying to set infinity chest filter with non zero count but empty name. (https://forums.factorio.com/123824)
    - Fixed a crash when super force building blueprint with belts and external wires in latency. (https://forums.factorio.com/122211)
    - Fixed 'import from' option changing when setting requested item quality on platforms. (https://forums.factorio.com/120354)
    - Fixed that assemblers without fluid boxes were incorrectly considered rotatable. (https://forums.factorio.com/123966)
    - Fixed burner energy source would not report out of fuel when incompatible items were in the fuel inventory. (https://forums.factorio.com/124016)
    - Fixed that some damage tooltips were incorrect. (https://forums.factorio.com/124208)
    - Fixed that any tag being changed would refresh any active tag-edit GUI. (https://forums.factorio.com/124220)
    - Fixed many smaller GUIs still not supporting non-English search (https://forums.factorio.com/123923)
    - Fixed a desync related to cargo landing pads trash inventory when playing without Space Age.
    - Fixed a crash when mods use fixed recipes with surface conditions in machines that don't have surface conditions. (https://forums.factorio.com/124224)
    - Fixed copying display panel would copy icon and text regardless of control behavior being active. (https://forums.factorio.com/123007)
    - Fixed nuclear reactor was heating tiles farther than it would heat entities. (https://forums.factorio.com/122005)
    - Fixed asteroid background rendering black lines when graphics driver forces anisotropic filtering. (https://forums.factorio.com/116707)
    - Fixed that "auto requests for space platforms" was not preserved in blueprint strings. (https://forums.factorio.com/124121)
    - Fixed that changing "send to orbit automatically" on rocket silos did not work when in ghost form. (https://forums.factorio.com/123700)
    - Fixed electric network statistics could show total value that was larger than expected caused by counting incomplete next sample. (https://forums.factorio.com/120351)
    - Fixed that importing save files in the map editor would crash the game. (https://forums.factorio.com/123402)
    - Fixed current research tooltip would show incorrect progress values. (https://forums.factorio.com/124133)
  Modding:
    - UTF-8 encoding is now checked for all mod text files to ensure proper rendering. Mods with ANSI encoded text files will not load anymore. (Prompted by https://forums.factorio.com/120452)
    - Added InserterPrototype::starting_distance.
    - Added minimum collision box restriction to cargo bays, cargo landing pads and space platform hubs. (https://forums.factorio.com/124079)
    - Burner inserter initial energy amount was changed to be defined on the burner energy source prototype.
    - Changed UseEntityInEnergyProductionAchievementPrototype::consumed_condition into ItemIDFilter.
    - ItemProductPrototype and FluidProductPrototype ignored_by_productivity defaults to value of ignored_by_stats.
    - Added heating_radius to ReactorPrototype and HeatPipePrototype.
  Scripting:
    - Added LuaBurnerPrototype::initial_fuel and initial_fuel_percent read.
    - Added LuaSpacePlatform::last_visited_space_location read.
    - Added LuaSpacePlatform::paused read/write.
---------------------------------------------------------------------------------------------------
Version: 2.0.24
Date: 05. 12. 2024
  Minor Features:
    - [space-age] Added "Nauvis Bus" and "Nauvis Power Up" menu simulations.
    - [space-age] Added camera views to Space platform tooltips.
    - Added radar minimap visualization for roboports and cargo landing pads. (https://forums.factorio.com/117994)
  Graphics:
    - [space-age] Changed the Space crafting category icon to look like a cargo pod instead of rocket silo.
    - Changed the Rocket part icon to look more like a part of the rocket.
  Balancing:
    - [space-age] Land mines on space platforms now damage the space platform tiles in a radius.
    - [space-age] Changed rocket fuel from ammonia recipe to require the same amount of solid fuel as the main rocket fuel recipes to prevent a recycling loop. (https://forums.factorio.com/122574)
  Changes:
    - Tweaked how entities are selected in remote view when using a gamepad. The entity directly under the crosshair is much more likely to be selected.
  Bugfixes:
    - Fixed a desync related to building rails with rail planner in latency. (https://forums.factorio.com/123181)
    - Fixed a crash when opening a planet with empty cliff generation settings in Factoriopedia. (https://forums.factorio.com/121735)
    - Fixed a crash when the last roboport is disconnected while searching in Logistic networks GUI. (https://forums.factorio.com/121692)
    - Fixed that items could be inserted into rocket inventory while the silo was in "automatic requests" mode. (https://forums.factorio.com/118442, https://forums.factorio.com/123172)
    - Fixed that downgrading an entity ghost didn't remove invalid item insertion requests. (https://forums.factorio.com/118959)
    - Fixed that robots could enter roboports marked for deconstruction. (https://forums.factorio.com/120107)
    - Fixed pipes and pipe shadow graphics on flipped biochamber. (https://forums.factorio.com/117390)
    - Fixed recycler showing greater than 300% productivity in the tooltip. (https://forums.factorio.com/122619)
    - Fixed crash when rendering thruster with ThrusterPrototype::plumes set to nil. (https://forums.factorio.com/123284)
    - Fixed that higher quality pumpjacks would produce less oil. (https://forums.factorio.com/123234)
    - Fixed that ghost building electric poles did not always space them correctly. (https://forums.factorio.com/122831)
    - Fixed rocket turrets not shooting spawners with capture robots. (https://forums.factorio.com/122257)
    - Fixed a crash when demolishers are killed as a direct result of attacking something. (https://forums.factorio.com/123308)
    - Fixed a crash when a robot tried to move in the same tick as it was deactivated by script. (https://forums.factorio.com/121718)
    - Fixed a crash when reordering time-based wait conditions in multiplayer. (https://forums.factorio.com/119933)
    - Fixed that a thruster deactivated by script still rendered the exhaust flames. (https://forums.factorio.com/121817)
    - Fixed that reading collision mask from LuaEntityPrototype could give incorrect collision mask when there were no layers. (https://forums.factorio.com/123332)
    - Fixed that players with open blueprint creation GUI were unable to open menu when the game was paused. (https://forums.factorio.com/120701)
    - Fixed parametrization of selector combinator would propose variables not relevant due to current mode. (https://forums.factorio.com/123321)
    - Fixed parametrization was not covering inserter, assembler and reactor signals. (https://forums.factorio.com/123416)
    - Fixed some recipes would give items of wrong quality when changing quality effect. (https://forums.factorio.com/122685)
    - Fixed a dying turret could be disabled by control behavior causing it not able to finish dead animation. (https://forums.factorio.com/123501)
    - Fixed a rare crash in CargoPod code when loading a Space Age save file with Space Age disabled. (https://forums.factorio.com/122504)
    - Fixed that LuaSurface::force_generate_chunk_requests() would not force all chunks correctly if generate_with_lab_tiles was true. (https://forums.factorio.com/123535)
    - Fixed a desync when changing force friends/ceasefire. (https://forums.factorio.com/121499)
    - Fixed that railguns could get stuck switching targets and not fire. (https://forums.factorio.com/123146)
    - Fixed trying to parametrize inserter stack size would clamp them to max stack size of neutral force. (https://forums.factorio.com/121360)
    - Fixed construction robots from the personal roboport being stuck in a loop when fulfilling delivery requests for construction robots. (https://forums.factorio.com/123638)
    - Fixed production-entity-list showing values for space age when only quality mod was enabled. (https://forums.factorio.com/122566)
    - Fixed a crash when mods cancel deconstruction of a rolling stock while it's being marked for deconstruction. (https://forums.factorio.com/123296)
    - Fixed that stack inserters could deadlock in some cases. (https://forums.factorio.com/118138)
    - Fixed that disabling Space Age mod removed Space Age achievements when playing a non-modded game. (https://forums.factorio.com/116020)
    - Fixed shortcut bar GUI clipping off screen in remote view. (https://forums.factorio.com/123143)
    - Fixed that Gleba generated cliffs when they were disabled. (https://forums.factorio.com/120536)
    - Fixed rapidly changing platform schedule would make it impossible to view that platform. (https://forums.factorio.com/120886)
    - Fixed Space platform tooltip flickering for 1 tick when another platform schedule/location changes. (https://forums.factorio.com/122021)
    - Fixed Space platform position indicator not updating in some cases. (https://forums.factorio.com/120447)
    - Fixed long logistic group name pushing delete button out of view. (https://forums.factorio.com/121857)
    - Fixed rocket silo in "automatic requests" mode not trashing spoiled items. (https://forums.factorio.com/123629)
    - Fixed assemblers with parameter recipe would not flip correctly. (https://forums.factorio.com/122112)
    - Fixed building rails in some cases could attempt to build them in wrong order causing a build attempt to be performed before a required support was built. (https://forums.factorio.com/121758)
    - Fixed bonus from research of character health is now showing in factoriopedia. (https://forums.factorio.com/121607)
    - Fixed that the pump would lose its filter when fast-replaced. (https://forums.factorio.com/119256)
    - Fixed setting generate_map in SimulationDefinition would not allow to have map generated in simulations. (https://forums.factorio.com/122338)
    - Fixed pipette of hazard concrete tiles would not set correct build direction. (https://forums.factorio.com/123406)
    - Fixed control settings menu sometimes growing in size when interacting with it. (https://forums.factorio.com/123442)
  Modding:
    - Added support for Opus audio codec.
    - Added FluidBox::mirrored_pipe_picture and mirrored_pipe_picture_frozen.
    - Added CharacterArmorAnimation::mining_with_tool_particles_animation_positions.
    - Underground fluid box connections with incompatible underground_collision_mask are allowed to connect as long as tiles between do not collide with any of them.
  Scripting:
    - Added LuaCustomEventPrototype::event_id read.
    - Added LuaCustomInputPrototype::event_id read.
    - Added LuaBootstrap::get_event_id.
    - Unified parsing of event types into LuaEventType. Made it possible to specify custom events and custom inputs by providing prototype instance.
    - Custom events and custom inputs defined by prototypes are given constants inside of defines.events.
---------------------------------------------------------------------------------------------------
Version: 2.0.23
Date: 28. 11. 2024
  Changes:
    - Added an error message when manually trying to launch a rocket to a full space platform.
    - Changed space platforms to not delete items on the ground when deconstructing them. (https://forums.factorio.com/122383)
    - Added back a simple version of the Sandbox scenario. Improved the behavior of god controller.
  Optimizations:
    - Improved asteroid chunk creation and movement performance.
    - Improved chart overlay performance in several cases.
  Bugfixes:
    - Fixed that clicking the "delete blueprint book" button in the same tick auto-save started as a multiplayer host would crash the game. (https://forums.factorio.com/121552)
    - Fixed that the display panel would lose its settings when fast-replaced. (https://forums.factorio.com/120967)
    - Fixed that the bonus GUI did not show recyclers benefiting from belt stack size research. (https://forums.factorio.com/123002)
    - Fixed that space platforms could get stuck waiting for rockets which became frozen. (https://forums.factorio.com/122562)
    - Fixed spidertron inventory sort interfering with item pickup requests. (https://forums.factorio.com/120760)
    - Fixed problems with incorrect setting of allowTipActivationFlag. (https://forums.factorio.com/122826)
    - Fixed robots attempting to enter a roboport which had all slots reserved for robots of a different type. (https://forums.factorio.com/122854)
    - Fixed trains and logistics map views would not preserve their settings. (https://forums.factorio.com/118972)
    - Fixed the tips and tricks window on small screens.
    - Fixed on screen keyboard appearing when some tips and tricks were shown. (https://forums.factorio.com/122243)
    - Fixed renaming all trains stops wouldn't rename the stops in wait conditions or interrupts. (https://forums.factorio.com/123084)
    - Fixed that slow-moving asteroid chunks didn't collide with space platform tiles. (https://forums.factorio.com/117668)
    - Fixed a crash when the game tried to unlock Steam achievements in minimal mode.
    - Fixed a crash when trying to open tips and tricks from chat. (https://forums.factorio.com/122965)
    - Fixed that cancelling entity upgrade didn't remove invalid requests. (https://forums.factorio.com/121242)
    - Fixed choppy fog animation in saves with 300+ hours of play time. (https://forums.factorio.com/122825)
    - Fixed a consistency issue when script inserts items at the back of a stopped transport belt. (https://forums.factorio.com/123110)
    - Fixed requested robots failing to cross a gap in the network. (https://forums.factorio.com/119354)
    - Fixed that space platform included thrusters marked for deconstruction in "can produce enough thrust" calculation. (https://forums.factorio.com/123102)
    - Fixed death messages for players with no username. (https://forums.factorio.com/123164)
    - Fixed stack inserters would not drop held items if they became incompatible due to filter change.
    - Fixed Quick Panel Panels tab missing next/previous page labels. (https://forums.factorio.com/118379)
    - Fixed a crash when opening assembling machines with a fixed recipe in latency. (https://forums.factorio.com/123098)
    - [space-age] Fixed that some recipes could not be crafted by god controller. (https://forums.factorio.com/119972)
---------------------------------------------------------------------------------------------------
Version: 2.0.22
Date: 26. 11. 2024
  Minor Features:
    - Assemblers circuit allows to choose if items in crafting should be included by read contents.
    - Asteroid collector circuit allow to choose if items held by hands should be included by read contents.
  Changes:
    - Jelly is no longer mined from Slipstack trees so it is less confusing where to get jelly from.
    - Nightvision is less orange.
    - Moved the "Any quality" option into the comparison dropdown.
    - Disabled spoiling for items created in an infinity chest until the first time they are removed from said chest.
    - Removed "Select previous technology" control which didn't work (replaced with the generic back/forward navigation in 2.0). (https://forums.factorio.com/117255)
  Bugfixes:
    - Fixed that undo tooltips could show the wrong surface. (https://forums.factorio.com/122364)
    - Fixed quality selector not appearing in infinity chest GUI if qualities are not yet unlocked. (https://forums.factorio.com/122379)
    - Fixed quality selectors in unfocused windows reacting to quality cycling. Fixes quality cycling while selecting upgrade planner entity modules.
    - Fixed selector combinator using the old quality dropdown UI.
    - Fixed a desync when holding blueprints with spidertrons. (https://forums.factorio.com/121954)
    - Fixed "option" key name on macOS. (https://forums.factorio.com/109696)
    - Fixed modifier key order on macOS.
    - Fixed that reaching inventory transfer limit didn't cancel additional item requests. (https://forums.factorio.com/121746)
    - Fixed performance issue when long transport line sequence is remerging while having active belt reader. (https://forums.factorio.com/122454)
    - Fixed "So Long and Thanks for all the Fish" achievement not triggering with Space Age enabled (https://forums.factorio.com/121106)
    - Fixed robots cancelling module upgrade requests if they didn't have enough storage for the old modules. (https://forums.factorio.com/122101)
    - Fixed that upgrading a rocket silo destroyed the second rocket if it was prepared. (https://forums.factorio.com/122416)
    - Fixed drawing of quality conditions in entity/blueprint preview in GUI. (https://forums.factorio.com/117030)
    - Fixed screenshot command crash when passing zoom of 0. (https://forums.factorio.com/122591)
    - Fixed it was not possible to copy settings between artillery wagons. (https://forums.factorio.com/122595)
    - Fixed another script issue in orbital logistics tips. (https://forums.factorio.com/122042)
    - Fixed that undoing a module upgrade didn't update the GUI. (https://forums.factorio.com/119343)
    - Fixed missing technology dependencies in quality technologies when playing base+quality. (https://forums.factorio.com/122588)
    - Fixed stack inserter would start dropping partial held stack when waking up by control behavior. (https://forums.factorio.com/122439)
    - Fixed an issue with obtaining achievements after loading a save file in some cases. (https://forums.factorio.com/121934)
    - Fixed construction robots not delivering items to an entity marked for upgrade. (https://forums.factorio.com/121181)
    - Fixed rocket silos requesting more items than their inventory size. (https://forums.factorio.com/120671)
    - Fixed flamethrower sound still playing after a tank is deactivated or destroyed with its ghost created. (https://forums.factorio.com/122330)
    - Fixed a crash when interacting with ghost tanks in some scenarios. (https://forums.factorio.com/122613)
    - Fixed persistent working sounds remaining silent after fading out on pause. (https://forums.factorio.com/122809)
    - Fixed that you could exit the rocket while landing on space platforms. (https://forums.factorio.com/117064)
    - Fixed a crash when your inventory was full and robots were trying to store items in your inventory. (https://forums.factorio.com/118550)
    - Fixed that infinite item resources would not produce if the yield went below 100%. (https://forums.factorio.com/118214)
    - Fixed that the automated insertion limit tooltip for artillery turrets was incorrect. (https://forums.factorio.com/122895)
    - Fixed cargo pod didn't have transparent background when landing on Fulgora. (https://forums.factorio.com/121059)
    - Fixed some light sprites rendered incorrectly when Occlude light sprites option was disabled. (https://forums.factorio.com/122625)
    - Fixed surface list being too tall when loading into a game in remote view. (https://forums.factorio.com/122743)
    - Fixed generic interrupt logic not replacing station names in wait conditions. (https://forums.factorio.com/122519)
    - Fixed that modded custom cameras would always show fog of war. (https://forums.factorio.com/122994)
    - Fixed a crash when pinning resource patch results that had been fully mined. (https://forums.factorio.com/122985)
  Modding:
    - Corpses used by entities with health automatically use the collision box of the parent entity. (https://forums.factorio.com/118718)
    - Added LuaEntityPrototype::auto_setup_collision_box which defaults to true.
  Scripting:
    - Added LuaEntityPrototype::auto_setup_collision_box read.
    - Events::on_cargo_pod_finished_ascending Lua event added.
    - 'rocket-launched' achievement condition now triggered by cargo pod ascending instead of rocket.
    - removed property 'player_index' from Events::on_rocket_launched data.
    - Changed LuaLogisticPoint::targeted_items_deliver and targeted_items_pickup to include quality.
    - Changed all instances of get_item_count to support quality.
    - Changed LuaPlayer::get_quick_bar_slot to include quality.
    - Changed LuaEquipmentGrid::get_contents() to include quality.
    - Changed LuaEquipmentGrid::count() to support quality.
    - Changed LuaEntity::storage_filter read to include quality.
    - Added quality to selected_prototype during custom input events.
    - Added GameViewSettings::show_surface_list property to control its vibility in the Remote View.
---------------------------------------------------------------------------------------------------
Version: 2.0.21
Date: 21. 11. 2024
  Minor Features:
    - Added drag-to-reorder to the research queue.
    - Added "Occlude light sprites" graphics option to allow disabling 2.0 light rendering to improve performance. As a side effect, it disables also lava glow. (https://forums.factorio.com/119530)
    - [space-age] Added "Additional terrain effects" graphics option to disable puddles and global terrain tint as alternative to increase performance on Gleba to disabling fog, clouds and animated water.
    - [space-age] Added "Nauvis Rocket Factory" menu simulation.
  Changes:
    - Replaced the "move forward" and "move backward" buttons on technologies in the research queue with a draggable handle.
    - Allowed to set blueprint parameter to be ingredient of other parameter even when it doesn't exist in an assembling machine. (https://forums.factorio.com/117979)
    - Added a hidden sound setting to base the music selection on the character's physical location. (https://forums.factorio.com/119140)
    - Agriculutral Tower now respects allied ghosts blocking planting spots. (https://forums.factorio.com/120729)
    - volcanic-cracks-hot no longer coverable by foundation. (https://forums.factorio.com/120745)
    - Added consistency check for overlapping blueprint tiles not being both (non)-foundations.
      Any inconsistent tiles will be removed on load (analogous already happens when importing blueprint via string or setting blueprint tiles via lua).
    - The slider and input field for the minimum payload in orbital logistic requests now enforce a minimum of 1 instead of 0. (https://forums.factorio.com/120811)
    - Added a delay before music switches when switching surfaces. (https://forums.factorio.com/119871)
    - Added hidden sound setting for controlling music transition stage durations.
    - Improved performance of superforced blueprint preview that is autofilling-in tiles.
  Bugfixes:
    - Fixed double parameter selection in signal selection list.
    - Fixed additional invalid state of collector navmesh. (https://forums.factorio.com/119125)
    - Fixed "Make it better" achievement not obtained when dropping modules in. (https://forums.factorio.com/116552)
    - Fixed dragging sliders with gamepad in free cursor mode.
    - Fixed a sound instance leak related to sound priority. (https://forums.factorio.com/120086)
    - Fixed that selection tool highlighting would show incorrectly in chart view for 1 frame. (https://forums.factorio.com/121970)
    - Fixed a crash when destroying segmented units during the chunk generated event. (https://forums.factorio.com/121998)
    - Improved logic for choosing which schedule to keep if trains get connected (https://forums.factorio.com/117696)
    - Fixed a crash after deconstructing cargo bays with editor. (https://forums.factorio.com/121978)
    - Fixed tutorial missions 4 and 5 missing access to radars and repair packs. (https://forums.factorio.com/117420)
    - Fixed spidertrons shooting extra capture robot during tick of projectile creation. (https://forums.factorio.com/119590)
    - Fixed condition highlights in decider combinator GUI not always updating if a condition used the "Each" special signal.
    - Fixed that energy sources would not update their buffer sizes when the prototype value would change. (https://forums.factorio.com/117669)
    - Fixed that asteroids would calculate damage to entities with resistances incorrectly. (https://forums.factorio.com/118788)
    - Fixed use of slow GPU timer query operation on macOS.
    - Fixed that opening ghost power poles would leave the GUI in a broken state. (https://forums.factorio.com/117823)
    - Toggle menu (escape) leaves remote driving. (https://forums.factorio.com/118188)
    - Fixed that equipment ghost tooltips did not show quality. (https://forums.factorio.com/122139)
    - Fixed incorrect consistency check when trash not requested is used inside of a blueprint and mods are involved. (https://forums.factorio.com/120411)
    - Fixed that portable solar panels and power armor tooltips did not report the correct amount of power generation for the current surface. (https://forums.factorio.com/118177)
    - Fixed that changing Vulcanus map gen settings using the editor prevented ashlands trees from spawning. (https://forums.factorio.com/121800)
    - Fixed that paste-settings could happen when not desired in some situations. (https://forums.factorio.com/121989)
    - Fixed that mobile logistic networks could generate useless alerts in some situations. (https://forums.factorio.com/122158)
    - Fixed robots repeatedly failing to cross Aquilo lake due to high energy usage and being stuck in a loop. (https://forums.factorio.com/118933)
    - Fixed robots looking for a place to charge always picking roboports closer to their target which resulted in overcrowding. (https://forums.factorio.com/117641)
    - Fixed a crash when attempting (and failing) to connect trains parked at specific positions. (https://forums.factorio.com/117173)
    - Fixed a crash when removing a station from a train schedule while another train in the same group used the final stop as waypoint. (https://forums.factorio.com/117297)
    - Fixed that agricultural tower would show all nauvis tiles as unplantable. Nauvis grass, dirt and red desert are now specifically plantable for tree seeds and highlight as green. (https://forums.factorio.com/122065)
    - Fixed Space age map generation not respecting custom starting locations (apart from Nauvis). (https://forums.factorio.com/121469)
    - Fixed technology slot showing research progress for finished trigger technologies. (https://forums.factorio.com/119386)
    - Fixed that reloading specific technologies would leave the dead technology trigger pointer in the trigger processor. (https://forums.factorio.com/viewtopic.php?f=7&t=121043)
  Modding:
    - Added distance_from_nearest_point_x and distance_from_nearest_point_y noise expressions.
    - Moved SpiderVehiclePrototype::chunk_exploration_radius to VehiclePrototype.
    - Removed limit of 64 unique PipeConnectionDefinitions's connection categories.
    - Removed music_transition_* utility constants.
    - Changed CraftItemTechnologyTrigger::item into ItemIDFilter. Removed item_quality.
    - Changed ProduceAchievementPrototype::item_product into ItemIDFilter. Removed quality.
    - Changed ProducePerHourAchievementPrototype::item_product into ItemIDFilter.
  Scripting:
    - Added optional build_check_type to LuaControl::teleport. (https://forums.factorio.com/122001)
    - Added LuaEntityPrototype::heating_energy read. (https://forums.factorio.com/121781)
    - Added LuaForce::circuit_network_enabled, cliff_deconstruction_enabled, mining_with_fluid, rail_support_on_deep_oil_ocean, rail_planner_allow_elevated_rails, vehicle_logistics read. (https://forums.factorio.com/120676)
---------------------------------------------------------------------------------------------------
Version: 2.0.20
Date: 18. 11. 2024
  Minor Features:
    - Added gamepad stick sensitivity setting for map movement.
    - Selecting a spidertron remote selection in the quickbar which is for a different planet than the current one will center on the planet.
  Bugfixes:
    - Fixed that selecting a quality comparison option when "any" quality was set did not work. (https://forums.factorio.com/121590)
    - Fixed it was possible to set inconsistent signals on a control behavior by using parametrized blueprint with a shared parameter. (https://forums.factorio.com/120441)
    - Fixed a crash when rotating entity that is destroyed inside of event handler.
    - Fixed blueprint description label not showing in list view. (https://forums.factorio.com/118739)
    - Fixed fulgoran attractor marking for deconstruction. (https://forums.factorio.com/121690)
    - Fixed beacons deactivated by script loaded from a 1.1.x save file were not migrated properly. (https://forums.factorio.com/121248)
    - Fixed a crash when using modded equipment without items to build it in ghost form. (https://forums.factorio.com/121785)
    - Fixed inserter would not keep stack size signal through a blueprint string. (https://forums.factorio.com/118961)
    - Fixed that you could pick up items off the ground while flying in a rocket. (https://forums.factorio.com/121778)
    - Fixed inserter would not reevaluate enable condition when it was changed by blueprint parameters. (https://forums.factorio.com/121332)
    - Fixed orbital logistics tips&tricks script crash due to space platform hub gui having different layout. (https://forums.factorio.com/121331)
    - Fixed that recipe fuel tooltips did not respect the show-all-unlocked-items interface setting. (https://forums.factorio.com/121873)
    - Fixed asteroid collector set filters from circuit network would set wrong filters for one tick after items were removed and read content is active. (https://forums.factorio.com/120435)
    - Fixed a crash when lua orders entity deconstruction specifying undo item but not specifying a player. (https://forums.factorio.com/121728)
    - Fixed that two damaged construction robots trying to repair each other could get stuck in an infinite loop of trying to hug each other and overshooting. (https://forums.factorio.com/117763)
    - Fixed a crash when running under the Steam Runtime Environment on Linux in certain situations. (https://forums.factorio.com/120128)
    - Fixed quality increase of self-recycling recipes being reported incorrectly in production statistics. (https://forums.factorio.com/120132)
    - Improved super force building logic of belt related blueprints over existing belts. (https://forums.factorio.com/118166)
---------------------------------------------------------------------------------------------------
Version: 2.0.19
Date: 15. 11. 2024
  Minor Features:
    - Added debug option 'always-show-lightning-protection'.
  Changes:
    - [space-age] Changed captive biter spawner to inherit quality from the wild spawner instead of the capture robot. (https://forums.factorio.com/121358)
    - Spidertron selections saved into the quickbar will be darkened with a planet icon in the top when the selection leads to a different planet than the current one.
  Bugfixes:
    - Fixed mining fulgoran lightning rods would not show yield. (https://forums.factorio.com/118205)
    - Fixed blueprint external wires were not added when pasting blueprint over existing entities. (https://forums.factorio.com/119281)
    - Electric weapons damage infinite tiers start more expensive to naturally progress from the non-infinite tiers correctly. (https://forums.factorio.com/120427)
    - Fixed wrong locomotive could turn lights on when train has locomotives both ways and goes back. (https://forums.factorio.com/119397)
    - Fixed a crash when trying to cycle qualities in 2.0 base game. (https://forums.factorio.com/121486)
    - Fixed foundry was not able to reach declared speed of crafting holmium plates due to input fluid shortage. (https://forums.factorio.com/120867)
    - Fixed buildings constructed on space platform by space platform were not tracked by build statistics, research triggers nor achievements.
    - Fixed pasting blueprint with constant combinator over constant combinator could create unnecesary copy settings undo actions. (https://forums.factorio.com/118426)
    - Fixed upgrading storage chests would not preserve storage filter. (https://forums.factorio.com/121521)
    - Fixed a crash when generating multiplayer maps while background simulations were enabled. (https://forums.factorio.com/121315)
    - Fixed selection tools and some spawnable items did not work correctly when chosen via remote ghost cursor gui. (https://forums.factorio.com/116689)
    - Fixed a crash when an item request proxy wanted to dispatch robots to insert items into invalid slots. (https://forums.factorio.com/121575)
    - Fixed tip of the rocket poking through air objects. (https://forums.factorio.com/119441)
    - Fixed rail planner in ghost mode would ignore existing ghost ramps and ghost supports proposing new supports that were not needed. (https://forums.factorio.com/120490)
---------------------------------------------------------------------------------------------------
Version: 2.0.18
Date: 14. 11. 2024
  Changes:
    - Allowed negative multiplier of logistic (and constant combinator) groups. (https://forums.factorio.com/118684)
    - Updated shortcut icons and increased their size to 56px.
    - [space-age] Container sizes increase with quality.
    - Reviving container ghosts no longer puts colliding items on the ground into the resulting container.
    - Loading game for hosting now automatically offers the dialog whether the mods should be synced before continuing (as with normal game load).
    - [space-age] Bulk inserter doesn't default upgrade to Stack inserter as they are not functionally interchangeable. (https://forums.factorio.com/121011)
    - [space-age] Demolisher health bars will always be visible for at least 1 tick after they take any damage, even if they fully regenerate the damage in the same tick.
    - [space-age] Default quality cycling shortcut simplified to alt+scroll.
  Bugfixes:
    - Fixed confusing blueprint parameter context tooltip for filter of storage chest. (https://forums.factorio.com/119013)
    - Fixed music not switching correctly when restarting level. (https://forums.factorio.com/121012)
    - Fixed that the production GUIs showed the graphs in 'All' when opened with saved precision. (https://forums.factorio.com/121152)
    - Fixed that the "load save after sync" checkbox did not work in the sync mods with save GUI. (https://forums.factorio.com/121091)
    - Fixed removing heatpipes from a blueprint could leave them visually connected to their neighbours. (https://forums.factorio.com/118750)
    - Fixed 'Dropping to planet' button being too wide and pushing the 'Cancel' button off the screen. (https://forums.factorio.com/121132)
    - Fixed 'Always show' label not being accurate to the behavior of only showing in "Alt-mode". (https://forums.factorio.com/116256)
    - Fixed 'Parameterised build' GUI clipping off screen when too long. (https://forums.factorio.com/120712)
    - Fixed robots failing to upgrade a container if it was the only source of the requested item. (https://forums.factorio.com/118973)
    - Fixed that reusing the same sprite for multiple effects crashed instead of showing the error message and an option to disable problematic mods. (https://forums.factorio.com/117208)
    - Fixed 'Galaxy of Fame' upload GUI clipping off screen on smaller resolutions. (https://forums.factorio.com/118826)
    - Fixed vertical alignment of Current Research icon. (https://forums.factorio.com/117091)
    - Fixed asteroid spawning being significantly reduced when a platform moved with paused thrust. (https://forums.factorio.com/121123)
    - Fixed that fluids could get erased during migrations. (https://forums.factorio.com/119600)
    - Fixed a crash when removing a roboport while robots in that network are deactivated by script. (https://forums.factorio.com/119993)
    - Fixed that choose-elem-button wouldn't show the select list GUI if clicked with an item that didn't pass the filters. (https://forums.factorio.com/118537)
    - Fixed that syncing mod while trying to host game didn't allow to continue the process after reloading the game. (https://forums.factorio.com/119876)
    - Fixed chunks not being covered by fog of war when remote-viewing an unvisited surface. (https://forums.factorio.com/121029)
    - Fixed all/any/individual request satisfied wait conditions ignoring maximum count of space platform requests. (https://forums.factorio.com/119265)
    - Fixed offshorepump tooltip flickering too much when pumping at full capacity. (https://forums.factorio.com/120177)
    - Disabled "Drive Remotely" button on driveable vehicles ghosts' GUIs. (https://forums.factorio.com/120400)
    - Fixed Cargo Landing Pad and Space Platform Hub GUI being clipped off screen on smaller resolutions. (https://forums.factorio.com/120670)
    - Fixed platform deletion and undelete platform buttons being clipped off the surface list. (https://forums.factorio.com/120443)
    - Fixed that tanks didn't preserve all of their settings when mined and rebuilt. (https://forums.factorio.com/121148)
    - Fixed that rebuilt tanks didn't have their inventory size bonus from equipment. (https://forums.factorio.com/121219)
    - Fixed script error in PvP when setting starting item count to 0. (https://forums.factorio.com/117571)
    - Fixed spectator players of dead teams showing on the map in PvP. (https://forums.factorio.com/114477)
    - Fixed that inserters could get stuck with specific combinations of spoilage and disabled by control behavior. (https://forums.factorio.com/121167)
    - Fixed that some pop-up GUIs would get closed when robots built the entity while the ghost GUI was open. (https://forums.factorio.com/118545)
    - Fixed that robots performing module upgrades left some modules on ground when upgrading mixed modules to one type. (https://forums.factorio.com/119524)
    - Fixed that space platforms could unload cargo while waiting for departure. (https://forums.factorio.com/120856)
    - Fixed clouds and smoke were moving in exactly opposite direction. (https://forums.factorio.com/118576)
    - Fixed that spidertrons would severely confuse demolishers. Demolishers will now retaliate against spidertrons. (https://forums.factorio.com/120027)
    - Fixed the confirmation button behaving inconsistently in the remote view ghost picker menu. (https://forums.factorio.com/121287)
    - Fixed Agricultural tower sometimes showing wrong status if its growing plants were destroyed externally.
    - Fixed a crash when exporting a blueprint with asteroid collectors which had gaps in the filters list. (https://forums.factorio.com/121377)
    - Fixed Being able to super-force entity through technology gui. (https://forums.factorio.com/120305)
    - Fixed spoilage was not considered as more spoiled than any spoilable items. (https://forums.factorio.com/121406)
    - Fixed that highlighted robots in the logistic networks chart view didn't smoothly follow robots. (https://forums.factorio.com/117328)
  Modding:
    - Changed base/space-age tile collision mask definitions so that they don't share references to the same tables.
    - Added ItemPrototype::spoil_level.
  Scripting:
    - Fixed/reworked how setting tiles behaves vis-à-vis (double)hidden tiles (concerns LuaSurface::set_tiles, editor and placing of non-mineable tiles in-game) (https://forums.factorio.com/118527)
    - Added LuaEquipment::inventory_bonus read.
    - Added LuaEquipmentGrid::inventory_bonus and LuaEquipmentGrid::movement_bonus read.
    - Added LuaEquipmentPrototype::get_inventory_bonus().
    - Fixed that LuaEntity::get_priority_target() would give invalid results for empty filters.
    - Extended LuaEntity::splitter_filter, splitter_input_priority and splitter_output_priority to also work with lane splitters.
---------------------------------------------------------------------------------------------------
Version: 2.0.17
Date: 12. 11. 2024
  Changes:
    - [space-age] Gleba evolution is smoother and more gradual.
    - [space-age] Small stomper pentapod moves more slowly (also decreases stomp DPS).
    - [space-age] Stomper pentapod vision range is reduced from 40 to 30.
    - [space-age] Medium and big wriggler pentapod health is increased.
    - [space-age] Streamlined quality selector to use separate buttons for each quality instead of a drop-down.
    - [space-age] Changed crafting machines to reset quality of the in-progress result when module effects change. (https://forums.factorio.com/120270)
    - Added inserter stack size override to be parametrised by blueprint. (https://forums.factorio.com/118635)
    - Added Vulcanus 8 music track.
  Bugfixes:
    - Fixed that the game would get into an invalid state if the backers.json file was manually edited in some ways. (https://forums.factorio.com/120176)
    - Fixed a crash with lightning when setting time to damage to 0 through mods. (https://forums.factorio.com/120474)
    - Fixed fast replacing a radar could cause radar network to break.
    - Fixed that blueprint export/import to string did not work correctly for turret priorities with gaps. (https://forums.factorio.com/120162)
    - Fixed that some asteroids could appear stationary if their velocity was lower than minimum position increment. (https://forums.factorio.com/120297)
    - Fixed space platform autosaves being overwritten mid-journey when the platform changed its state. (https://forums.factorio.com/119650)
    - Fixed market offer not working with nothing modifier. (https://forums.factorio.com/120744)
    - Fixed rocket silo would start closing doors when next rocket was finished while lights blinking animation was already started. (https://forums.factorio.com/120748)
    - Fixed LuaTechnologyPrototype::essential returning incorrect value. (https://forums.factorio.com/120640)
    - Fixed that strafer pentapods couldn't attack a retreating target it was behind even when faster than the target. Attack range is increased but strafe distance is unchanged.
    - Fixed more issues with blueprint reassigning changing the position of the entities or snapping values of the blueprint. (https://forums.factorio.com/117957)
    - Fixed wrap-around of asteroid rotation animation was not seamless. (https://forums.factorio.com/117915)
    - Fixed that Galaxy of Fame upload didn't clean its files. (https://forums.factorio.com/118090)
    - Fixed more crashes related to using formatting strings with floating-point numbers on Intel Macs running Sonoma.
    - Fixed cancelling deconstruction via deconstruction player was not showing counts for canceled deconstructions. (https://forums.factorio.com/119294)
    - Fixed that setting negative value in constant combinator create 2 entries for the number in the blueprint parametrisation, one with underflown value.
    - Fixed that it wasn't possible to input negative numbers in blueprint parametrisation. (https://forums.factorio.com/117989)
    - Fixed offshore pump would present itself as water well pump even when it was not pumping water. (https://forums.factorio.com/120877)
    - Fixed crash when trying to search invalid UTF-8 string (https://forums.factorio.com/120452)
    - Fixed that hidden space locations would will show in descriptions. (https://forums.factorio.com/120541)
    - Fixed that fast-transferring modules would put them into the rocket silo rocket inventory. (https://forums.factorio.com/117666)
    - Fixed that switching surfaces while a platform hub GUI was open would leave the GUI open in some cases where it wasn't supposed to. (https://forums.factorio.com/119720)
    - Fixed that you could remove your armor and spill items through the quickbar. (https://forums.factorio.com/120586)
    - Fixed that modded attack_reaction could crash the game. (https://forums.factorio.com/120687)
    - Fixed a crash when using surface.clear() on vulcanus. (https://forums.factorio.com/121058)
    - Fixed that orbital request select window wasn't showing proper import from after chaning the group unless the whole window was closed and opened again. (https://forums.factorio.com/118392)
    - Fixed double set of parameters in factoriopedia. (https://forums.factorio.com/118152)
    - Fixed stack inserter would not wait for more items if spoil priority was set. (https://forums.factorio.com/120980)
    - Fixed loaders would freeze or unfreeze partially. (https://forums.factorio.com/119228)
    - Fixed arithmetic combinator gui would allow changing not relevant checkboxes in some cases. (https://forums.factorio.com/121041)
    - Fixed surface editor would not set surface properties when creating surfaces planet-alike. (https://forums.factorio.com/120874)
    - Fixed rail planner would remain active when changing surfaces. (https://forums.factorio.com/121026)
    - Fixed a crash when reviving power switch with multiple ghost copper cables connected to the same side. (https://forums.factorio.com/121056)
    - Fixed space platform hub gui would reset position when changing auto requests checkbox. (https://forums.factorio.com/120512)
    - Fixed that assembler with set recipe enabled would not keep direction if current recipe did not require direction. (https://forums.factorio.com/120686)
    - Fixed robot repair job assignmend ignoring repair packs stored in roboports when finding the closest source. (https://forums.factorio.com/117937)
    - Allowed increasing of request count by blueprint parameters to push the max request count. (https://forums.factorio.com/118536)
    - Fixed that corpses would block tiles from being deconstructed. (https://forums.factorio.com/119202)
    - Fixed that restarting to reload mods on macOS would leave behind unresponsive zombie windows. (https://forums.factorio.com/117058)
  Modding:
    - Input loader supports filters.
  Scripting:
    - Added LuaControl::set_driving() (https://forums.factorio.com/121014)
---------------------------------------------------------------------------------------------------
Version: 2.0.16
Date: 08. 11. 2024
  Minor Features:
    - Search is now case and accent insensitive for all official languages.
  Changes:
    - [space-age] Changed tree seed default import location to Nauvis. (https://forums.factorio.com/119272)
    - Fluid mixing will prefer the fluid with more volume and discard the other.
    - Updated SDL to version 2.30.9.
  Bugfixes:
    - Fixed a freeze when setting logistic/construction robots to active=false through script. (https://forums.factorio.com/119911)
    - Fixed that LuaEntity::vehicle did not work correctly for characters controlled by a player. (https://forums.factorio.com/119848)
    - Fixed rendering of glowing items on belts would not be batched properly. (https://forums.factorio.com/118863)
    - Fixed a crash when reading LuaEntity::robot_order_queue. (https://forums.factorio.com/119764)
    - Fixed that the permissions GUI could not be opened in multiplayer as not-the-host. (https://forums.factorio.com/119979)
    - Fixed some decorative entities like craters or chimneys not having a tall enough drawing box. (https://forums.factorio.com/116746)
    - Fixed that factoriopedia_description would not be used if the prototype didn't also have a regular description. (https://forums.factorio.com/119631)
    - Fixed a crash when space platforms are destroyed while specific entity GUIs are open. (https://forums.factorio.com/119136)
    - Fixed undoing a copy-settings could void assembler contents. (https://forums.factorio.com/119554)
    - Fixed tips not appearing in tutorials. (https://forums.factorio.com/117463)
    - Fixed wrong times symbol in a logistic request tooltip. (https://forums.factorio.com/120014)
    - Fixed that using pipette on GUI items did not consistently copy the quality. (https://forums.factorio.com/119201)
    - Fixed that using pipette on tile items in GUI always selected normal quality. (https://forums.factorio.com/116952)
    - Fixed that using pipette on entity items in GUI could select the wrong item if multiple items can build the same entity.
    - Fixed visualisation issue around cursor attractor range enveloping an existing attractor (https://forums.factorio.com/119514)
    - Fixed tile replacement logic ignoring tile ghosts covered by tile ghosts
    - Fixed stations getting skipped when using the 'Destination full' condition for interrupts. (https://forums.factorio.com/115988)
    - Fixed UI jank that widgets would snap to be centered on the cursor when dragged.
    - Fixed selections using deconstruction planners etc. not getting cancelled when leaving remote view. (https://forums.factorio.com/117145)
    - Fixed that changing viewed surface would not abort wire drag. (https://forums.factorio.com/119456)
    - Fixed non-chart sprites sometimes being drawn into chart. (https://forums.factorio.com/118486)
    - Fixed upgrading cargo bays with incoming pods would leave them permanently reserved. (https://forums.factorio.com/119912)
    - Fixed a crash when changing tiles causes entities to die. (https://forums.factorio.com/120091)
    - Fixed that a music track could play on a wrong surface. (https://forums.factorio.com/119409)
    - Fixed bloom lightmap for fog was being rendered also when fog effect was not used.
    - Fixed super force overbuilding entity with settings sometimes behaving incorrectly if overbuilt entity was marked for upgrade.
    - Fixed fluid overextent warning would sometimes show on entities that would not help overcome the overextent. (https://forums.factorio.com/119791)
    - Fixed cars not having lightning endangerement alerts despite being vulnerable to lightnings (https://forums.factorio.com/119473)
    - Fixed a performance issue in the manage-mods GUI. (https://forums.factorio.com/120032)
    - Fixed a memory corruption issue when changing a character's force from one that did not have logistics to one that did. (https://forums.factorio.com/120101)
    - Fixed the Trash unrequested checkbox in the character logistic GUI expanding the GUI size. (https://forums.factorio.com/118606)
    - Fixed that LuaEntity::mirroring write did not work for ghosts. (https://forums.factorio.com/117633)
    - Fixed sounds of items inserted by robots being too loud. (https://forums.factorio.com/117780)
    - Fixed the Trash unrequested checkbox showing in chests which have no trash slots. (https://forums.factorio.com/116985)
    - Fixed a crash when switching audio devices when there were none initially.
    - Fixed pin text rich text icon quality punching through GUIs. (https://forums.factorio.com/117647)
    - Fixed that LuaSurface::find_tiles_filtered() did not work with rotated bounding boxes. (https://forums.factorio.com/111178)
    - Fixed interrupt GUI targets list being squashed too much with lots of interrupt conditions. (https://forums.factorio.com/119550)
    - Fixed that heating towers couldn't consume items fast enough if the fuel value was low. (https://forums.factorio.com/120114)
    - Fixed a consistency issue when deconstructing the last roboport in a logistic network. (https://forums.factorio.com/119973)
    - Fixed fog was clipping through agricultural tower. (https://forums.factorio.com/116678)
    - Fixed that killed and rebuilt power switches would get stuck in the inoperable state. (https://forums.factorio.com/119732)
    - Fixed a performance issue with large inventory GUIs. (https://forums.factorio.com/120212)
    - Fixed that infinity chests didn't show hidden items. (https://forums.factorio.com/118813)
    - Fixed that programmable speaker alert text wasn't included in the blueprint parametrisation logic. (https://forums.factorio.com/118080)
    - Fixed that science pack descriptions in Factoriopedia didn't make any sense. (https://forums.factorio.com/116958)
    - Fixed muzzle flash of artillery wagon was offset when the wagon was on elevated rails. (https://forums.factorio.com/118761)
    - Fixed artillery wagon gun barrel was rendered under elevated rail fence.
    - Fixed drawing linked fluidbox connections when they should be hidden.
    - Fixed that manually-built trains were switched to automatic mode when a ghost attached to them was revived. (https://forums.factorio.com/119836)
    - Fixed that blueprints could be grabbed while having a ghost item in the cursor. (https://forums.factorio.com/118524)
    - Fixed an assembling machine could be set a fluid-only recipe with quality when set by circuit network. (https://forums.factorio.com/120108)
    - Fixed maximum request limit (autotrash threshold) not accepting math expressions. (https://forums.factorio.com/117887)
    - Fixed equipment requests not being cleared when the grid didn't have enough space. (https://forums.factorio.com/117509)
    - Fixed that asteroid collector control behavior "set filter" would affect status light while wire was disconnected. (https://forums.factorio.com/118456)
    - Fixed turbo splitter was missing description. (https://forums.factorio.com/120236)
  Scripting:
    - Added hide_clouds and hide_fog parameters to LuaGameScript::take_screenshot. (https://forums.factorio.com/120199)
    - Added LuaEntity::get_logistic_sections(). Added LuaLogisticSections.
---------------------------------------------------------------------------------------------------
Version: 2.0.15
Date: 05. 11. 2024
  Minor Features:
    - Cars and tanks will auto-refuel. (https://forums.factorio.com/118247)
    - Relation between offshore pump and fluid tiles added to Factoriopedia.
    - Statistic GUI precision is preserved across instances.
    - [space-age] Space platforms can be built with quality starter packs. (https://forums.factorio.com/118376)
  Changes:
    - Increased spidertron walking sound volume.
    - Using the "craft all" hotkey on free recipes queues 1 stack of the results. (https://forums.factorio.com/118319)
    - Changed the simulated mouse cursor appearance to match the system default on macOS.
    - [space-age] Added pollution value to heating tower.
    - [space-age] Show recycler output arrow in "Alt-mode". (https://forums.factorio.com/119176)
    - Display panels set to "Show in chart" with no icon now hide the default icon until hovered. (https://forums.factorio.com/116844)
    - Removed support for 8 bit audio depth.
    - Added tooltip to "Spoiled priority" inserter setting to clarify behavior and limitations.
  Bugfixes:
    - Fixed IME Pad input not working on screens with visible simulations. (https://forums.factorio.com/116118)
    - Fixed that the browse-games GUI header labels were not clickable. (https://forums.factorio.com/117697)
    - Fixed that kills with chained effects did not count towards statistics or achievements. (https://forums.factorio.com/118420)
    - Extended the mute-programmable-speaker command to apply to sounds with both global and surface playback modes. (https://forums.factorio.com/118386)
    - Fixed a crash when a player got desynced from a multiplayer game while the Technology GUI was open.
    - Fixed a crash when rendering display panel text after loading a save file. (https://forums.factorio.com/119071)
    - Fixed a crash when clicking on an orbital request slot with an invalid ghost item in cursor. (https://forums.factorio.com/118847)
    - Fixed a crash when rendering certain blueprints with pipe-to-grounds which visually connected to neighbours outside of the blueprint. (https://forums.factorio.com/116456)
    - Fixed cargo pod with satellite not despawning after launching to orbit. (https://forums.factorio.com/118913)
    - Fixed a crash when teleporting a crafting machine ghost with fluid connections. (https://forums.factorio.com/118607)
    - Fixed that space platforms would try to build/upgrade/deconstruct/repair other forces entities. (https://forums.factorio.com/119089)
    - Fixed that the production GUI title wouldn't update when viewing different planets. (https://forums.factorio.com/119174)
    - Fixed that starting territories on Vulcanus could be merged into one more frequently than expected. (https://forums.factorio.com/117525)
    - Fixed that platform requests satisfied wait conditions could be stuck when the platform had unfulfilled ghost item requests. (https://forums.factorio.com/119179)
    - Fixed that space platforms didn't fulfill remote item delivery requests if the target slot was already occupied with the same item. (https://forums.factorio.com/119179)
    - Fixed that negative movement speed stickers could cause player movement to get stuck in a near infinite loop. (https://forums.factorio.com/118071)
    - Fixed a crash when drawing spidertrons on the map if selected_minimap_representation wasn't defined. (https://forums.factorio.com/117889)
    - Fixed shattered planet achievements being incorrectly awarded when traveling backwards in a paused platform. (https://forums.factorio.com/119178)
    - Fixed that remote view while in the map editor did not ignore fog of war. (https://forums.factorio.com/119152)
    - Fixed a crash when using LuaEquipmentGrid::take_all() when the grid contained ghosts. (https://forums.factorio.com/118730)
    - Fixed that belt immunity equipment didn't use less power at higher qualities like it said it did. (https://forums.factorio.com/118722)
    - Fixed that several specific-item producing entities could not be specifically filtered in the deconstruction planner. (https://forums.factorio.com/118089, https://forums.factorio.com/118297, https://forums.factorio.com/116477)
    - Fixed LuaEntity::max_health was returning incorrect values for entities with health affected by evolution factor. (https://forums.factorio.com/118626)
    - Fixed fast replacing loaders would not preserve filter mode. (https://forums.factorio.com/119559)
    - Fixed that heating towers and nuclear reactors were fast-replaceable with each other. (https://forums.factorio.com/118560)
    - Fixed rail curves making a blueprint's default snapping grid unnecessarily large. (https://forums.factorio.com/116603)
    - Removed long delay at start when no audio devices are found. (https://forums.factorio.com/117795)
    - Fixed that result_is_always_fresh was ignored for hand crafting. (https://forums.factorio.com/119705)
    - Maybe fixed crashes related to using formatting strings with floating-point numbers on Intel Macs running Sonoma.
    - Fixed that removing cargo bays while the inventory limit was in place did not work correctly. (https://forums.factorio.com/118132)
    - Fixed that inserters could get stuck loading cargo wagons in some cases. (https://forums.factorio.com/119636)
    - Fixed spoiled items in filtered slots of inventory would not get ejected to unfiltered slots when sorting inventory. (https://forums.factorio.com/119743)
    - Fixed a crash when removing equipment that was in equipment ghosts. (https://forums.factorio.com/119207)
    - Fixed a crash when migrating a fluid box from one that joins with a fluid segment to one that does not.
    - Fixed endlessly pending asteroid collector calculation when navigation was not changed (https://forums.factorio.com/119125)
    - Fixed modded spider vehicles being selectable with Spidertron Remote when selectable_in_game property was false.
    - Fixed copying settings from inserter to assembler could raise error sound even when circuit conditions were changed. (https://forums.factorio.com/118520)
    - Fixed that some color signals were not given lamp color. (https://forums.factorio.com/118710)
    - Fixed that recipe parameter would not allow productivity effect. (https://forums.factorio.com/118790)
    - Fixed that new filters set by LuaLogisticSection::filters would not propagate to other sections under the same group. (https://forums.factorio.com/118427)
    - Fixed that sync-mods-with-save did not show load-save as an option. (https://forums.factorio.com/119038)
    - Fixed captive biter spawner was able to connect to logistic network. (https://forums.factorio.com/119492)
    - Fixed that clearing assembler recipe would not clear invalid item requests. (https://forums.factorio.com/119347)
    - Fixed a crash when trying to drag temporary schedule record for a constantly retriggering interrupt. (https://forums.factorio.com/119233)
    - Fixed asteroid collector description not listing minimum energy consumption. (https://forums.factorio.com/118962)
    - Fixed recycling time of recipes with default crafting time was twice as long. (https://forums.factorio.com/118900)
    - Fixed space platforms and cargo landing pads losing items when merging forces. (https://forums.factorio.com/117877)
    - Fixed that item pickup requests weren't invalidated after making an automatic trash request. (https://forums.factorio.com/118276)
    - Fixed environmental sounds needlessly reloading when entering/leaving remote view. (https://forums.factorio.com/117910)
    - Fixed rough ice thawing to volcanic tiles. (https://forums.factorio.com/119177)
  Modding:
    - [space-age] Changed territory noise expressions coordinate system from chunk-based to tile-based.
    - Added option to surface.pollute() for recording the pollution change in statistics.
    - Fixed on_entity_damaged.source not behaving according to the 2.0 specification.
  Scripting:
    - Added connection_type and linked_connection_id to LuaFluidboxPrototype::pipe_connections.
---------------------------------------------------------------------------------------------------
Version: 2.0.14
Date: 01. 11. 2024
  Changes:
    - [space-age] Changed self-recycling recipe statistics to be ignored in production graph.
    - Changed sprites with scale between 0.5 and 1 (exclusive) to apply downscaling to low resolution (affects base game biter sprites).
    - Changed cargo landing pad mining time to 1.
    - Moved the mods GUI search to be with the content it is searching.
    - Added linear interpolation method (used by default now) for audio resampling when playback speed is changed. (https://forums.factorio.com/116936)
    - Added an option to disable animated ghosts to aid performance on integrated GPUs. (https://forums.factorio.com/116304)
    - [space-age] Added a confirmation box when deleting space platforms.
  Bugfixes:
    - Fixed that having multiple key bindings could cause some keys to get stuck. (https://forums.factorio.com/118498)
    - Fixed that it wasn't possible to parametrised item filter to any quality. (https://forums.factorio.com/118272)
    - Fixed a crash when killing segmented units attached to a segmented controller. (https://forums.factorio.com/118639)
    - Fixed that tank logistic trash slots did not work correctly when using roboports in the tank. (https://forums.factorio.com/118235)
    - Fixed that shortcuts marked as not toggleable still allowed being toggled. (https://forums.factorio.com/115015)
    - Fixed that lua shortcuts ignored unavailable_until_unlocked. (https://forums.factorio.com/117464)
    - Fixed that teleporting certain entities would delete their fluid contents. (https://forums.factorio.com/117719)
    - Fixed that the reactor GUI temperature would flicker when the temperature was < 100 degrees. (https://forums.factorio.com/118121)
    - Fixed that some errors related to prototypes would report coming from the wrong prototype. (https://forums.factorio.com/118703)
    - Fixed that copying spider vehicle settings between spiders of different quality did not work correctly. (https://forums.factorio.com/118711)
    - Fixed that pumps would pull fluid from internal machine buffers instead of the connected fluid segment. (https://forums.factorio.com/118688)
    - Fixed that mods were able to create item stacks without quality which crashed the game. (https://forums.factorio.com/118677)
    - Fixed rocket silo requesting more items even if another rocket wasn't ready yet. (https://forums.factorio.com/118163)
    - Fixed incorrect lightning protection visualisation in some cases where shorter range attractor is close to longer ranged one (https://forums.factorio.com/117751)
    - Fixed vehicle sounds not playing in some menu simulations. (https://forums.factorio.com/117674)
    - Fixed a crash when reading repair state of a character not assigned to a player. (https://forums.factorio.com/118767)
    - Fixed asteroid collector navigation not generating in time when a straight platform edge is aligned with chunk border, which caused a crash. (https://forums.factorio.com/118050)
    - Fixed consistency issue when removing a turret that was connected to logistic network. (https://forums.factorio.com/117498)
    - Fixed a crash when prototype data changes and roboports are requesting specific robots. (https://forums.factorio.com/117618)
    - Fixed combinators could get stuck after cancelling deconstruction order. (https://forums.factorio.com/118748)
    - Fixed a crash when fast-replacing not-a-heat-interface entity with a heat interface. (https://forums.factorio.com/118778)
    - Fixed a crash when trying to recycle blueprint books with contents. (https://forums.factorio.com/118825)
    - Fixed being able to enter a frozen rocket.
    - Fixed flames not updating on a frozen or deconstructed rocket silo.
    - Fixed a crash when viewing players in the players GUI when they disconnect from the server.
    - Fixed a crash when copy-pasting settings from an assembling machine to a logistic chest that did not support requests. (https://forums.factorio.com/118716)
    - Fixed that the space map GUI would not show until you had visited at least 1 other planet. (https://forums.factorio.com/118865)
    - Fixed loader energy source buffer size computation. (https://forums.factorio.com/118529)
    - Fixed that tesla turret and tesla gun chain lightning sometimes arced to friendly entities. (https://forums.factorio.com/118726)
    - Fixed that character_mining_speed_modifier was not handled in latency state.
    - Fixed factoriopedia for space connections would highlight wrong graph series when hovering over slots of spawned asteroids. (https://forums.factorio.com/118057)
    - Fixed pinning other players did not work correctly. (https://forums.factorio.com/118939)
    - Fixed demolishers getting disturbed by vehicles and other non-building entities. (https://forums.factorio.com/117092)
    - Fixed "Get off my lawn" achievement not being awarded when building close to a demolisher. (https://forums.factorio.com/118420)
    - Fixed a crash when copy-pasting from cars with equipment grids to ghost-cars without equipment grids. (https://forums.factorio.com/118480)
    - Fixed a crash when showing logistic request tooltip immediately after joining a multiplayer game. (https://forums.factorio.com/116939)
    - Reverted a fix for train interrupts not being checked when passing a station without conditions (https://forums.factorio.com/117530) because it crashed the game. (https://forums.factorio.com/118822)
  Modding:
    - Combined four ghost tint definitions in UtilityConstants into UtilityConstants::ghost_shader_tint and added UtilityConstants::ghost_shaderless_tint.
    - Added LoaderPrototype::per_lane_filters.
  Scripting:
    - Added LuaEntity::loader_filter_mode (read/write).
---------------------------------------------------------------------------------------------------
Version: 2.0.13
Date: 30. 10. 2024
  Minor Features:
    - [space-age] Offshore pump speed increases with quality.
  Changes:
    - Curved rails cost 3 rail items to build.
  Bugfixes:
    - Fixed Remote View sometimes flickering to the wrong surface when using Next Surface/Previous Surface hotkeys.
    - Fixed that the Surface List would react to the Home and End keys after it was clicked (https://forums.factorio.com/116927)
    - Improved diagonal character movement which should help slip between things easier. (https://forums.factorio.com/117748)
    - Fixed a crash when upgrading the inner entity of a ghost while the GUI was open. (https://forums.factorio.com/118164)
    - Fixed that joining LAN games without a username set would allow any characters for the username. (https://forums.factorio.com/107985)
    - Fixed that request from buffer chests was not preserved when changing the force of an entity. (https://forums.factorio.com/114099)
    - Fixed that flamethrower turret could be manually built to mix fluids. (https://forums.factorio.com/118045)
    - Fixed that half diagonal rails would cost only 1 rail item. (https://forums.factorio.com/117484)
    - Fixed pipe sound starting and stopping too abruptly. (https://forums.factorio.com/118028)
    - Fixed turret behaviour when it has more than 4 directions and the collision box is not affected by rotation.
    - Fixed a crash when switching preferred audio output device while a variable music track is being generated. (https://forums.factorio.com/118250)
    - Fixed an issue with platform construction requests when copying settings onto the hub. (https://forums.factorio.com/117600)
    - Fixed a crash when saving related to construction robots and their work targets moving. (https://forums.factorio.com/118226)
    - Fixed that Continue host option didn't offer mod sync to the save to be hosted. (https://forums.factorio.com/107900)
    - Fixed Space platform requests would always be checked in the same order, leading to some requests being ignored. (https://forums.factorio.com/117146)
    - Fixed base game space science getting throughput limited due to limited hatches. (https://forums.factorio.com/118064)
    - Fixed defines.space_platform_state was missing value for paused. (https://forums.factorio.com/118336)
    - Fixed solar panel output multiplier flickering in tooltip. (https://forums.factorio.com/117972)
    - Fixed that deconstruction of a chest with full trash slots didn't dispatch enough robots. (https://forums.factorio.com/117455)
    - Fixed a crash caused by a player sending a space platform which was waiting for departure (not enough thrust) to a location which wasn't unlocked yet. (https://forums.factorio.com/118254)
    - Fixed that train interrupts were not checked when passing station without conditions. (https://forums.factorio.com/117530)
    - Fixed that the browse-games GUI 'dedicated server' and 'favorite' settings would get confused with each other. (https://forums.factorio.com/118358)
    - Fixed that capture-spawner research trigger reported incorrect type. (https://forums.factorio.com/118279)
    - Fixed production and electricity statistics would use wrong locale for ranges exceeding 99 hours. (https://forums.factorio.com/117170)
    - Fixed that exoskeleton legs would incorrectly consume more energy at higher qualities. (https://forums.factorio.com/118370)
    - Fixed that logistic filter upper count wasn't considered by the blueprint parametrisation. (https://forums.factorio.com/117422)
    - Fixed technology trigger info showing outside the tooltip. (https://forums.factorio.com/116004)
    - Fixed that Lua require didn't accept symbolic links. (https://forums.factorio.com/117061)
    - Fixed that migrating logistic cell charger count would corrupt loading. (https://forums.factorio.com/117868)
    - Fixed that cars/tanks would not preserve their settings correctly in blueprint strings. (https://forums.factorio.com/118293)
    - Fixed that fluids would be duplicated when fast-replacing machines. (https://forums.factorio.com/118323)
    - Fixed that the window could get stuck in an infinite loop of toggling fullscreen when changing displays on Linux. (https://forums.factorio.com/116349)
    - Fixed that the "make it better" achievement only worked with quality level 1 modules. (https://forums.factorio.com/117497)
    - Fixed asteroid collectors sometimes not generating navmesh properly around chunk borders and related instabilities. (https://forums.factorio.com/117737, https://forums.factorio.com/117276)
    - Fixed that opened console was rendered into the galaxy of fame output. (https://forums.factorio.com/117619)
    - Fixed that the focus search hotkey would not work in choose elem button GUIs if a mod GUI was marked as opened. (https://forums.factorio.com/118073)
    - Fixed that Intel Macs running macOS Big Sur or later logged the wrong version number.
    - Fixed issue where entities at position where entities at the point where lightning attractor collection ranges touch were incorrectly considered endangered by lightning (https://forums.factorio.com/118102)
    - Fixed blue line at the edge of some sprites by clearing sprite atlas background to clear color. (https://forums.factorio.com/117261)
    - Fixed some cases of upgradeable overbuilds not upgrading (https://forums.factorio.com/117644)
    - Fixed that using Nauvis map gen settings for other planets made them generate only grass. (https://forums.factorio.com/118374)
    - Fixed that the select-recipe GUI did not work correctly if you re-bound the crafting hotkeys. (https://forums.factorio.com/118383)
    - Fixed a crash when editing a pin while the entity was referencing was removed. (https://forums.factorio.com/118406)
    - Fixed selector combinator could sometimes fail to select correct signal. (https://forums.factorio.com/118412, https://forums.factorio.com/116548)
    - Fixed that some technology triggers required crafting specific quality items. (https://forums.factorio.com/117848)
    - Fixed constant combinator activity lamp not updating state in certain cases. (https://forums.factorio.com/117929)
    - Fixed that custom sprite button's caption would be drawn under the sprite. (https://forums.factorio.com/118327)
    - Possibly fixed a crash on Intel Macs related to printing floats with 0 precision. (https://forums.factorio.com/116239)
    - Fixed layered icons in rich text were not scaled and rotated properly. (https://forums.factorio.com/116031)
    - Fixed that moisture and terrain type weren't migrated properly for 1.1 saves resulting in hard chunk edges.
    - Fixed occasional crash occurring when super force deconstructing with filtered tiles only planner includes double tile ghosts and an entity ghost on one tile (https://forums.factorio.com/118041)
    - Fixed a crash when a space platform hub with 'Any request zero' wait condition was destroyed. (https://forums.factorio.com/118505)
    - Fixed that custom gui elem_tooltip did not work for some new types. (https://forums.factorio.com/118581)
    - Fixed big electric poles were not colliding with asteroid collectors. (https://forums.factorio.com/118506)
    - Fixed that LuaGameScript::show_message_dialog() could use the wrong player and freeze the game. (https://forums.factorio.com/115881)
  Scripting:
    - Added LuaSpacePlatform::name write.
    - Added player_won to the on_pre_scenario_finished event.
    - LuaControl uses physical controller for item manipulations (LuaControl::insert, has_items_inside, get_item_count, remove_item, clear_items_inside)
    - Added LuaPlayer::physical_controller_type read.
    - Added LuaQualityPrototype::color read.
  Sounds:
    - Fulgora lightning sound remixed lower with volume variations.
    - Fixed some explosions that were using the wrong size of explosion sound.
    - Numerous sound mixes including new plant mining sounds mixed lower.
    - Various menu simulation mixes improved.
---------------------------------------------------------------------------------------------------
Version: 2.0.12
Date: 28. 10. 2024
  Bugfixes:
    - Fixed rocket silos requesting more items than necessary. (https://forums.factorio.com/116949)
    - Fixed a crash when reading owner_location on simple item stacks. (https://forums.factorio.com/117357)
    - Fixed mini-tutorial scripts crashing or not granting items if player switched to remote view.
    - Fixed that LuaControl::opened write did not work for several GUI types. (https://forums.factorio.com/117362)
    - Fixed that elevated rail entities would still work without owning space-age. (https://forums.factorio.com/117225)
    - Fixed that the admin "other player" GUI would open the other player's remote controller invenory instead of physical inventory. (https://forums.factorio.com/117410)
    - Fixed a crash related to quickbar interaction with any-quality spawnable items. (https://forums.factorio.com/117206)
    - Fixed a crash when building (faulty) blueprint with two hazard concrete tiles in one space (https://forums.factorio.com/117108 and https://forums.factorio.com/117071)
    - Fixed game state GUIs being automatically closed when the game was paused. (https://forums.factorio.com/116851)
    - Fixed several possible errors related to smart belt building. (https://forums.factorio.com/116660, https://forums.factorio.com/117119)
    - Fixed that disconnecting and reconnecting while personal robots were working did not preserve their quality. (https://forums.factorio.com/117448)
    - Fixed that cargo pods dropped players to a random location which could make them stuck. (https://forums.factorio.com/117461 and https://forums.factorio.com/117408)
    - Fixed that alert icons were rendered into the galaxy of fame.
    - Fixed a desync related to space platform hubs reading content and repair packs merging due to inventory sorting.
    - Fixed ribbon world preset having too many cliffs on Nauvis. (https://forums.factorio.com/117544)
    - Fixed that blueprint parametrisation value formula evaluation didn't work for negative numbers. (https://forums.factorio.com/116342)
    - Extended blueprint parametrisation to work on fluid recipe parameters.
    - Fixed lua deconstruct_area crashing when deconstructing a ghost (https://forums.factorio.com/117154)
    - Fixed inserter status showing "Target full" when swinging towards a belt (https://forums.factorio.com/116626)
    - Fixed that drag building context was not carried properly between normal view and remote view. (https://forums.factorio.com/116818)
    - Fixed combat robots bobbing. (https://forums.factorio.com/117364)
    - Fixed a crash when defining a recipe that does not always produce an item. (https://forums.factorio.com/117476)
    - Fixed that filters of a ghost turret could get corrupted in latency when upgrading it with upgrade planner. (https://forums.factorio.com/117708)
    - Fixed that re-bound crafting keys did not work correctly. (https://forums.factorio.com/117454)
    - Fixed that chat icons didn't include layered icons. (https://forums.factorio.com/117024)
    - Fixed a crash when super-force-building electric poles in latency state. (https://forums.factorio.com/117620)
    - Fixed a debug visualization render crash when the given force no longer exists. (https://forums.factorio.com/117800)
    - Fixed visual noise caused by parameter recipes drawing as not researched. (https://forums.factorio.com/117688)
    - Fixed selector combinator's constant index was not covered by blueprint parameters. (https://forums.factorio.com/117869)
    - Fixed arithmetic combinator was not showing red and green inputs separately in tooltips. (https://forums.factorio.com/117819)
    - Fixed superforced overbuilding logistic and non-losistic chests did not transfer limits (https://forums.factorio.com/117353)
    - Fixed underground pipe in cursor would sometimes not rotate when rotation key pressed right after placement while playing in latency.
    - Fixed loading save files with some entities on planets with lighting when those entities were removed.
    - Fixed a crash in multiplayer if you were wearing armor and the force you were on was deleted.
    - Fixed some of the quirks of drag building. Whenever there is nothing to build from in the cursor, the drag building logic is interrupted. (https://forums.factorio.com/100393)
    - Fixed that the mine-entity technology trigger did not work if the resource entity produced multiple or variable results. (https://forums.factorio.com/117500)
    - Fixed that asteroid collectors could get stuck if the inventory limiter was used. (https://forums.factorio.com/117739)
    - Fixed a missing value in the prototype explorer. (https://forums.factorio.com/117805)
    - Fixed that smoke-with-trigger could teleport to 0,0 on a map if it was previously following a specific entity. (https://forums.factorio.com/117807)
    - Fixed rail ramp health bar position. (https://forums.factorio.com/117921)
    - Fixed wait condition "station is full" and "station is not full" would report incorrect progress. (https://forums.factorio.com/117949)
    - Fixed crash related to blueprint parametrisation and drag building button being held and moved after the dialog appeared. (https://forums.factorio.com/117299)
    - Fixed lamp would keep using color when circuit wire was disconnected. (https://forums.factorio.com/117400)
    - Fixed copy settings undo could fail to restore control behavior settings if they were originally at default values. (https://forums.factorio.com/117212)
    - Fixed that the map editor couldn't set filters in some cases. (https://forums.factorio.com/117801)
    - Fixed that LuaRecord methods did not work correctly. (https://forums.factorio.com/117411)
    - Fixed crash when building parameterised blueprint with dependent ingridient used in another machine being a fluid. (https://forums.factorio.com/117673)
    - Fixed missing blueprint parametrisation logic for the loader. (https://forums.factorio.com/117490)
    - Fixed a crash when migrating blueprint library content in a save that had that blueprint GUI open. (https://forums.factorio.com/115674)
    - Fixed that items could be put into ghost inventories. (https://forums.factorio.com/117988)
    - Fixed playing too many sounds at once at the start of certain tips and tricks simulations. (https://forums.factorio.com/116390)
    - Fixed a crash when setting RoboportPrototype::charging_station_count_affected_by_quality to true. (https://forums.factorio.com/118086)
    - Fixed generic interrupt false positives with certain interrupt conditions. (https://forums.factorio.com/117799)
    - Fixed main-menu music mode not working correctly in-game. (https://forums.factorio.com/117613)
    - Fixed a crash when trying to open Technology GUI from Factoriopedia while the game was being saved. (https://forums.factorio.com/118029)
    - Fixed clipping that could occur in some variable music tracks. (https://forums.factorio.com/117987)
    - Fixed that set recipe on assembling machine circuit controls could buffer items indefinitely. (https://forums.factorio.com/117890)
    - Fixed inconsistency in belt power replace through corner when going backwards and forwards. (https://forums.factorio.com/102843)
    - Fixed a train consistency issue when interrupt triggers inside of another interrupt in certain cases. (https://forums.factorio.com/116845, https://forums.factorio.com/117585, https://forums.factorio.com/117717)
    - Fixed space platform losing its paused state when it arrived to a planet drifting backwards. (https://forums.factorio.com/118123)
  Modding:
    - Added LoaderPrototype::frozen_patch_in and frozen_patch_out.
---------------------------------------------------------------------------------------------------
Version: 2.0.11
Date: 25. 10. 2024
  Features:
    - [space-age] Asteroid collector filters can be modified by blueprint parametrisation.
    - Programmable speaker can be modified by blueprint parametrisation.
    - When imported blueprint is placed, assembling machines will be configured with the recipe even when recipe is not yet researched.
  Changes:
    - [space-age] Fulgora ruins now also drop iron sticks when mined so electric poles could be crafted without recyclers at the start.
    - [space-age] The "Custom minimum payload" slider for orbital logistics now offers more sensible values.
    - [space-age] Orbital logistics "Custom minimum payload" is now checked against largest possible payload before setting the filter.
    - [space-age] Cargo bays will show a warning icon when they are not connected to a Hub or Landing Pad.
  Optimizations:
    - Improved performance of technology GUI when viewing only essential technologies. (https://forums.factorio.com/117044)
  Bugfixes:
    - Fixed a crash when construction robots attempt to deliver modules in the same tick the target entity is destroyed. (https://forums.factorio.com/116791)
    - Fixed that biter base menu simulation had more decoratives over the Wube logo than desired. (https://forums.factorio.com/116882)
    - Tips simulation fixed with minor changes to texts (https://forums.factorio.com/116394 https://forums.factorio.com/116854 https://forums.factorio.com/116442)
    - Fixed that the map editor couldn't change the spawn point of a force after it was set. (https://forums.factorio.com/116966)
    - Fixed that the game would hang when closing the load game menu if the number of mods in the mods directory was too large on Linux. (https://forums.factorio.com/116561)
    - Fixed incorrect pump speed reporting when pumping into a fluid wagon. (https://forums.factorio.com/116492)
    - Fixed that pumps could not pump into a fluid wagon at full speed. (https://forums.factorio.com/116492)
    - Fixed that inserters could get stuck if the crafting machine they're interacting with dies and is rebuilt. (https://forums.factorio.com/116972)
    - Fixed a performance issue with ghost building. (https://forums.factorio.com/117023)
    - Fixed achievement nucear-power to require building nuclear reactor. (https://forums.factorio.com/116730)
    - Fixed a possible exploit of using parametrised blueprint to set unlocked recipes in assemblers. (https://forums.factorio.com/117063)
    - Fixed that players in remote view were unable to open menu when the game was paused. (https://forums.factorio.com/116472)
    - Fixed turrets sometimes being marked for deconstruction and rebuild if trying to upgrade through overbuilding.
    - Fixed position of car driven by local player would be delayed on minimap in multiplayer.
    - Fixed a crash related to rocket silos when adding and removing mods. (https://forums.factorio.com/117067)
    - Fixed that zooming with buttons(keyboard or controller) would not zoom to pixel-perfect values.
    - Fixed a crash when reading cursor record of a character not assigned to a player. (https://forums.factorio.com/116926)
    - Fixed that building with modded items did not work correctly in all cases. (https://forums.factorio.com/116862)
    - Fixed a crash when merging forces related to chart tags. (https://forums.factorio.com/116931)
    - Fixed that blueprinted containers would loose their settings when overbuilt over container without those settings (https://forums.factorio.com/116130)
    - Fixed a crash when setting roboport requests to a negative value. (https://forums.factorio.com/116996)
    - Fixed RecipePrototype::maximum_productivity was allowed to be negative. (https://forums.factorio.com/117026)
    - Fixed rail description would suggest toggle rail layer binding when elevated-rails mod was disabled. (https://forums.factorio.com/116885)
    - Fixed blueprints being able to produce two overlaying ghosts of tiles with the same placing item (like hazard-concrete-left/right)
    - Fixed technology GUI not updating technology cost label if the technology didn't have any science packs. (https://forums.factorio.com/117237)
    - Fixed reading LuaTechnologyPrototype::research_trigger could throw an error. (https://forums.factorio.com/117279)
    - Fixed modules technology icon when quality mod is disabled. (https://forums.factorio.com/117284)
    - Fixed MapGeneratorGui would not enable reset to defaults button when changing technology price multiplier. (https://forums.factorio.com/116864)
    - Fixed PVP scenario not having starting area protection enabled when the last player of that force logged out. (https://forums.factorio.com/117028)
    - Fixed use-item-groups had no effects. (https://forums.factorio.com/117367)
    - Fixed a crash when trying to render a surface which doesn't exist in a simulation. (https://forums.factorio.com/117359)
    - Fixed crashes caused by calling missing library symbols on older macOS versions. (https://forums.factorio.com/116227)
    - Fixed a crash when deleting chart tags while they're selected in the chart search result. (https://forums.factorio.com/118143)
  Modding:
    - Added AssemblingMachinePrototype::disabled_when_recipe_not_researched.
  Scripting:
    - Added LuaEntity::insert_plan and LuaEntity::removal_plan read/write.
    - Added removal_plan parameter to LuaSurface::create_entity for item request proxies.
---------------------------------------------------------------------------------------------------
Version: 2.0.10
Date: 23. 10. 2024
  Features:
    - [space-age] Galaxy of fame. Offered when the game is finished. (https://www.factorio.com/galaxy)
    - Added flying text for more cases of unsuccessful resource mining.
  Changes:
    - Non-blocking saving setting is no longer synced over the Steam cloud.
  Bugfixes:
    - Fixed that blueprint book tooltips did not look correct when in the quickbar. (https://forums.factorio.com/116593)
    - Fixed that movement speed bonus equipment would show garbage values when low on energy. (https://forums.factorio.com/116433)
    - Fixed that some fluid-only recipes would allow quality modules. (https://forums.factorio.com/116424)
    - Fixed that the "kill with artillery" achievement did not work with artillery wagons. (https://forums.factorio.com/116517)
    - Fixed invalid package name in sprite path definition would result in OS error message dialog instead of loading into minimal mode. (https://forums.factorio.com/116210)
    - Fixed that continue host menu option didn't respect the port from the config. (https://forums.factorio.com/111288)
    - From now on, we wont save blueprint-storage to a file when it was not used yet. This might help preventing cloud storage file by a file representing empty blueprint storage. (https://forums.factorio.com/113198)
    - Fixed that the blueprint setup GUI would always confirm to discard changes even if nothing changed when the blueprint had a description. (https://forums.factorio.com/116285)
    - Leaked D3D device and swap chain in attempt to avoid AMD driver crash when closing the game. (https://forums.factorio.com/108367)
    - Fixed LogisticContainerControlBehavior exclusive mode could get out of sync from the ContainerControlBehavior it derives from. (https://forums.factorio.com/116669)
    - Fixed that the debug settings GUI could get stuck behind the normal game logic. (https://forums.factorio.com/116413)
    - Fixed that the elem_tooltip type of "signal" did not work correctly. (https://forums.factorio.com/116650)
    - Instead of aborting when SDL_DXGIGetOutputInfo call fails, the game will try to initialize D3D device using adapter 0. (https://forums.factorio.com/109955)
    - Fixed crashes when using LuaEntity fluid methods when the entity's fluidboxes were not part of a segment. (https://forums.factorio.com/116093)
    - Fixed that LuaEntity::insert_fluid would not work on the output FluidBoxes of a crafting machine.
    - Fixed removal of transport belts under cursor which would be normally fast-replaeable while drag traversing underground gap by belt rebuilding. (https://forums.factorio.com/113128)
    - Fixed arithmetic combinator's first constant would not be proposed as parameter. (https://forums.factorio.com/116716)
    - Fixed that on_entity_logistic_slot_changed did not fire for constant combinators. (https://forums.factorio.com/116575)
    - Fixed a crash in the space platform hub GUI when the inventory size changes at the same time as the limit is changed. (https://forums.factorio.com/116597)
    - Fixed turbo underground belts simulation in factoriopedia. (https://forums.factorio.com/116695)
    - Fixed a crash when a segmented unit entity causes the entire segmented unit to die. (https://forums.factorio.com/116551)
    - Fixed a crash when a platform was traveling to the shattered planet using a temporary stop which expired. (https://forums.factorio.com/116763)
    - Fixed fluid conditions not showing fluid amounts. (https://forums.factorio.com/116686)
    - Fixed using a custom surface in PvP was preventing Space Age progression. (https://forums.factorio.com/116513)
    - Fixed a crash when switching preferred audio output device while a variable music track is playing. (https://forums.factorio.com/116785)
    - Fixed train stop GUI being too wide at some smaller resolutions. (https://forums.factorio.com/116621)
    - Fixed driven car being drawn on all surfaces in latency. (https://forums.factorio.com/116587)
    - Fixed dying enemy would not randomize direction of its dying animation.
    - Fixed that failed achievement wasn't gettable again without restarting the game. (https://forums.factorio.com/116329)
    - Fixed a crash when defining planet prototypes that don't contain any resources. (https://forums.factorio.com/116849)
    - Fixed logistic section active state was not preserved in a blueprint string. (https://forums.factorio.com/116775)
    - Fixed a crash when showing some modded GUI tables. (https://forums.factorio.com/116735)
    - Fixed an issue where entity flagged as not mineable could be marked for deconstruction using undo.
    - Fixed pumpjacks with low yield would show 0 output rate in the tooltip. (https://forums.factorio.com/116179)
    - Fixed Nauvis elevation dropdown missing in map generator GUI, causing incorrect previews from map exchange strings. (https://forums.factorio.com/116303)
    - Fixed that it wasn't possible to parametrise virtual signals and space locations contained in text. (https://forums.factorio.com/116292)
    - Fixed brightness and contrast sliders being reset to 0 when setting the text field to a negative value. (https://forums.factorio.com/116613)
    - Fixed that it wasn't possible to parametrise entities, virtual signals and space locations contained in text. (https://forums.factorio.com/116292)
---------------------------------------------------------------------------------------------------
Version: 2.0.9
Date: 22. 10. 2024
  Changes:
    - Achievement logistic-network-embargo updated with different condition for base game and space age.
  Bugfixes:
    - Fixed a crash when viewing the production statistics GUI while switching surfaces. (https://forums.factorio.com/116084)
    - Fixed unstable global grid position when re-assigning blueprint. (https://forums.factorio.com/111005)
    - Fixed that individual segmented units parts were in the kill statistics.
    - Fixed a crash when opening the technology GUI focused on disabled technology. (https://forums.factorio.com/116243)
    - Fixed migration of rails in blueprints in 1.1 version of blueprint library. (https://forums.factorio.com/116106)
    - Fixed a crash when trying to use unsupported audio depth. (https://forums.factorio.com/116218)
    - Fixed a crash when loading some blueprint library contents with mods changed. (https://forums.factorio.com/116014)
    - Fixed a crash when clicking "upgrades" in the wave defense scenario. (https://forums.factorio.com/116320)
    - Fixed Spidertrons receiving up to 8 times extra damage from explosives. (https://forums.factorio.com/116246)
    - Fixed that unpowered inserters could grab items.
    - Fixed that some GUIs could be opened behind the technology GUI. (https://forums.factorio.com/116252)
    - Fixed crash in multiplayer when mining modded tree with less stump variants than alive tree variants.
    - Fixed it was not possible to open loader gui for input loader. (https://forums.factorio.com/116297)
    - Fixed crash in mod manager in minimal mode when some text used space-age icon rich text tag.
    - Fixed that changing surfaces with ghost equipment would not correctly request robots to deliver the equipment. (https://forums.factorio.com/116146)
    - Fixed build sound of huge ghost entities not being ghostly enough. (https://forums.factorio.com/116219)
    - Fixed a crash when item entity marked to be deconstructed is cancel deconstructed while being over belt. (https://forums.factorio.com/116374)
    - Fixed that the runtime server config GUI did not fit on some screen sizes. (https://forums.factorio.com/116398)
    - Fixed GUI effects volume set to zero not being applied on start if background simulations were turned off. (https://forums.factorio.com/116461)
    - Fixed a crash when setting cursor_ghost of a character not assigned to a player. (https://forums.factorio.com/116484)
    - Fixed a crash when reading opened GUIs of a character not assigned to a player. (https://forums.factorio.com/116516)
    - Fixed PvP Scenario unlocking all the trigger technologies. (https://forums.factorio.com/116251)
    - Fixed a crash when changing the force of cargo landing pads.
    - Fixed tools items and ammo items could be refilled during cursor split interaction. (https://forums.factorio.com/116420)
    - Fixed that it was not possible to mark legacy rails for deconstruction using deconstruction planner configured for straight-rail. (https://forums.factorio.com/116386)
    - Fixed that the Fulgora starting island could have no breaks in the cliffs. (https://forums.factorio.com/116574)
    - Fixed that deconstruction planner would treat entities with deconstruction alternative as being normal quality.
    - Fixed crash when running out of disk space when saving preview for a save file.
    - Fixed that passive provider and active provider logistic points could have sections added through the Lua API. (https://forums.factorio.com/116137)
    - Fixed that space platform schedule changes didn't update last user of the space platform hub. (https://forums.factorio.com/116560)
    - Fixed a crash when enabling snap-to-grid when a blueprint had no contents. (https://forums.factorio.com/116321)
    - Fixed that filter inserter was visible in technology icon for fast inserters.
    - Fixed that a buffered rocket would briefly render lights south of the rocket silo. (https://forums.factorio.com/116132)
    - Fixed commas and quality icons not allowed in save file names. (https://forums.factorio.com/116236)
    - Fixed crashes when viewing alerts for entities that then die. (https://forums.factorio.com/116481)
    - Fixed incorrect surface condition of a space platform hub. (https://forums.factorio.com/116467)
---------------------------------------------------------------------------------------------------
Version: 2.0.8
Date: 21. 10. 2024
  Bugfixes:
    - Fixed a crash when changing decider combinator conditions or outputs in latency in some cases.
    - Fixed a crash when sending a platform with no thrust to a planet and then removing the stop. (https://forums.factorio.com/116133)
    - Fixed a crash when robots try to station in a full roboport because their stack size changed.
    - Fixed a crash in path finder when migrating 1.0 save files to 2.0.
    - Fixed orbital drop slots not counting towards Item count wait condition.
    - Fixed space platforms not respecting peaceful and no enemy modes.
    - Fixed a crash when downloading multiple mods fails.
    - Fixed a crash when clicking "play" while the map preview was running. (https://forums.factorio.com/116202)
    - Fixed a crash when drawing a spider leg with length 0. (https://forums.factorio.com/116034)
    - Fixed error in loading 1.1 version of blueprint library would prevent starting new map or loading a save. (https://forums.factorio.com/116217)
    - Fixed crashes around the Explore Mods GUI with intermittent network connectivity.
    - Fixed a crash when viewing a single-product recipe with no main product in Factoriopedia.
    - Fixed a crash when pathfinding with a rotated bounding box. (https://forums.factorio.com/115524)
---------------------------------------------------------------------------------------------------
Version: 2.0.7
Date: 20. 10. 2024
  Major Features:
    - [space-age] Added space platforms, which can request items to be delivered by rockets and used to deliver cargo between planets. (https://factorio.com/blog/post/fff-381)
    - [space-age] Added new planet Vulcanus, a volcanic planet with new resources, structures, items, recipes and technologies focussed on metallurgy. (https://factorio.com/blog/post/fff-386, https://factorio.com/blog/post/fff-387)
    - [space-age] Added new planet Gleba, a swampy planet with new resources, structures, items, recipes and technologies focussed on agriculture. (https://factorio.com/blog/post/fff-413, https://factorio.com/blog/post/fff-414)
    - [space-age] Added new planet Fulgora, a stormy desert planet with new resources, structures, items, recipes and technologies focussed on elecromagnetism. (https://factorio.com/blog/post/fff-398, https://factorio.com/blog/post/fff-399)
    - [space-age] Added new planet Aquilo, a freezing planet with new resources, structures, items, recipes and technologies focussed on cryogenics.
    - [space-age] Introduced quality, which is additional property of item, entities and equipment. (https://factorio.com/blog/post/fff-375)
      Most entities, equipment, modules and ammo have various kind of bonuses with higher quality.
    - [space-age] Added rail ramps, rail supports and elevated rails to build bridges. (https://factorio.com/blog/post/fff-378)
    - [space-age] Added stack inserters (previous stack inserters are called bulk inserters now) which can load transport belts with layered stacks of items. (https://factorio.com/blog/post/fff-393)
    - New rail shapes, rail curves, 22.5 degree tracks.
    - Added Train interrupts (https://factorio.com/blog/post/fff-389, https://factorio.com/blog/post/fff-395)
      Trains can have number of interrupts, each interrupt has conditions and set of stops.
      Whenever is the train leaving a station, the first interrupt with fulfilled condition is activated, which adds its stations
      as temporary items into the schedule.
    - Added Train groups. (https://factorio.com/blog/post/fff-389)
      Train name is editable and trains with the same name are considered to be in the same group.
      Editing schedule of a train automatically updates schedules of all the trains in the same group.
    - Added Logistic groups. (https://factorio.com/blog/post/fff-382)
      Logistic group is editable for logistic points (Requester chest, Roboport, Character, Spidertron, etc.).
      Editing the requests of a logistic point automatically updates requests of all the points in the same group.
    - Added Factoriopedia. (https://factorio.com/blog/post/fff-397)
      It provides detailed information about different kind of objects.
      Alt clicking any relevant gui element or game entity opens the related page.
    - Forced building will now automatically adds missing landfill or other other tiles based on context.
    - Added super forced building mode. Ctrl + Shift + Build marks for deconstruction player's colliding entities and replaces ghosts and tiles. (https://factorio.com/blog/post/fff-383)
    - Added search to the remote view. It allows to do surface wide search for recipe production, resources and train stations and map tags. (https://factorio.com/blog/post/fff-400)
    - Blueprint parametrisation. Allows to make more generic bluprints, which are configured upon building. (https://factorio.com/blog/post/fff-392)
  Features:
    - Rail planner is usable in the map (remote view). (https://factorio.com/blog/post/fff-403)
    - Added smart dragging of underground belts and pipes.
    - Added a toggle to show pipelines on the map.
    - Added the option to pin positions, entities, alerts or search results, and keep track of their location. (https://factorio.com/blog/post/fff-400)
    - Entity ghosts are now buildable on water if the landfill ghosts are already there.
    - Added a third graph to the electric network overview to track the charges of accumulators over time. (https://factorio.com/blog/post/fff-408)
    - Added a new alert for construction and logistic robots that can't find free space in a roboport.
    - Added a new alert for trains failing to pathfind to their target. (https://factorio.com/blog/post/fff-395)
    - Added a new alert for turrets running out of ammunition. It only sounds once right when the ammo is used up.
    - Added fuel condition to the train schedule.
    - Added condition to the train schedule to check whether a specific station is full or not.
    - Added an option for a locomotive to update its color automatically based on the color of the target train stop. (https://factorio.com/blog/post/fff-389)
    - Smarter worker robot scheduling.
      Worker robots have task queue now which allows the planner to choose the robot that will be able
      to get to the destination fastest, even if it is doing something else at the moment.
    - Robot requests in roboports.
    - Added Flipping as a primary action to flip entities horizontally or vertically. Works on items in hand
      placed on the surface or ghosts. AssemblingMachines can now be mirrored by flipping them, allowing
      additional fluid box configurations. Bound to F (Horizontal) & V (Vertical) by default.
    - Upgrade planner can install new modules into machines, this is done by leaving the source slot empty
      and setting up only the destination slot.
    - Upgrade planner module upgrade/install can have machine filter and maximum count per machine specified.
    - Upgrade planner now has dynamic size, similar to the blueprint library. The size is capped at 250 rows now.
    - Added a way to create module/fuel requests in entities remotely by clicking with ghost item in hand. (https://factorio.com/blog/post/fff-380)
    - All turrets (except for artillery) can now be configured individually to prioritize certain types of enemies when looking for targets. (https://factorio.com/blog/post/fff-410)
      The priority settings can be copy-pasted between the different turret types and can be configured through the circuit network.
    - Added latency hiding for cars (and tanks).
    - Rocket silos continue producing parts for the next rocket while the current rocket is being launched. Completing another rocket soon enough skips closing and reopening the doors. (https://factorio.com/blog/post/fff-405)
    - Improved the way spidertrons are remotely controlled.
      Instead of spidertron remote being linked to single spidertron, it can be used to group select and command spidertrons like in your typical RTS game.
    - Spidertrons can be entered remotely, so you can control them as if you were inside physically, so switching the map on/off doesn't distrubt the mode.
    - Allowed opening and configuring entities through remote view. (https://factorio.com/blog/post/fff-380)
  Ease of use:
    - Added green indicator (instead of yellow), when previewing underground belt/pipe on its maximal distance. (https://factorio.com/blog/post/fff-388)
  Circuit Network:
    - Added selector combinator. It allows to select one of the signals, or the signal count from an input.
    - Added editable description to combinator entities.
    - Decider Combinators are now allowed to check multiple conditions and send multiple outputs per combinator.
    - Arithmetic combinator now allows to select red and green networks for input signals and perform Each-Each operations.
    - Signal pipetting.
    - Added display panel. 1X1 entity which can show specified icon and/or text, possibly also on the map. It can be also controlled by the circuit network. (https://factorio.com/blog/post/fff-419)
    - Transport belt connected to a circuit network can now read contents of the whole segment instead of just the one tile. (https://factorio.com/blog/post/fff-405)
    - Roboports can read logistic network contents and requests. (https://factorio.com/blog/post/fff-428)
    - Roboports can output the number of roboports in the logistic network to the circuit network. (https://factorio.com/blog/post/fff-428)
    - Logistic Chests have an optional circuit condition to enable / disable their connection to the network. (https://factorio.com/blog/post/fff-428)
    - Rocket silo is connectable to circuit network, and allows to read its contents.
    - [space-age] Rocket silo circuit connection can read orbital requests.
    - All turrets (including artillery) can now be connected to the circuit network to read their current ammo count and/or deactivate them. (https://factorio.com/blog/post/fff-410)
    - Assembling machines, chemical plants, oil refineries and centrifuges can now send the ingredient list of their recipes to the circuit network.
    - Drag building electric poles will also drag circuit wires when starting from electric pole with already connected circuit wires.
    - When electric pole is removed, it will rewire circuit wires similar to copper wires.
    - Cut/copy pasting blueprint with external circuit wire connections will preserve these connections when the blueprint is built (if possible). (https://factorio.com/blog/post/fff-402)
    - Radar can now be connected to circuit network, allowing to wirelessly transmit a single channel of red and green signals on each planet/surface. (https://factorio.com/blog/post/fff-402)
    - Added a way to read nuclear reactor temperature through the circuit network. (https://factorio.com/blog/post/fff-428)
  Minor Features:
    - Added "No enemies" setting that disables enemy unit spawning from enemy spawners, map gen, and items. Does not disable enemy spawners.
    - Upgrade planner can upgrade fuel in blueprints (yet to be implemented for existing entities).
    - Added cargo pods that move items from platforms to landing pads.
    - Added a warning when a save game is too large to sync via the Steam cloud.
    - Added PipeWire audio driver.
    - Added a setting to select the preferred audio driver on Windows and Linux.
    - Undo improvements. Undo actions older than 1 minute require confirmation +flying text notification of what was undone.
    - Added redo.
    - Allow undoing of module changes done via upgrade planner.
    - Allow undoing of copy-pasting entity settings like assembler recipes or inserter filters. (https://factorio.com/blog/post/fff-412)
    - Allowed lamps color to be configured manually.
    - Manual building in latency state now tracks used items.
    - Manual building previews will now highlight ghosts that would be removed.
    - Blueprints with entities and landfill are now one-click buildable over water.
    - Added icons for tileable blueprints, like "Curve, Corner, T junction, X junction" and similar, in Virtual signals category.
    - Evolution factors are now tracked individually for each surface.
    - Pumps now can have a fluid filter. If present, only the specified fluid is taken from the pump's source.
    - Electric poles are no longer limited to 5 copper connections to other electric poles.
    - Removed some of the abstract items (red wire, green wire, discharge defense, artillery remote, spidertron remote) and replaced them with shortcut bar tools which can be used anytime for free. (https://factorio.com/blog/post/fff-379)
      These tools can still be placed into the quickbar if desired.
    - The smart pipette can also pick terrain and using it on fluid select the offshore pump.
    - The smart pipette can also pick items from crafting, logistic, select list, inventory and quickbar.
    - Disabling train stop no longer sends ongoing trains away. Disabled train stop is now considered full and trains will not skip schedule records.
    - Map tags can be moved. (https://factorio.com/blog/post/fff-388)
    - Map tags can be quickly copied using pipette. (https://forums.factorio.com/47822)
    - Map tags and pings can be placed while zoomed in to game view.
    - Spidertrons can be damaged by cars and tanks, can be damaged by walking on fire, and can be slowed with slowdown capsules.
    - Switching to the map editor using /editor now places the player at the position they were looking at in remote view. Switching out of the map editor returns the character to the position it was when entering.
      Added editor options to individually revert these changes to their previous behavior.
    - Numerical textfields accepts values with postfix formats (10k instead of 10000 etc), simple math expressions, like 3*7+7k are also possible.
    - Added logic to hide previews for buildable items if fast-transfer modifiers (default: Ctrl) are pressed. Doesn't apply to blueprints or when rail planner is active.
    - Improved the AI of the worker flying robots when it comes to choosing roboport to recharge.
      It prefers roboports closer to its destination, so (for example) it won't get stuck over lakes forever.
    - When you retrieve your corpse, the logistic requests will re-enable if they were enabled before death.
      (Related to the already existing behaviour, where the requests are disabled upon death, to avoid unwanted supply)
    - Dedicated servers will stay paused until the first player is fully connected (if auto-pause is enabled).
    - Added an option to auto-pause servers while any player is connecting (defaults to false).
    - Added several new achievements both to the base game and space age.
    - When renaming a train stop, it will try to copy its color from an existing stop with that name.
    - Added control inputs (Ctrl/Shift + Arrow keys) to adjust blueprint grid alignment.
    - Train stop can be given a priority, trains will prefer going to the train stop with higher priority and it will be easier for them to depart from such train stop. (https://factorio.com/blog/post/fff-395)
    - Allow copy-pasting of setting for trains and train stops while in chart view. (https://factorio.com/blog/post/fff-403)
    - Crafting machines can craft more than 1 recipe per tick if their speeds are fast enough.
    - Improved the ultra-wide monitor experience by greatly increasing the maximum view distance based on the game window's dimensions.
    - Added "sync-mods" command line option to sync mods with a given save file.
    - Trains with non-empty schedule are automatically switched into automated mode upon completition.
    - The spidertron inventory is automatically sorted.
    - Added a browse history feature. Pressing ALT + arrow keys (or the arrow button on the right top of the window), can go back and forth through what was opened. (https://factorio.com/blog/post/fff-397)
    - Added 8 directional arrows to virtual signals. Also added red cross signal next to the checkmark.
    - Added a super forced mode for deconstruction planner: when selecting area while holding Ctrl + Shift (by default) deconstructs everything (deconstructible and not filtered out), i.e. entities, tiles and hidden tiles
    - Added a reverse mode for deconstruction planner: when selecting an area using right-click, the white-/blacklist setting for entity and tile filters will be reversed for this selection.
    - Added a nondefault tile cover cache - last used cover tile is being saved per surface per force per tile id being covered. For most intents and purposes, those values act the same as default covers defined by covered tile prototype (for tiles without default cover defined).
    - The storage filter of logistic storage chests can now be copy-pasted.
  Optimizations:
    - Added automatic splitting of repeated noise expressions into separate procedures which increased map generation speed.
    - Improved C++ structure of noise expressions which reduced game start-up time and MapGenSettings compilation time.
    - Improved worker robot performance, they are not updated every tick when moving or stationary anymore. (https://factorio.com/blog/post/fff-421)
    - Improved performance of idle roboports. (https://factorio.com/blog/post/fff-421)
    - Improved radar charting speed. (https://factorio.com/blog/post/fff-421)
    - Improved circuit network logic by making it fully multithreaded.
    - Changed Spidertron walking strategy to deliberately alternate legs and be overall more efficient and performant.
    - Changed train wait condition evaluation order to check 'cheap' conditions (e.g. wait time) before 'expensive' conditions (e.g. inventory) within a set of "and"-connected conditions.
  Graphics:
    - Changed night vision effect from grayscale to a more contrasty one.
    - Added decay stages for enemies. (Biters, Spitters, Worms, Spawners)
    - Reworked die animations, now they have more gore to transition into the decay stages better.
    - Reworked fire animations, improved quality and increased resolution.
    - Reworked rocket projectile animations
    - Fixed copper and circuit wires appearing to sag below the perceived ground level.
    - Fixed copper and circuit wire shadows projecting onto the ground incorrectly.
  Sounds:
    - Improved sounds of dying enemies.
    - Added different sounds for manipulating different items in the inventory and opening different entities. (https://factorio.com/blog/post/fff-396)
    - Added different sounds for shooting different kind of targets.
    - Added ambient sounds. (https://factorio.com/blog/post/fff-396)
    - Added semi-persistent ambient sounds.
    - Added support for sound accents for entities' working_sound. These are short sounds which play at a specific moment in the entity's animation.
    - Added support for multiple main sounds for entities' working_sound.
    - Extended support for aggregation to most sounds.
    - Added controls to skip current music track, go back to previous one and to pause/resume music.
    - [space-age] Added new music. (https://factorio.com/blog/post/fff-406)
    - Added variable music. (https://factorio.com/blog/post/fff-407)
  Balancing:
    - Diminishing return of beacons effect (https://factorio.com/blog/post/fff-409)
    - Lowered Fluid pumping speed from 12 000 to 1 200.
    - Altered the mining drill bounding box, so you can walk between mining drill and substation and such.
    - Lowered stack size of ammo from 200 to 100.
    - Increased fluid wagon capacity from 25000 to 50000 to make fluid wagons more compelling compared to the new pipe mechanics.
    - Increased low density structure stack size from 10 to 50.
    - Increased beacon stack size from 10 to 20.
    - [space-age] Rocket part takes 10 times less ingredients than before.
    - [space-age] Rocket silo requires 50 rocket parts to craft a rocket instead of 100.
    - Biter spawner health grows with evolution, up to 10 times with maximum evolution.
    - Increased health of bigger worms, and added a laser resistance to them.
    - Removed the 15% explosion damage resistance from biter spawners.
    - Doubled the damage of artillery.
    - Nerfed personal laser defense damage output to 1/3 its previous output.
    - Changed all module-3 recipe to require only 4 (instead of 5) module-2 ingredients.
    - Greatly increased default tile pollution absorption.
    - Increased rocket fuel stack size from 10 to 20.
    - Decreased the crafting time of rocket ingredients.
    - Decreased the crafting time of solid fuel.
    - Increased damage and range of non-explosive cannon shells.
    - Doubled the distractor robot health from 90 to 180 and life time from 45s to 90s.
    - Increased destroyer robot base damage from 10 to 20 and range from 15 to 20.
    - Increased damage of shotgun pellets from 5 to 8, and made shotgun projectiles spawn closer to the player.
    - Increased battery capacity of construction robot from 1.5MJ to 3MJ.
    - Rocket (ammo) no longer requires an electronic circuit to be crafted.
    - Rocket and Explosive rocket projectiles accelerate twice as fast.
    - Changed the rocket recipe to require only processing unit instead of rocket control unit. Rocket control unit was removed from the game.
  Changes:
    - Reworked the fluid system flow logic. (https://factorio.com/blog/post/fff-416)
      Contiguous sections of pipes and storage tanks are merged into segments.
      Each segment contains a single fluid, and throughput is proportional to how full a segment is.
    - Removed Filter and Stack filter inserter, instead all inserters can use filters now.
    - Character corpses no longer despawn.
    - Merged zoom controls and removed functionality to zoom in without leaving chart view.
    - Kovarex enrichment process is now unlocked by automation, logistic and chemical science pack only.
    - Power armor equipment grid resized from 7x7 to 6x8 to be a bit more practical.
    - Power switch and Programmable speaker stack size reduced from 50 to 10.
    - Big and huge rock doesn't drop stone items when destroyed anymore.
    - 1 Water will now produce 10 Steam in boilers/heat exchangers.
    - Boilers will respect conservation of energy by considering heat capacity of input and output fluids.
    - Improved high-DPI display support on Windows to match that of Retina displays on macOS.
    - Removed the "fuzzy search" setting.
    - Updated SDL to version 2.30.0.
    - Smart belt building was slightly improved, so it makes the underground also when overbuilding belt gap with belts already present on both sides.
    - Trains will not skip stations that do not have any valid stops, they will 'no path' instead.
    - Trains with artillery wagons now need to wait for all cannons to be in fully their parked position before departing.
      When driving manually, keep holding accelerate to command the artillery to stop firing and assume their parked position.
    - Improved Apple Retina display support throughout the game.
    - Made manual UI scale setting visually consistent between Retina and non-Retina displays, and between native resolution rendering setting being enabled and disabled.
    - Default control key for Map changed from M to Tab or M.
    - Default control key for Next weapon changed from Tab to C.
    - Default control key for Shoot selected changed from C to Shift+Space.
    - Default control key for Toggle personal roboport changed from Alt + R to Alt + F.
    - Added event-based technologies for unlocks related to the early game.
    - Added event-based technologies to only allow to research the oil related and uranium related technologies after the related resource had been mined.
    - Switching to map view switches to remote controller now, which allows to open and setup entities even when they are far away.
    - Chunks under fog of war are covered even in normal view.
    - Default train connect key is now J, train disconnect key is now K and vertical flip is now V.
    - Allowed electric poles to be fast-replaced by moving.
    - Allowed entity ghost-building over tile ghosts.
    - Allowed landfill mining.
    - Underground belts and pipes-to-ground connections can be blocked by certain tiles.
    - Disabled loading of saves before 1.0.0 version (You can use 1.1 to load older saves and re-save them).
    - Changed the /evolution command to respect the now Surface-based evolution tracking. Provide a Surface's name as parameter to get its evolution factor, or leave blank to get a full list.
    - Locomotive fuel inventory is now accesible by inserters, so it can be unloaded automatically.
    - Changed module limitations for recipes from item-based to effect-based. A module can't be placed into a machine if the current recipe doesn't support one of the effects.
    - Changed "use item" (grenades, artillery remote, capsules) to its own control and changed the default to right mouse button.
    - Improved heuristic of robots selecting roboports to charge/station.
    - Changed selection logic of entity ghosts. They now behave as if they were real entities already.
    - Car collisions impact on speed reworked (destroying obstacles now slows the car less than before).
    - Added one more color to robot overview on the map (red = logistic robots targeted to me, to deliver or to trash).
    - [space-age] Launching space science pack into space no longer returns fish as there is now an other method to automate obtaining fish.
    - Changed command-line map preview to match GUI map preview, including correct overlapping ore generation and cliffs.
    - Changed --report-quantities option to report total entity count and resource amount in the selected area instead of approximate values.
    - Removed --map-preview-scale, --slope-shading, --slope-shade-property and --noise-outputs command-line options.
    - Ghost pipes are now connecting to other pipes.
    - When train has no fuel, player can manually move the train slowly when it is manually controlled. (https://factorio.com/blog/post/fff-403)
    - Increased Big electric pole maximum wire reach from 30 to 32.
    - Electric poles are always crafted from copper wire instead of copper plates.
    - Removed sandbox scenario.
    - Tweaked most of the tips trigger and skip trigger logic, added new tips. Added the ability to show animated UI related tips.
    - MapTick is now 64 bit.
    - Disabled the turret shooting alert by default.
    - Remnants of destroyed player buildings do not disappear after a while any more.
    - Increased the number of chunks generated around players based on the maximum view distance.
    - Steam Cloud sync for blueprint library is enabled by default now, and library is saved to blueprint-storage-2.dat.
    - Changed pipe to ground collision mask so player can walk on top of it.
    - Using the pipette on an entity marked for upgrading now picks the result of the upgrade instead of the existing entity.
    - Rotating (and flipping) already built entities is now allowed at any distance.
  Gui:
    - Added Players screen (accessible from the side menu), where each of the player can be inspected. (https://factorio.com/blog/post/fff-423)
    - Added click-and-drag to rearrange logistic requests within a section.
    - Changed spidertron gui to have 3 panels instead of two when the flat character gui settings is selected (which is by default).
    - The spidertron grid is opened by a button instead of a tab.
    - Improved the tooltips of the graph, to actually explain what is the relationship of the two numbers displayed.
    - Production and electric network graphs now highlight the corresponding line if an item's slot is hovered in the list below.
    - Fixed technology graph UI not properly scaling with UI scale.
    - Fixed heat exchanger glow sprite was drawn above the character sprite. (https://forums.factorio.com/110542)
    - Fixed a minor bug in the fluid movement calculation, which didn't take the volume of the container into considaration properly.
    - Restructured all the circuit condition windows.
    - Circuit and logistics condition windows can be opened at the same time.
    - New logistic networks GUI. (https://factorio.com/blog/post/fff-405)
    - Added Arrow Up/Down keys support when searching in a listbox.
    - The trains stop gui contains a list of trains on the way to this stop (https://factorio.com/blog/post/fff-403).
    - Added option switch save game sorting by either name or last modified state.
    - Added a notification of researched technology.
    - Research widget has a tooltip which shows the research production graph for the last 10 minutes. (https://factorio.com/blog/post/fff-423)
    - Alert gui now allows specific selection of the problem we want to move to. (https://factorio.com/blog/post/fff-400)
    - Circuit conditions for trains now show precise progress in the GUI if it makes sense for the condition.
    - Changed sorting of technologies in technology list to put infinite technologies at the back.
    - The buttons for circuit and logistic control settings of entities are now always visible if the entity supports them.
  Modding:
    - Added global feature_flags in the settings and prototype stages.
    - Added BeaconPrototype::allowed_module_categories, CraftingMachinePrototype::allowed_module_categories,
      LabPrototype::allowed_module_categories, MiningDrillPrototype::allowed_module_categories, and
      RecipePrototype::allowed_module_categories.
    - Replaced the map generator water slider with an autoplace control prototype; water_level and segmentation_multiplier are now noise expressions.
    - Removed pre-defined noise variables finite_water_level, wlc_elevation_offset, wlc_elevation_minimum, cliff_elevation_offset,
      terrace_elevation_offset, terrace_elevation_interval. Added cliff_elevation_0.
    - Added EntityWithHealthPrototype::overkill_fraction.
    - Removed AutoplacePeak specification format.
    - Added AmmoItemPrototype::shoot_protected.
    - Removed ItemPrototype::rocket_launch_product. Use rocket_launch_products instead.
    - Moved FluidBoxManagerPrototype::off_when_no_fluid_recipe up to AssemblingMachinePrototype::fluid_boxes_off_when_no_fluid_recipe.
    - Added delayed-active-trigger ActiveTrigger type.
    - Added ability to attach a SmokeWithTrigger to a target entity and make it fade when the target entity is destroyed.
    - Added time-based cooldowns to TriggerEffectWithCooldown.
    - Removed ContainerPrototype::enable_inventory_bar.
    - Added ContainerPrototype::inventory_type "normal".
    - Added LinkedContainerPrototype::inventory_type "normal".
    - Added ItemPrototype::send_to_orbit_mode.
    - Renamed ItemPrototype::placed_as_equipment_result to place_as_equipment_result to match the runtime name.
    - Removed BurnerEnergySource::fuel_category. Use BurnerEnergySource::fuel_categories instead.
    - Removed slice, slice_x and slice_y from Sprite and RotatedSprite.
    - Changed PipeToGround::pictures to use a standard Sprite4Way.
    - Removed OffshorePumpPrototype::picture. Use OffshorePumpPrototype::graphics_set instead.
    - Removed deprecated "compressed" SpriteFlag.
    - Removed icon_mipmaps from various prototypes using icons. Mipmap count will be inferred from icon_size and actual dimensions of the source image.
    - Added OffshorePumpPrototype::energy_source and energy_usage.
    - Changed research unit ingredients to only be specified by a tuple.
    - Changed recipe ingredients to only be specified by a table with named keys.
    - Removed catalyst_amount from recipe ingredients and products.
    - Added ignored_by_stats to recipe ingredients.
    - Added ignored_by_stats and ignored_by_productivity to recipe products.
    - Added 'R' (ronna) and 'Q' (quetta) SI prefixes.
    - Removed 'K' from allowed SI prefixes - use 'k' instead.
    - Renamed "effectivity-module" to "efficiency-module", including all items, recipes, and technologies.
    - Renamed technology "advanced-electronics" to "advanced-circuit".
    - Renamed technology "advanced-electronics-2" to "processing-unit".
    - Renamed technology "optics" to "lamp".
    - Reset technology effects is automatically run when technology unlocks change.
    - Renamed boiler "heat-water-inside" mode to "heat-fluid-inside".
    - Replaced TileSpriteLayoutVariant::tall with TileSpriteLayoutVariant::tile_height.
    - Removed WorkingVisualisation::draw_as_sprite and WorkingVisualisation::draw_as_light. Use SpriteParameters::draw_as_light and draw_as_glow instead.
    - Removed BeaconModuleVisualization::draw_as_sprite and BeaconModuleVisualization::draw_as_light.
    - Removed AnimationElement::draw_as_sprite and AnimationElement::draw_as_light.
    - Removed BeaconGraphicsSet::apply_module_tint_to_light.
    - On prototypes of entities with circuit connector removed circuit_wire_connection_points and circuit_connector_sprites but added circuit_connector.
    - Renamed InserterPrototype::stack to InserterPrototype::bulk.
    - Changed "forward-then-backward" animation run mode to not repeat the first and the last frame when running backward.
    - Determining whether a tile draws transitions over different tile takes into consideration also TilePrototype::layer_group now.
    - Renamed TileRenderLayer "ground" to "ground-natural" and added "ground-artificial".
    - Reduced number of layers in "zero" tile render layer group from 128 to 64. And "water" from 64 to 8.
    - Removed TilePrototype::draw_in_water_layer.
    - Changed tile graphics definition format for both main tile pictures and tile transitions. See TilePrototype documentation.
    - Add more prototype properties for shaping Spidertron and spider unit legs and behaviors.
    - Loader is now circuit connectable.
    - Increased the limit of different "optimized-decorative" types from 255 to 65535.
    - Removed EntityPrototype::drawing_box and replaced it with drawing_box_vertical_extension.
    - Changed icon_size default to be always 64, which is also defined by defines.default_icon_size, for the case we ever wanted to change this.
    - Changed icon drawing in GUIs to account for all layers when scaling them to fit a slot or a button.
    - Added IconData::draw_background.
    - Increased the limit of different tile types from 255 to 65535.
    - Collision layers are now defined by prototypes. There is still limit of 55 layers but the layers themselves can have any name.
    - Collision mask has a mandatory table "layers" which must specify layers as dictionary.
    - Removed collision layers from "layer-13" to "layer-55".
    - Changed prototypes from straight-rail to legacy-straight-rail and curved-rail to legacy-curved-rail
    - New rail prototypes: straight-rail, curved-rail-a, curved-rail-b, half-diagonal-rail, rail-ramp, elevated-straight-rail, elevated-curved-rail-a, elevated-curved-rail-b, elevated-half-diagonal-rail.
    - Added rail-support prototype.
    - Changed way of defining rail prototype graphics: pictures are tied to direction of an entity they will be used by.
    - Changed prototype data loading to enforce the correct types are used.
    - Restricted prototype names to only contain alphanumeric characters, dashes and underscores.
    - Added RailPrototype::ending_shifts to fine-tune render position of rail endings.
    - Added RollingStockPrototype::transition_collision_mask and RollingStockPrototype::elevated_collision_mask.
    - Changed rail planner prototype: it now takes list of rail entities it is allowed to place and optional support for use with elevated rails.
    - Added EntityPrototypeFlag "building-direction-16-way".
    - Reworked noise expression definition system.
    - Added circuit connections to TurretPrototype and ArtilleryPrototype.
    - Changed most entity graphics definitions to be optional.
    - Changed various entity prototypes to only accept "energy_source" for the energy source, not "burner".
    - Changed PumpPrototype::fluid_box into input_fluid_box and output_fluid_box.
    - Changed TileEffectDefinition to allow for different effects.
    - Changed "finish-the-game-achievement" achievement type to "complete-objective-achievement".
    - Renamed until_second to within for various achievement prototypes.
    - Renamed spidertron-remote prototype to rts-tool.
    - Moved subgroup property from individual prototypes to PrototypeBase.
    - Removed "axially_symmetrical" property from RotatedSprite and RotatedAnimation definitions.
    - Removed the entity flag fast-replaceable-no-cross-type-while-moving and fast-replaceable-no-build-while-moving.
    - Removed support for emissions_per_second from worker robots.
    - Renamed track_coverage_during_build_by_moving to track_coverage_during_drag_building and changed the default to true
    - Added optional tile_condition to the place_as_tile, which allows to specify explicit list of tiles it can be built over.
    - Added vector_to_place_result (drop target) support to crafting machines.
    - Changed default value of TilePrototype::check_collision_with_entities to true.
    - The fluid generated by offshore pump is property of the tile instead of the pump.
    - Replaced ModulePrototype::limitation and ModulePrototype::limitation_blacklist with RecipePrototype::allow_[effect-name] properties (e.g. RecipePrototype::allow_productivity). By default, all effects except productivity are allowed.
    - Replaced ModulePrototype::limitation_message_key with RecipePrototype::allow_[effect-name]_message properties (e.g. RecipePrototype::allow_productivity_message). If not set, the game uses "item-limitation.[effect-name]-effect".
    - Added ElectricPolePrototype::auto_connect_up_to_n_wires.
    - Added RecipePrototype::hide_from_signal_gui.
    - Replaced min_perceived_performance, performance_to_sound_speedup, min_animation_progress and max_animation_progress with perceived_performance table containing minimum, maximum and performance_to_activity_rate.
    - Entity selection priority is no longer deduced from collision masks. Use property 'selection_priority' for that purpose.
    - Several prototype types have been given new 'selection_priority' default values, documented in '__base__/prototypes/entities/entity_util.lua'.
    - The prototype names of logistic chests have been changed to match their English display name. 'logistic-chest-requester' became 'requester-chest', etc. This applies to entities, items and recipes.
      Saves, exported blueprint/book/planner strings, and rich text tags in labels and destriptions will have their contents migrated automatically.
    - Added RocketSiloPrototype::rocket_quick_relaunch_start_offset, specifying the starting position for rockets created with the new quick-launch feature. 0 is the regular starting position, 1 is the end of the rising animation.
    - Added optional RocketSiloPrototype::rocket_parts_storage_cap, denoting when a silo is considered "full" for crafting rocket parts. Has to be at least rocket_parts_required, and defaults to that value.
    - Reworked how PipeConnectionDefinitions are specified. Added 'connection_type'. Added ability to specify 'linked' connection_type. Renamed 'type' into 'flow_direction'. Added direction. 'position' now has to be inside of the entity. Added 'connection_category'. Added 'linked_connection_id'.
    - Deprecated player-port prototype.
    - Changed type of 'entity-unknown', 'tile-proxy', 'tree-dying-proxy', 'tree-proxy' from flying-text to entity-ghost.
    - Removed the "flying-text" entity type. Use LuaPlayer::create_local_flying_text or LuaRendering::draw_text instead.
    - Removed the "flame-thrower-explosion" entity type.
    - Removed "smoke" entity prototype.
    - Removed "particle" and "leaf-particle" entity prototypes.
    - Removed "mining-tool" item prototype.
    - Removed "noise-layer" prototypes. Places previously accepting them now take a 32-bit integer or a string which gets converted using CRC32.
    - Removed SpiderEnginePrototype::military_target check. If a spider vehicle should be a military target, set EntityWithOwnerPrototype::is_military_target directly.
    - Removed RecipePrototype::result and result_count. Use RecipePrototype::results instead.
    - ProductPrototype now has a mandatory "type" field and does not accept simplified syntax for item products.
    - Unified the way hidden property of all prototypes is specified, which is always a hidden bool instead of different kind of flags.
    - Added MiningDrillPrototype::effect_receiver, CraftingMachinePrototype::effect_receiver and LabPrototype::effect_receiver.
    - Removed MiningDrillPrototype::base_productivity, CraftinMachinePrototype::base_productivity and LabPrototype::base_productivity. They were moved into EffectReceiverPrototype::base_effect.
    - Restructured SelectionToolPrototype: specific modes are described under select(required), alt_select(required), reverse_select(optional) and alt_reverse_select(optional) tables.
    - Added airborne-pollutant prototype and changed various pollution related properties to support multiple pollution types.
    - Rearranged BoilerPrototype's pictures.
    - Added CorpsePrototype::expires, defaulting to 'true'. Denotes whether corpses of this type expire by default.
    - Moved character guns inventory size to the prototype as guns_inventory_size defaulting to 3.
    - Removed hr_version from all graphics definitions. The graphics are now always considered to be in high definition.
    - Removed ability of ItemWithInventory to extend inventory.
    - Removed ItemPrototype::default_request_amount and wire_count.
    - Removed normal and expensive properties from TechnologyPrototype and RecipePrototype.
    - Removed deprecated graphics definitions from TransportBeltConnectablePrototype, use belt_animation_set instead.
    - Removed RocketSiloPrototype::rocket_result_inventory_size.
    - Removed ConstantCombinatorPrototype::item_slot_count.
    - Changed "combat-robot-count" achievement type to "combat-robot-count-achievement".
    - Changed "ghost-time-to-live" modifier type to "create-ghost-on-entity-death" and changed the modifier from double to bool.
    - Added EntityPrototype::icon_draw_specification, to control the scale and shift of alt-info icons for entities.
    - Removed AmmoTurretPrototype::entity_info_icon_shift.
    - Removed CraftingMachinePrototype::entity_info_icon_shift.
    - Removed CraftingMachinePrototype::scale_entity_info_icon.
    - Removed StorageTankPrototype::scale_entity_info_icon.
    - Removed LinkedContainerPrototype::scale_info_icons.
    - Removed ContainerPrototype::scale_info_icons.
    - Removed RobotWithLogisticInterfacePrototype::cargo_centered.
    - Removed utility constant pollution_color.
    - Removed biter_ai_settings global variable. Instead, when requiring "biter-ai-settings.lua", assign the returned table to a local variable.
    - Added BeamPrototype::graphics_set and moved graphics related properties there.
    - Added CraftingMachinePrototype::graphics_set and moved graphics related properties there.
    - Added AccumulatorPrototype::chargable_graphics and moved graphics related properties there.
    - [space-age] Added space-platform-hub, cargo-pod and cargo-bay prototypes.
    - [space-age] Added asteroid, asteroid-collector and thruster prototype.
    - Added asteroid-chunk prototype.
    - Added cargo-landing-pad prototype.
    - Added procession and procession-layer-inheritance-group prototypes.
    - Added space-platform-starter-pack, space-location, planet and space-connection prototypes.
    - Added surface-property and surface prototypes.
    - Added active-trigger and chain-active-trigger prototypes.
    - Added quality prototype and various related prototype properties.
    - Added spider-unit prototype.
    - [space-age] Added segment and segmented-unit prototypes.
    - [space-age] Added lightning-attractor prototype.
    - Added lightning prototype.
    - Added plant prototype.
    - [space-age] Added agricultural-tower prototype.
    - Added selector-combinator and display-panel prototypes.
    - Added fusion-generator and fusion-reactor prototypes.
    - Added burner-usage prototype.
    - Added temporary-container prototype.
    - Added equipment-ghost prototype.
    - Added impact-category, deliver-category and deliver-impact-combination prototypes.
    - Added remote-controller prototype.
    - Added stateless_visualisation_variations to DecorativePrototype, SimpleEntityPrototype, SimpleEntityWithOwnerPrototype and TreePrototype.
    - Added stateless_visualisation to DecorativePrototype and EntityPrototype.
    - Added RoboportPrototype::radar_range.
    - Added ShortcutPrototype::unavailable_until_unlocked.
    - Added MiningDrillPrototype::resource_drain_rate_percent and filter_count.
    - [space-age] Added MiningDrillPrototype::drops_full_belt_stacks.
    - [space-age] Added LoaderPrototype::max_belt_stack_size.
    - [space-age] Added InserterPrototype::max_belt_stack_size.
    - Added InserterPrototype::grab_less_to_match_belt_stack and enter_drop_mode_if_held_stack_spoiled.
    - Added BeaconPrototype::profile and beacon_counter.
    - Added AmmoItemPrototype::ammo_category.
    - Added LogisticContainerPrototype::trash_inventory_size.
    - Added LabPrototype::trash_inventory_size.
    - Added CarPrototype::auto_sort_inventory and trash_inventory_size.
    - Added RocketSiloPrototpye::rocket_supply_inventory_size, logistic_trash_inventory_size, render_not_in_network_icon and cargo_station_parameters.
    - Added TilePrototype::built_animations and related properties.
    - Added TilePrototype::weight, max_health, dying_explosion, destroys_dropped_items and default_destroyed_dropped_item_trigger.
    - Added ItemPrototype::weight, random_tint_color, has_random_tint, plant_result, destroyed_by_dropping_trigger and default_import_location.
    - [space-age] Added ItemPrototype::spoil_result, spoil_to_trigger_result and spoil_ticks.
    - Added CliffPrototype::place_as_crater.
    - Added TurretPrototype::graphics_set and other graphics related properties.
    - Added TechnologyPrototype::research_trigger and allows_productivity.
    - Added AmbientSound::planet and variable_sound.
    - Added Prototype::factoriopedia_alternative and PrototypeBase::factoriopedia_description, hidden_in_factoriopedia and factoriopedia_simulation.
    - Added RecipePrototype::preserve_products_in_machine_output, surface_conditions and maximum_productivity.
    - Added VehiclePrototype::allow_remote_driving.
    - Added MapSettings::asteroids.
    - Added RollingStockPrototype::default_copy_color_from_train_stop.
    - Added AmmoTurretPrototype::energy_source and energy_per_shot.
    - Added RocketSiloRocketPrototype::cargo_pod_entity.
    - Added EntityPrototype::ambient_sounds, tile_buildability_rules, impact_category, icons_positioning and surface_conditions.
    - Added RadarPrototype::connects_to_other_radars, energy_fraction_to_connect and energy_fraction_to_disconnect.
    - Added CustomInputPrototype::block_modifiers.
    - [space-age] Added ArmorPrototype::provides_flight, collision_box and related properties.
    - Added CharacterPrototype::flying_bob_speed, grounded_landing_search_radius and flying_collision_mask.
    - [space-age] Added capture-robot prototype.
    - Added EnemySpawnerPrototype::captured_spawner_entity and time_to_capture.
    - [space-age] Added EntityPrototype::heating_energy.
    - Added frozen graphics to various entities.
    - Added inventory-bonus-equipment prototype.
    - Added lane-splitter prototype.
    - Added new achievement prototypes: dont-kill-manually-achievement, dont-research-before-researching-achievement,
      change-surface-achievement, create-platform-achievement, deplete-resource-achievement, destroy-cliff-achievement,
      equip-armor-achievement, module-transfer-achievement, place-equipment-achievement, research-with-science-pack-achievement,
      shoot-achievement, space-connection-distance-traveled-achievement, use-item-achievement.
    - Added FluidPrototype::visualization_color.
    - Added PipeToGroundPrototype::visualization.
    - Added "get-by-unit-number" entity prototype flag.
    - Changed plural localisation format to use double underscores around parameter index.
    - Added new prototype type "custom-event" to define custom events in the data stage. Custom events share the same namespace as custom inputs and built-in events for subscribing to and raising them.
    - Added "grounded" sticker effect to temporarily disable mech armor flight
    - Changed autoplace control-setting variable names in noise expressions to be shorter/less verbose.
    - Added dynamic volume modifiers to sounds. These are applied when specific conditions in-game are met.
    - Added non-linear modes for sound attenuation.
    - Added an option to override default zoom level attenuation for individial sounds.
    - Added darkness (time of day) threshold for sounds.
    - Added Sound::advanced_volume_control which includes attenuation (distance based), fades (zoom level based) and darkness threshold.
    - Added Sound::speed_smoothing_window_size to smooth out changes in playback speed.
    - Added priority selection to sound aggregation.
    - Added activity matching modifiers to further control activity to volume or speed matching of working_sound.
    - Added Sound::priority. Sounds with higher priority can replace sounds with lower priority when all audio resources are used.
    - Added SoundDefinition::min_volume and SoundDefinition::max_volume for automatic volume variation.
  Scripting:
    - Renamed `global` into `storage`.
    - Added LuaBootstrap::feature_flags.
    - Added LuaEntityPrototype::allowed_module_categories read.
    - Added LuaRecipePrototype::allowed_module_categories read.
    - Removed LuaConstantCombiantorControlBehavior::parameters read/write.
    - Added LuaPlanet::associate_surface.
    - Added on_space_platform_pre_mined, on_space_platform_mined_item, on_space_platform_mined_entity, on_space_platform_built_entity,
            on_space_platform_built_tile, and on_space_platform_mined_tile.
    - Renamed on_built_entity and on_robot_built_entity parameter `created_entity` to `entity`.
    - Removed LuaConstantCombinatorControlBehavior::signals_count, set_signal() and get_signal().
    - Removed LuaGameScript::disable_tutorial_triggers().
    - Added LuaGameScript::enable_tip_triggers_in_custom_scenarios().
    - Added event on_player_used_spidertron_remote.
    - Added LuaEntity::cargo_pod read.
    - Added LuaHelpers class globally visible under `helpers` in control stage, including in `on_load`.
    - Moved LuaGameScript::table_to_json, json_to_table, write_file, remove_path, direction_to_string, evaluate_expression,
      encode_string, decode_string, parse_map_exchange_string, check_prototype_translations, is_valid_sound_path,
      is_valid_sprite_path to LuaHelpers.
    - Removed LuaGui::is_valid_sprite_path. Use LuaHelpers::is_valid_sprite_path instead.
    - Removed LuaRendering::is_font_valid. Use LuaPrototypes::font instead.
    - Removed LuaGameScript::active_mods. Use LuaBootstrap::active_mods instead.
    - Added on_player_controller_changed event.
    - Added LuaEntity::force_finish_ascending() and force_finish_descending() methods.
    - Added LuaEntity::procession_tick read/write.
    - Removed LuaPlayer::open_map, zoom_to_world, and close_map. LuaPlayer::set_controller with type 'remote' replaces these.
    - Added LuaPlayer::centered_on read/write.
    - Added LuaPrototypes globally visible under `prototypes` in control stage, including in `on_load`.
    - Moved prototypes access from LuaGameScript::X_prototypes to LuaPrototypes::X.
    - Moved filtered prototypes access from LuaGameScript::get_filtered_X_prototypes to LuaPrototypes::get_X_filtered.
    - Moved LuaBootstrap::get_prototype_history to LuaPrototypes::get_history.
    - Moved LuaGameScript::styles to LuaPrototypes::style.
    - Moved LuaGameScript::map_gen_presets to LuaPrototypes::map_gen_preset.
    - Moved LuaGameScript::named_noise_expressions to LuaPrototypes::named_noise_expression.
    - Renamed LuaSettings::player to player_default.
    - Changed Vectors to always be read from the game as the two-element array format instead of sometimes using x and y keys.
      This mostly affects properties of TriggerEffectItem. Writing a Vector to the game still accepts both formats.
    - Removed util.online_players. Use game.connected_players instead.
    - Removed LuaEntity::is_entity_with_force. Use LuaEntity::is_military_target instead.
    - Added preserve_ghosts_and_corpses argument to LuaSurface::create_entity.
    - Added cause argument to LuaSurface::create_entity.
    - Added on_pre_scenario_finished event.
    - Added optional gui_title to game.create_inventory().
    - Changed on_entity_damaged.cause semantics
    - Added on_entity_damaged.source
    - Replaced dealer argument with source and cause arguments in LuaEntity::damage().
    - Added LuaEntityPrototype::growth_grid_tile_size read.
    - Added LuaEntityPrototype::harvest_emissions read.
    - Added LuaSurfacePrototype::surface_properties read.
    - Added max_radius and use_start_position_on_failure to LuaSurface::spill_item_stack.
    - Changed LuaSurface::spill_item_stack to take a table of parameters.
    - Lua functions inside of `global` will now throw an error when saving instead of being silently discarded.
    - Renamed LuaEntityPrototype::stack to LuaEntityPrototype::bulk.
    - Added LuaTechnology::successors and LuaTechnologyPrototype::successors read.
    - Added LuaGameScript::technology_notifications_enabled (read/write).
    - Removed LuaForce::get_saved_technology_progress() and set_saved_technology_progress(). Added LuaTechnology::saved_progress (read/write).
    - Added LuaPlayer::locale read and on_player_locale_changed event.
    - Moved LuaGameScript::request_train_path into LuaTrainManager::request_train_path.
    - Removed LuaEntity::get_rail_segment_entity. Added LuaEntity::get_rail_segment_signal and get_rail_segment_stop.
    - Added LuaEntity::get_item_insert_specification.
    - Added LuaEntity::get_line_item_position, LuaTransportLine::get_line_item_position and LuaTransportLine::line_length.
    - Added LuaTransportLine::get_detailed_contents.
    - Added LuaEntity::fluids_count read, get_fluid() and set_fluid().
    - Removed ability of reading FluidWagon's fluid storage or FluidTurret's internal buffer fluid storage using LuaFluidBox.
    - Added new controller type (remote), which is to build space platforms, so it allows ghost building but not any physical manipulation.
    - Added LuaPlayer::physical_surface, physical_surface_index, physical_vehicle and physical_position read.
    - LuaInventory::get_contents() will now return an array of {name = name, count = count, quality = quality}.
    - Changed market price items to be defined as {name = name, count = count, quality = quality }.
    - Added 8 new directions into defines.direction. If mods are storing any direction values in their storage, they will need to migrate them by multiplying by 2.
    - LuaEntity::rotate no longer takes "spill_items", "enable_looted" nor "force" parameter.
    - Removed LuaEntity::get_upgrade_direction() method.
    - Changed on_built_entity event. Instead of stack/item, it passes consumed_items - modifiable stack of items used for the building.
    - LuaTile::to_be_deconstructed() and related events can be given a force. If not given, it checks if tile is to be deconstructed by any force.
    - Moved LuaItemPrototype::mapper_count property to LuaItemCommon.
    - Renamed LuaLogisticContainerControlBehavior::circuit_mode_of_operation into circuit_exclusive_mode_of_operation.
    - Added LuaCustomEventPrototype type and LuaGameScript::custom_event_prototypes read for the custom event prototypes.
    - Added on_achievement_gained event.
    - Added on_undo_applied event.
    - LuaBootstrap::raise_event()'s "event" parameter now also accepts event names as string as alternative to their numerical IDs. The event names are needed to raise custom events.
    - LuaBootstrap::on_event()'s "event" parameter now accepts event names for built-in events too, in addition to for custom inputs and the new custom events.
    - Added new attribute "icon_selector" to LuaGuiElement::add() for creating textfields and text-boxes with the icon selector button.
    - Removed __self from the LuaObjects. Intended way of checking if an object is a lua object is to check type is userdata.
    - Changed LuaForce::evolution_factor, evolution_factor_by_pollution, evolution_factor_by_time and evolution_factor_by_killing_spawners to get_* and set_* methods.
    - Type of LuaObjects is now "userdata" instead of "table".
    - Added defines.wire_connector_id.
    - Added LuaEntity::get_wire_connector and LuaEntity::get_wire_connectors.
    - Added LuaWireConnector.
    - Added LuaRecipePrototype::hide_from_signal_gui.
    - Removed LuaEntity::circuit_connected_entities, LuaEntity::circuit_connection_definitions and LuaEntity::copper_connection_definitions.
    - Removed LuaEntity::neighbours support for electric poles and power switches.
    - Removed LuaEntity::connect_neighbour and LuaEntity::disconnect_neighbour.
    - LuaCircuitNetwork is now binding to WireConnectorID. Removed LuaCircuitNetwork::circuit_connector_id. Added LuaCircuitNetwork::wire_connector_id.
    - LuaEntity::get_circuit_network and LuaControlBehavior::get_circuit_network now require exactly 1 parameter: wire_connector_id.
    - Replaced LuaEntity::get_merged_signal with LuaEntity::get_signal and LuaEntity::get_merged_signals with LuaEntity::get_signals. They no longer take circuit_connector_id but wire_connector_id.
    - Removed defines.circuit_connector_id.
    - Electric pole created through LuaSurface::create_entity can be requested to not auto connect.
    - Replaced LuaFlowStatistics::get_flow_count parameter "bool input" with "string category" to reflect the addition of the "storage" category.
    - Added LuaFlowStatistics::set_storage_count() and get_storage_count() methods.
    - Added LuaFlowStatistics::storage_counts read.
    - Removed LuaForce::item_production_statistics, fluid_production_statistics, kill_count_statistics and entity_build_count_statistics reads.
    - Added LuaForce::get_item_production_statistics(), get_fluid_production_statistics(), get_kill_count_statistics() and get_entity_build_count_statistics() methods.
    - Removed LuaGameScript::pollution_statistics read.
    - Added LuaGameScript::get_pollution_statistics() method.
    - Unified the way logistic filters are accessed, removed specific character/spidertron logistic filter methods, and all is done through get_logistic_point and get_section.
    - Added LuaControl::get_requester_point() method.
    - Removed LuaControl::clear_vehicle_logistic_slot, get_vehicle_logistic_slot, set_vehicle_logistic_slot,
      clear_personal_logistic_slot, get_personal_logistic_slot and set_personal_logistic_slot.
    - Removed LuaEntity::clear_request_slot(), get_request_slot() and set_request_slot() methods.
    - Removed LuaEntity::request_slot_count read.
    - Added LuaLogisticSection.
    - Added LuaLogisticPoint::get_section(), add_section() and remove_section() methods.
    - Added LuaLogisticPoint::enabled read/write.
    - Added LuaLogisticNetwork::network_id read.
    - Added LuaRailEnd.
    - Added LuaEntity::get_rail_end.
    - Removed LuaTrain::front_rail, back_rail, rail_direction_from_front_rail, rail_direction_from_back_rail. They are replaced with LuaTrain::get_rail_end.
    - Added LuaFluidBox::add_linked_connection(), remove_linked_connection(), get_linked_connection() and get_linked_connections() methods.
    - Renamed LuaFluidBox::get_fluid_system_id() to get_fluid_segment_id().
    - Renamed LuaFluidBox::get_fluid_system_contents() to get_fluid_segment_contents().
    - Removed LuaFluidBox::get_flow() method.
    - Added LuaPlayer::land_on_planet() method.
    - Added LuaPlayer::enter_space_platform() and leave_space_platform() method.
    - Added LuaPlayer::display_density_scale read.
    - Removed LuaEntityPrototype::collision_mask_with_flags, LuaTilePrototype::collision_mask_with_flags and LuaDecorativePrototype::collision_mask_with_flags. Respective collision_mask returns mask with flags instead.
    - Added LuaSurface::global_effect read/write.
    - Removed LuaTechnology::effects, use LuaTechnologyPrototype::effects instead.
    - Added LuaAirbornePollutantPrototype.
    - Removed LuaNoiseLayerPrototype.
    - Removed LuaItemPrototype::limitations and LuaItemPrototype::limitation_message_key reads.
    - Removed LuaGameScript::get_active_entities_count() method.
    - Removed LuaGameScript::count_pipe_groups() method.
    - Removed LuaForce::zoom_to_world_* properties.
    - Removed LuaForce::research_queue_enabled read/write.
    - Removed LuaGuiElement::get_slider_discrete_slider(), set_slider_discrete_slider(), and discrete_slider.
    - Removed LuaGuiElement::clear_and_focus_on_right_click, it is now always true.
    - Removed LuaEntity::text.
    - Removed LuaPlayer::log_active_entity_chunk_counts() and log_active_entity_counts() methods.
    - Removed LuaAutoplaceControl::control_order since it was a duplicate of ::order.
    - CircuitCondition passed to or given by LuaControlBehavior no longer uses the "condition" table, condition should be given directly.
    - Renamed LuaItemStack::blueprint_icons into preview_icons.
    - Added LuaTrainManager available through LuaGameScript::train_manager (read).
    - Added LuaTrainManager::get_trains. Removed LuaSurface::get_trains and LuaForce::get_trains.
    - Added LuaTrainManager::get_train_stops. Removed LuaSurface::get_train_stops, LuaForce::get_train_stops and LuaGameScript::get_train_stops.
    - Added snap_to_grid to LuaSurface::create_entity() and LuaControl::teleport().
    - Added LuaRenderObject. All LuaRendering methods for manipulating object selected by id were moved to LuaRenderObject.
    - Added LuaSurface::localised_name read/write.
    - Moved LuaGameScript::get_train_by_id into LuaTrainManager::get_train_by_id.
    - Added LuaRecord representing records in the blueprint library.
    - Added LuaPlayer::blueprints read.
    - Added LuaGameScript::blueprints read.
    - LuaGameScript::print, LuaPlayer::print, LuaSurface::print and LuaForce::print no longer accept Color as a second parameter.
    - Changed permission related events to also fire when mods edit permissions.
    - Changed LuaForce::ghost_time_to_live to LuaForce::create_ghost_on_entity_death bool read/write.
    - Renamed on_entity_destroyed event into on_object_destroyed.
    - Renamed LuaBootstrap::register_on_entity_destroyed into LuaBootstrap::register_on_object_destroyed.
    - Removed help() method from every Factorio Lua object.
    - Removed LuaObject::isluaobject.
    - Renamed LuaUnitGroup into LuaCommandable. Renamed LuaCommandable::group_number into LuaCommandable::id.
    - Added LuaEntity::commandable read. LuaEntity::unit_group moved to LuaCommandable::parent_group. LuaEntity::spawner moved to LuaCommandable::spawner.
    - Removed LuaEntity::set_command, set_distraction_command, command, distraction_command and moving.
    - Added LuaEquipment::quality read.
    - Added LuaEquipment::to_be_removed read.
    - Added LuaEquipment::ghost_prototype, ghost_type and ghost_name read.
    - Added LuaEquipmentGrid::revive() method.
    - Added quality and ghost parameters to LuaEquipmentGrid::put() method.
    - Added search_ghosts parameter to LuaEquipmentGrid::find() method.
    - Added LuaEquipmentGrid::order_removal() and cancel_removal() methods.
    - Added LuaEquipmentGrid::entity_owner and player_owner read.
    - Changed LuaEquipmentGrid::generator_energy read to LuaEquipmentGrid::get_generator_energy() method.
    - Added LuaPrototypeBase as the common superclass for all Lua*Prototype classes.
    - Added LuaItem and LuaItemCommon. LuaItemCommon is the common superclass for LuaItem and LuaItemStack.
    - Moved LuaControl::get_blueprint_entities to LuaItemCommon and LuaRecord.
    - Added LuaUndoRedoStack available through LuaPlayer::undo_redo_stack (read).
    - Added player and undo_index parameters for undo queue to LuaSurface::set_tiles() method.
    - Added player and item_index parameters for undo queue to LuaEntity::destroy() method.
    - Added item_index parameter for undo queue to LuaSurface::cancel_deconstruct_area() method.
    - Added item_index parameter for undo queue to LuaSurface::create_entity() method.
    - Added item_index parameter for undo queue to LuaEntity::order_upgrade() method.
    - Added item_index parameter for undo queue to LuaEntity::order_deconstruction() method.
    - Added super_forced parameter to cancel_deconstruct_area and deconstruct_area in LuaSurface, LuaRecord and LuaItemCommon.
    - Added quality condition to count_entities_filtered and find_entities_filtered methods in LuaSurface.
    - Added has_double_hidden_tile boolean to count_tiles_filtered and find_tiles_filtered methods in LuaSurface.
    - Added LuaSurface::set_property() and get_property() methods.
    - Added LuaSurface::set_double_hidden_tile() and get_double_hidden_tile() methods.
    - Added LuaTile::double_hidden_tile read.
    - Added LuaSurface::execute_lightning() method.
    - Added max_gap_size and max_attack_distance to LuaSurface::request_path() method.
    - Added LuaSurface::create_global_electric_network() and destroy_global_electric_network() methods.
    - Added LuaSurface::has_global_electric_network read.
    - Added LuaSurface::platform read.
    - Added LuaSurface::pollutant_type read.
    - Added LuaSurface::deletable read.
    - Added LuaRecipe::productivity_bonus read/write.
    - Added LuaNamedNoiseFunction.
    - Added LuaSpacePlatform and LuaPlanet.
    - Added LuaEntity::custom_status read/write.
    - Added LuaEntity::use_filters read/write.
    - Added LuaEntity::name_tag read/write.
    - Added LuaEntity::get_priority_target() and set_priority_target() methods.
    - Added LuaEntity::ignore_unprioritised_targets read/write.
    - Changed LuaEntity::electric_output_flow_limit and electric_input_flow_limit read to get_electric_output_flow_limit() and get_electric_input_flow_limit() methods.
    - Added quality parameter to LuaEntity::set_recipe() method.
    - Added LuaEntity::combinator_description read/write.
    - Added LuaEntity::mining_drill_filter_mode read/write.
    - Added LuaEntity::tick_grown read/write.
    - Added LuaEntity::quality read.
    - Added LuaEntity::always_on read/write.
    - Renamed LuaEntity::electric_emissions to electric_emissions_per_joule.
    - Added LuaEntity::copy_color_from_train_stop read/write.
    - Added LuaEntity::train_stop_priority read/write.
    - Added LuaEntity::rail_layer read.
    - Added LuaEntity::mirroring read/write.
    - Added LuaEntity::crane_grappler_destination and crane_grappler_destination_3d write.
    - Added LuaEntity::crane_destination and crane_destination_3d read/write.
    - Added LuaEntity::artillery_auto_targeting read/write.
    - Added LuaEntity::robot_order_queue read.
    - Added LuaItemCommon::owner_location read.
    - Added LuaForce::unlock_space_location(), lock_space_location() and is_space_location_unlocked() methods.
    - Added LuaForce::create_space_platform() method.
    - Added LuaForce::unlock_space_platforms(), lock_space_platforms() and is_space_platforms_unlocked() methods.
    - Added LuaForce::set_surface_hidden() and get_surface_hidden() methods.
    - Added LuaForce::unlock_quality(), lock_quality() and is_quality_unlocked() methods.
    - Added LuaForce::copy_from() and copy_chart() methods.
    - Added LuaForce::platforms read.
    - Renamed LuaForce::stack_inserter_capacity_bonus to bulk_inserter_capacity_bonus.
    - Added LuaForce::beacon_distribution_modifier and belt_stack_size_bonus read/write.
    - Added LuaSimulation available through LuaGameScript::simulation (read).
    - Added LuaGameScript::get_entity_by_unit_number() method.
    - Added LuaGameScript::set_win_ending_info() and set_lose_ending_info() methods.
    - Added LuaGameScript::planets read.
    - Added LuaGameScript::get_vehicles.
    - Added LuaSurface::planet read.
    - Removed LuaEntityPrototype::max_health. Added LuaEntityPrototype::get_max_health(quality?). Added LuaEntity::max_health read.
    - Changed on_cutscene_waypoint_reached event's parameter "waypoint_index" to not be zero indexed.
    - Added LuaPlayer::clear_local_flying_texts() method.
    - Added LuaSurface::clear_hidden_tiles.
  Bugfixes:
    - Fixed a crash related to fast-replacing a belt during its created trigger.
    - Fixed that character entities couldn't be teleported between surfaces by script directly.
    - Fixed mining a tree in multiplayer would make its stump appear with a delay, only after the mining action propagated to the game state.
    - Fixed that joining a server while auto-save is running would lead to a deadlock on the client side.
    - Fixed reading LuaItemStack::entity_label would return nil when label was set. (https://forums.factorio.com/115320)
    - Fixed reading object_name of LuaTransportBeltControlBehavior would return incorrect value.
    - Fixed that linux would not release memory after deleting blueprint library contents. (https://forums.factorio.com/114560)
    - Fixed that enemies could not retaliate to the original cause of some forms of damage.
    - Fixed that joining a multiplayer server did not work if the save was larger than 4 gigabytes. (https://forums.factorio.com/114705)
    - Fixed a desync when clicking the "continue" button on the game-won screen. (https://forums.factorio.com/114226)
    - Fixed that mod-defined additional paste entities did not work for splitters. (https://forums.factorio.com/114114)
    - Fixed LuaPlayerBuiltEntityEventFilter ghost_name did not filter tile ghost inner names. (https://forums.factorio.com/113438)
    - Fixed that driving vehicles in the map editor would not open gates. (https://forums.factorio.com/114428)
    - Fixed disabling inserter's circuit condition could activate inserter when it was still requested to say disabled. (https://forums.factorio.com/112970)
    - Fixed a desync when setting tiles during chunk generation that resulted from force_generate_chunk_requests(). (https://forums.factorio.com/113601)
    - Fixed that underground pipe dragging would not use the correct distance if the underground fluidbox connections were not in the center of the entity.
    - Fixed potential audio clicks when a filter is used. (https://forums.factorio.com/112948)
    - Improved performance of the upgrade planner GUI when there are many entity prototypes. (https://forums.factorio.com/113376)
    - Fixed plural form localisation of decimal and negative numbers. (https://forums.factorio.com/109521)
    - Fixed silent global programmable speaker sounds taking up audio resources. (https://forums.factorio.com/113648)
    - Fixed single water tile edging weird on border of 2 land tiles. (https://forums.factorio.com/104016)
    - Fixed a desync when changing PathFinderMapSettings cache sizes at runtime. (https://forums.factorio.com/113006)
    - Fixed renaming train stop could skip updating train schedules if there were train stops with same name on other surfaces. (https://forums.factorio.com/106370)
    - Fixed that labs didn't work correctly around high speeds and low science pack stack sizes. (https://forums.factorio.com/112321)
    - Fixed --load-scenario would force map size to be 50x50. (https://forums.factorio.com/110708)
    - Fixed Gui double-click speed was very fast and not respecting the system settings. (https://forums.factorio.com/111875)
    - Fixed that escape didn't work to dismiss the sync mods with save GUI. (https://forums.factorio.com/111415)
    - Fixed setting up blueprint from library would not set the label. (https://forums.factorio.com/106823)
    - Fixed that pickup inserters would not go to sleep when there was a rolling stock present even if it was not valid to interact with. (https://forums.factorio.com/111328)
    - Fixed boilers would not account for output fluid heat capacity when calculating the amount of output fluid produced. (https://forums.factorio.com/103016)
    - Fixed disconnecting lamp from circuit network would disable control behavior even if it was still connected to logistic network. (https://forums.factorio.com/111736)
    - Fixed filter burner inserter was not able to pickup fuel from belt when fuel is not accepted by filters. (https://forums.factorio.com/110651)
    - Fixed burner inserter could get stuck when fueling cycle was interrupted by a player. (https://forums.factorio.com/110682)
    - Fixed burner mining drill could drop items on wrong side of transport belt if the drill was not facing north. (https://forums.factorio.com/110846)
    - Fixed it was not possible to change rail's chart color. (https://forums.factorio.com/109659)
    - Fixed cursor split from quickbar would not round up. (https://forums.factorio.com/109461)
    - Fixed that zoom limits were appearing too small on Apple Retina displays. (https://forums.factorio.com/101652)
    - Fixed that building entities close to vertical rails would trigger train visualisation from train stop rendering even if it goes away from cursor.
    - Fixed pressing R while in rail planner would set wrong initial building direction.
    - Fixed rolling stock ghost revive was possible when there are diagonal rail ghosts not yet built which could make a train to not connect properly.
    - Fixed the wrong technology level shown on the icon in the currently selected technology.
    - Fixed upgrading connected underground belt ghost in latency state.
    - Fixed that lights of trains on other surfaces would be rendered on selected surface when doing a screenshot.
    - Fixed that for train "Fluid count" conditions, a fractional fluid amount below 1.0 would already be considered equal to 0. Amounts between 0.0 and 1.0 are now rounded up instead.
      The same logic now also applies to fluid storage tanks reading their contents and pumpjacks reading their expected resource yield.
    - Fixed undoing tile deconstruction after it was cancelled and undone before.
    - Fixed that upgrade tasks might not be processed by mobile roboport as fast as other types of tasks. (https://forums.factorio.com/101644)
    - Fixed responsibility of toggle shortcut buttons in multiplayer.
    - Fixed upgrading electric pole would disconnect a power switch.
    - Fixed several problems related to character walking and terrain building in latency hiding mode.
    - Fixed characters being able to 'jump over' obstacles when moving fast enough.
    - Fixed upgraded-modules undo action not saving or loading entity tags.
    - Fixed cutscene controller index could go out of bounds and grow indefinitely. (https://forums.factorio.com/102534)
    - Fixed that rocket silo didn't wait for the stack to be full when autolaunching.
    - Fixed the 'Error loading mods' window did not allow copying the error message. (https://forums.factorio.com/103769)
    - Fixed the shortcut bar GUI not shrinking when GUI scale is decreased. (https://forums.factorio.com/103819)
    - Fixed furnaces with fluidboxes defined with fluid filters would not have fluid filters. (https://forums.factorio.com/104036)
    - Fixed that trains didn't show wheels in blueprint, even when the rails are present.
    - Fixed that trains in blueprints didn't save the connections, so close individual rolling stocks could get connected after the blueprint placement.
    - Fixed that assembling machine would not complain when fixed_recipe was specified that cannot be crafted by given machine. (https://forums.factorio.com/105308)
    - Fixed building a blueprint with entities buildable off grid only could fail to center the blueprint properly. (https://forums.factorio.com/100944)
    - Fixed closing quickbar select page gui would not close when using confirm gui binding. (https://forums.factorio.com/101928)
    - Fixed rotating off-center bounding boxes. (https://forums.factorio.com/102850)
    - Fixed long train stop names causing shorter names to be clipped on subsequent selection. (https://forums.factorio.com/106051)
    - Fixed that inserters could sleep incorrectly if pointed at furnaces with fluid inputs. (https://forums.factorio.com/105131)
    - Fixed item stack sizes could cause issues with crafting machine's overloaded status. (https://forums.factorio.com/101436)
    - Fixed that extreme speed assembling machines would calculate productivity incorrectly. (https://forums.factorio.com/72618)
    - Fixed that robots waiting to charge were stuck after removing all charging spots of that roboport prototype.
    - Fixed that equipment in armor not currently worn would still apply drain logic. (https://forums.factorio.com/109600)
    - Fixed that worms wouldn't target construction robots correctly in some cases. (https://forums.factorio.com/106081)
    - Fixed that LuaEntity::copy_settings() didn't respect normal copy logic. (https://forums.factorio.com/109524)
    - Fixed that require() would allow files from other drives. (https://forums.factorio.com/115137)
    - Changed burner energy sources without burnt result inventory to void burnt results instead of getting stuck. (https://forums.factorio.com/113498)
    - Fixed wrong hierarchy order of blueprint book nesting when previewing entities in the world.
    - Fixed that rich-text used in train stops and train schedule weren't migrated.
    - Fixed tiles in the rocket rush lobby could be deconstructed. (https://forums.factorio.com/116008)
    - Fixed translation requests failing because of empty parameters. (https://forums.factorio.com/116098)
---------------------------------------------------------------------------------------------------
Version: 1.1.110
Date: 16. 08. 2024
  Bugfixes:
    - Fixed electric furnace shadow missing on some configurations. (https://forums.factorio.com/114217)
    - Fixed a crash when using weak tables in the lua global table. (https://forums.factorio.com/114713)
    - Fixed a bonus productivity exploit when crafting machine ingredients were force returned. (https://youtu.be/Za18SLd0PD0)
---------------------------------------------------------------------------------------------------
Version: 1.1.109
Date: 07. 06. 2024
  Bugfixes:
    - Fixed a crash when trying to hand-craft recipes that have fluid ingredients.
---------------------------------------------------------------------------------------------------
Version: 1.1.108
Date: 31. 05. 2024
  Changes:
    - Updated the format of the machine-readable modding documentation to version 5.
  Bugfixes:
    - Fixed a crash when exiting the game while steam authentication is failing.
    - Fixed a crash when starting the game with fractional scaling on newer wlroots compositors.
    - Fixed a potential desync when calling LuaGui::is_valid_sprite_path() with a sprite path starting with "file.".
    - Fixed a potential crash when switching audio device fails. (https://forums.factorio.com/113630)
---------------------------------------------------------------------------------------------------
Version: 1.1.107
Date: 11. 04. 2024
  Modding:
    - Added an optional "mods" to simulation definitions.
  Scripting:
    - Disabled the majority of the lua "debug" library due to security issues.
  Bugfixes:
    - Fixed LuaEntity::set_request_slot would not accept count of 0. (https://forums.factorio.com/110676)
    - Fixed first tutorial level advancing to a wrong story step after drill is set in quickbar. (https://forums.factorio.com/109315)
    - Fixed mods sorting order by last highlighted and by last updated. (https://forums.factorio.com/106420)
---------------------------------------------------------------------------------------------------
Version: 1.1.106
Date: 26. 03. 2024
  Bugfixes:
    - Fixed a crash when watching a replay when other player looks into blueprint library. (https://forums.factorio.com/107931)
  Modding:
    - Added StorageTankPrototype::show_fluid_icon.
  Scripting:
    - Added LuaEntityPrototype::vector_to_place_result.
---------------------------------------------------------------------------------------------------
Version: 1.1.105
Date: 20. 03. 2024
  Gui:
    - Added Paste button to exchange string import GUIs
    - Scrolling is smoother when using scrollbars with a controller.
    - Hotkey hints GUI will try to move out of the way of chat messages.
  Bugfixes:
    - Fixed that LuaForce::chart_all() wouldn't chart surfaces that had never had any charting. (https://forums.factorio.com/110966)
    - Fixed LuaEntity::circuit_connection_definitions could return copper wires from ghost entities. (https://forums.factorio.com/111087)
    - Fixed a desync related to changing in-progress infinite research levels. (https://forums.factorio.com/111127)
    - Fixed a crash when quitting to the main menu while non-blocking saving is running. (https://forums.factorio.com/110661)
    - Fixed a rare crash when switching audio devices. (https://forums.factorio.com/111407)
    - Fixed copying train stop settings could cause some trains to arrive. (https://forums.factorio.com/111511)
    - Fixed a save corruption issue related to large amounts of overlapping small electric poles. (https://forums.factorio.com/111580)
    - Fixed crash when finishing a mini-tutorial after changing the input method from keyboard and mouse to controller while in the mini-tutorial.
    - Fixed strange entity selection behavior after finishing a mini-tutorial after changing the input method from controller to keyboard and mouse while in the mini-tutorial.
    - Fixed entity status icons being visible in simulations. (https://forums.factorio.com/111618)
    - Fixed that the game window was missing decorations when using Gnome on Wayland. (https://forums.factorio.com/105512)
    - Fixed a crash related to XDG cursor themes on Wayland. (https://forums.factorio.com/111787)
    - Fixed a crash when giving NaN values to some lua APIs. (https://forums.factorio.com/111807)
    - Fixed a desync when changing the force of a requester chest with filters set from the circuit network. (https://forums.factorio.com/111359)
    - Fixed a rendering issue with pumpjack arrows when holding some items. (https://forums.factorio.com/106116)
  Scripting:
    - Added LuaRendering::move_to_back.
    - Added LuaItemStack::is_ammo read.
---------------------------------------------------------------------------------------------------
Version: 1.1.104
Date: 30. 01. 2024
  Gui:
    - Trying to close a window will first close any opened drop-down. This improves navigating drop-downs with controllers.
  Bugfixes:
    - Fixed that empty locale would cause things to not show in GUIs. (https://forums.factorio.com/110679)
    - Fixed intro sound being treated as gui effect instead of music. (https://forums.factorio.com/110848)
    - Fixed that LuaFluidBox::get_fluid_system_contents() did not behave correctly when the fluid box was not part of a fluid system.
---------------------------------------------------------------------------------------------------
Version: 1.1.103
Date: 19. 01. 2024
  Bugfixes:
    - Fixed a crash when searching in certain icon selector GUIs. (https://forums.factorio.com/110795)
---------------------------------------------------------------------------------------------------
Version: 1.1.102
Date: 18. 01. 2024
  Bugfixes:
    - Fixed crash when placing linked chest in multiplayer with hotkey suggestions enabled. (https://forums.factorio.com/110356)
    - Fixed that migration_applied was always false in the on_configuration_changed event. (https://forums.factorio.com/110392)
    - Fixed that item health bars didn't render correctly at some scales. (https://forums.factorio.com/110378)
    - Fixed a crash when the server has disconnected while setting quickbar slots. (https://forums.factorio.com/110242)
    - Fixed that the delete save confirm could delete the wrong save if a different one was selected while it was showing. (https://forums.factorio.com/110453)
    - Fixed that the custom camera widget wouldn't render entity status icons correctly. (https://forums.factorio.com/108086)
    - Fixed that LuaGameScript::auto_save() wouldn't work if the root saves folder didn't already exist. (https://forums.factorio.com/109462)
    - Fixed that selecting a group in the chat icon selector GUI would occasionally select a random result. (https://forums.factorio.com/105017)
    - Fixed an error when scenario or blueprint library files are read-only on Linux. (https://forums.factorio.com/102351)
    - Fixed several potential deadlocking issues with non-blocking saving. (https://forums.factorio.com/108738)
    - Fixed tank not consuming fuel when turning while braking. (https://forums.factorio.com/110347)
    - Fixed train could not advance from destination full state when a train stop placed from blueprint was built before a rail next to it. (https://forums.factorio.com/110572)
    - Fixed partial item transfer not preserving inventory hand location. (https://forums.factorio.com/110543)
    - Fixed transport belt would keep saying "Disabled by control behavior" after circuit wires were removed.
    - Fixed controller relative driving mode steering left and right repeatedly in multiplayer.
    - Fixed controller relative driving mode causing jittery movement when driving backwards.
  Debug:
    - Added show_generated_chunks debug option which shows uncharted yet generated chunks on the map.
---------------------------------------------------------------------------------------------------
Version: 1.1.101
Date: 26. 12. 2023
  Bugfixes:
    - Fixed a crash when entering bad number values in some input fields. (https://forums.factorio.com/110140)
    - Fixed a crash when removing an item that is being used to hand craft a recipe while also changing the recipe to take fluid ingredients.
    - Fixed a crash when defining a recipe that takes zero fluid as the first ingredient.
    - Fixed cloning a furnace would not preserve previous recipe id.
    - Fixed that selecting a locale would sometimes reset the setting back to "Default"
    - Fixed that choose-elem-button equipment tooltips were missing the equipment name and description.
    - Fixed being unable to focus search in the train overview GUI with Control + F when a mod attaches a relative GUI element to it.
    - Fixed a crash when item stack of item-on-ground becomes empty because of scripted stack transfer. (https://forums.factorio.com/110322)
  Modding:
    - Fluid ingredient amounts must be larger than zero.
    - TransportBeltConnectables cannot be given given "building-direction-8-way" flag.
  Scripting:
    - Added LuaGuiElement::elem_tooltip read/write.
    - Added LuaEntityPrototype::boiler_mode read.
    - Added LuaGameScript::request_train_path.
---------------------------------------------------------------------------------------------------
Version: 1.1.100
Date: 04. 12. 2023
  Bugfixes:
    - Fixed loader would not connect to belts in preview in some cases. (https://forums.factorio.com/109999)
    - Fixed bad pumpjack drain logic related to yield. (https://forums.factorio.com/110005)
    - Fixed recipes with ingredients craftable for free could not be crafted. (https://forums.factorio.com/110012)
  Scripting:
    - Added LuaEntity::belt_shape read.
    - Added LuaEntity::gps_tag read.
---------------------------------------------------------------------------------------------------
Version: 1.1.99
Date: 28. 11. 2023
  Bugfixes:
    - Fixed that reset technology effects would advance infinite research in some cases. (https://forums.factorio.com/109866)
---------------------------------------------------------------------------------------------------
Version: 1.1.98
Date: 22. 11. 2023
  Changes:
    - Pressing "Regenerate map" in the map editor will open the map generator.
    - "Regenerate map" is no longer available in map editor for scenarios that don't use the map generator.
  Bugfixes:
    - Fixed a loader could get stuck in rare cases with mixed items when inserter takes items from belt in a loader.
    - Fixed that pressing regenerate map in the map editor would change the map generator settings GUI next time it's used.
    - Fixed a crash when loader entity is migrated into loader-1x1. (https://forums.factorio.com/109790)
---------------------------------------------------------------------------------------------------
Version: 1.1.97
Date: 14. 11. 2023
  Bugfixes:
    - Fixed crashes when putting super large numbers in number input fields.
    - Fixed a desync when putting super large numbers in the map editor brush size fields.
  Scripting:
    - Fixed that the website link in the about GUI did not work on Linux. (https://forums.factorio.com/109684)
    - Fixed a crash when changing the technology price multiplier while research is in progress.
    - Fixed a crash when mods would swap character armor with armor in the player inventory that only existed due to the worn armor inventory size bonus. (https://forums.factorio.com/109677)
---------------------------------------------------------------------------------------------------
Version: 1.1.96
Date: 08. 11. 2023
  Bugfixes:
    - Fixed a desync related to manual crafting large recipe counts.
    - Fixed that Arm builds of the game would not render cliff previews correctly. (https://forums.factorio.com/109564)
    - Fixed train fulfilled fraction was always showing full green background. (https://forums.factorio.com/109566)
    - Fixed a desync when mods cause resources to generate with 'infinite' richness.
    - Fixed a desync when mods change character interaction distance to super large values.
    - Fixed a desync when technology prices would grow beyond 18~ quintillion.
    - Fixed a desync related to mods and custom map generation.
    - Fixed a desync when mods define corpses with very long lifetimes.
    - Fixed a crash when entering large values for train wait times.
---------------------------------------------------------------------------------------------------
Version: 1.1.95
Date: 07. 11. 2023
  Changes:
    - Technology researched message does not play chat notification sound.
  Bugfixes:
    - Fixed that the prototype explorer and CustomInputEvent::selected_prototype did not work on crafting machine fluid slots.
    - Fixed LuaEntity::disconnect_neighbour called on electric pole would disconnect left side of power switch when requested to disconnect right side. (https://forums.factorio.com/109309)
    - Fixed that cloning rails in the map editor could lead to corrupt saves in some instances. (https://forums.factorio.com/109436)
    - Fixed offset of circuit connector sprites for inserters
  Scripting:
    - Added PrintSettings::sound_path, volume_modifier and game_state.
    - Replaced PrintSettings::skip_if_redundant with PrintSettings::skip. Added defines.print_skip.
---------------------------------------------------------------------------------------------------
Version: 1.1.94
Date: 18. 10. 2023
  Bugfixes:
    - Fixed that inserters would stop working when interacting with fluid-producing machines in some cases. (https://forums.factorio.com/108996)
---------------------------------------------------------------------------------------------------
Version: 1.1.93
Date: 17. 10. 2023
  Minor Features:
    - Added "--nogamepad" command line option to disable gamepad(controller) detection and support.
  Changes:
    - Disabled support for .voc audio files for Allegro audio backend.
  Bugfixes:
    - Fixed that selection tool with "cancel-deconstruct", "cancel-upgrade" or "downgrade" mode would not render selection of entities. (https://forums.factorio.com/108620)
    - Fixed it was possible to create maps with width or height larger than 2000000. (https://forums.factorio.com/108174)
    - Fixed recipe tooltip in assembling machine was doing intermediate crafting logic when showing items missing for crafting. (https://forums.factorio.com/108190)
    - Fixed inserter could take items from wrong side of a belt when the belt shape was changed. (https://forums.factorio.com/108046)
    - Fixed that heat buffer temperatures would not migrate correctly when changing the prototype maximum temperature. (https://forums.factorio.com/108724)
    - Fixed that the research queue would not be enabled by default for the Marathon and Death world marathon presets.
    - Fixed fast replacing train stops would not preserve trains limit. (https://forums.factorio.com/109034)
    - Fixed that crafting machines did not handle item-with-tags type items correctly. (https://forums.factorio.com/109080)
    - Fixed that setting color to nil for rolling stock did not fire the on_entity_color_changed event. (https://forums.factorio.com/108816)
    - Fixed that LuaInventory::find_empty_stack() didn't respect the 'hand' location. (https://forums.factorio.com/106381)
    - Fixed that LuaGameScript::auto_save() didn't handle sub-directories correctly. (https://forums.factorio.com/105701)
    - Fixed that closing a headless multiplayer game via ctrl+c would give an exit code of 1 instead of 0. (https://forums.factorio.com/109019)
    - Fixed that all exit codes got coerced into 0 or 1.
    - Fixed that crafting machine fluid outputs could prevent them from sleeping in some cases. (https://forums.factorio.com/108996)
    - Fixed that the Lua utility function "make_4way_animation_from_spritesheet" didn't handle several values correctly. (https://forums.factorio.com/107928)
    - Fixed server not showing in LAN server browser if the game is also public and with a different external port because of NAT.
    - Fixed controller vibrations playing in keyboard and mouse mode.
    - Fixed controller buttons simulating clicks and modifiers in keyboard and mouse mode. (https://forums.factorio.com/107888)
  Modding:
    - SimpleEntityWith[Owner/Force] no longer require a graphics definition.
    - Accumulators no longer require a graphics definition.
    - Generators no longer require setting effectivity - it defaults to 1.
    - Combinators no longer require a graphics definition.
    - Generators no longer require a graphics definition.
    - Burner generators no longer require a graphics definition.
  Scripting:
    - Added LuaGameScript::get_train_by_id.
    - Added LuaEntityPrototype::spawn_decoration and spawn_decorations_on_expansion read.
    - Added LuaEntityPrototype::connection_distance and joint_distance read.
    - Added LuaEntityPrototype::radius_visualisation_specification read.
    - Added LuaEntity::sticker_vehicle_modifiers read.
    - Added LuaForce::is_chunk_requested_for_charting().
    - Added LuaEntity::spawning_cooldown, absorbed_pollution, and spawn_shift read.
    - LuaGameScript::print, LuaPlayer::print, LuaSurface::print and LuaForce::print now accept a PrintSettings as a second parameter.
    - Added LuaStyle::draw_grayscale_picture read/write.
---------------------------------------------------------------------------------------------------
Version: 1.1.92
Date: 25. 09. 2023
  Minor Features:
    - Added a notification when a technology is researched.
    - Added /enable-research-queue console command to enable the research queue without disabling achievements.
  Changes:
    - The research queue is enabled by default for new games.
  Bugfixes:
    - Fixed that pumpjacks would not show the correct status when they were stopped due to full fluid output. (https://forums.factorio.com/107907)
    - Fixed that sync-mods-with-save would download the latest mod version regardless of the mod's base dependency. (https://forums.factorio.com/106289)
  Modding:
    - Added ResourceEntityPrototype::cliff_removal_probability defaulting to 1.
---------------------------------------------------------------------------------------------------
Version: 1.1.91
Date: 13. 09. 2023
  Bugfixes:
    - Fixed that updating a mod would re-download all of its dependencies if they were not enabled. (https://forums.factorio.com/108481)
    - Fixed that Build control was allowing binding to controller buttons that would not work. (https://forums.factorio.com/106132)
    - Fixed (again) dump commands not working correctly related to folders. (https://forums.factorio.com/108673)
    - Fixed that ending copy selection in controller mode could trigger the copied entities to be immediately built. (https://forums.factorio.com/108644)
---------------------------------------------------------------------------------------------------
Version: 1.1.90
Date: 07. 09. 2023
  Changes:
    - Removed option to capture system mouse cursor when using a controller due to it breaking touch screen input.
    - The temporary virtual cursor shown when using the mouse in controller input mode will now disappear when a controller stick is moved instead of after 1.5 seconds (https://forums.factorio.com/108534)
  Bugfixes:
    - Fixed some visual glitches related to LuaGuiElement::auto_toggle and LuaGuiElement::toggled.
    - Fixed that some remapped keys wouldn't work on Linux. (https://forums.factorio.com/108229)
    - Fixed that some default mappings on Steam Deck would map to back grip buttons but there was no way to trigger them.
    - Fixed that --dump-data did not work if the script output folder didn't exist. (https://forums.factorio.com/108259)
    - Fixed sounds.large_explosion ignoring volume parameter. (https://forums.factorio.com/108493)
  Modding:
    - Removed unused rocket silo prototype property idle_energy_usage.
  Scripting:
    - LuaEntity::neighbours read for underground belt ghost returns far end.
    - Removed LuaEntityPrototype::idle_energy_usage read.
---------------------------------------------------------------------------------------------------
Version: 1.1.89
Date: 16. 08. 2023
  Features:
    - Migrated the prototype modding documentation from the wiki to the docs website, enabling a more advanced presentation, an offline version, and machine-readability of the underlying format. They can be found at https://lua-api.factorio.com/latest/index-prototype.html.
  Minor Features:
    - Added controller vibrations to some actions.
    - Added option to capture system mouse cursor when using a controller. This fixes cursor teleporting when using both controller and mouse but locks the mouse cursor to the game window. (https://forums.factorio.com/107969)
  Bugfixes:
    - Fixed a desync between ARM and x86 platforms when calling math.atan2() Lua function with NaN arguments.
    - Fixed a player could not obtain achievements if it was in game for longer than 9942h. (https://forums.factorio.com/107893)
    - Fixed blueprint setup GUI cutting off at the bottom at certain UI scales. (https://forums.factorio.com/107903)
    - Fixed that LuaGuiElement type 'slider' didn't enable/disable correctly when first created. (https://forums.factorio.com/107991)
    - Fixed a crash when clearing the cursor stack through script when using capsules. (https://forums.factorio.com/107862)
    - Fixed a crash when viewing the map preview when one or more noise expressions are invalid. (https://forums.factorio.com/89023)
    - Fixed that the game could freeze if there were too many auto-placeable entities defined. (https://forums.factorio.com/108048)
    - Fixed cursor sometimes teleporting to nearby entities when selecting entities to be built from the Quick panel with controller, in multiplayer.
    - Fixed that damage trigger effects would not pass the damage source when doing damage. (https://forums.factorio.com/108224)
  Modding:
    - Added FurnacePrototype::cant_insert_at_source_message_key. (https://forums.factorio.com/108146)
    - Added game_controller_vibration_data to sounds.
  Scripting:
    - Added LuaEntity::copper_connection_definitions.
    - LuaGameScript::kick_player and ban_player no longer accept LocalisedString for reason parameter but only regular strings.
    - LuaSurface::map_gen_settings can be changed during on_chunk_generated. (https://forums.factorio.com/108100)
    - Added LuaEntityPrototype::vertical_selection_shift.
    - Added LuaEntity::is_headed_to_trains_front read.
    - Added LuaEntity::draw_data read for rolling stock.
---------------------------------------------------------------------------------------------------
Version: 1.1.88
Date: 20. 07. 2023
  Changes:
    - Automatic UI scale on Steam Deck will never be lower than 100%
    - Steam on-screen keyboard will automatically appear on Steam Deck and in Steam Big Picture mode when using a controller.
  Bugfixes:
    - Fixed that notch slider tooltips would not show in some cases. (https://forums.factorio.com/107602)
    - Fixed that updating mods with dependencies did not work correctly in some cases. (https://forums.factorio.com/107673)
    - Fixed music not playing after setting preferred audio output device. (https://forums.factorio.com/107719)
    - Fixed that any error with an audio stream would crash the game, improved audio stream error handling in general.
    - Fixed a hang in audio streams. (https://forums.factorio.com/107792)
    - Fixed Hungarian keyboard layout not being handled correctly. (https://forums.factorio.com/107849)
---------------------------------------------------------------------------------------------------
Version: 1.1.87
Date: 04. 07. 2023
  Minor Features:
    - Changed --dump-data to write infinite values as the string "inf" and "-inf".
  Bugfixes:
    - Fixed LuaGameScript::check_prototype_translations() did not work correctly for manual localised strings with parameters. (https://forums.factorio.com/107573)
    - Fixed it was possible to drop cursor items through ghosts. (https://forums.factorio.com/107601)
    - Fixed a crash when fast replacing loader into a loader with fluid energy source when the loader type needs to be changed. (https://forums.factorio.com/107591)
    - Fixed LuaFluidBox::get_pipe_connections() returning target_index as zero-indexed.
  Scripting:
    - Added target_fluidbox_index to PipeConnection.
    - Renamed PipeConnection's target_index to target_pipe_connection_index.
---------------------------------------------------------------------------------------------------
Version: 1.1.86
Date: 28. 06. 2023
  Minor Features:
    - It is now possible to blueprint entities of friendly forces.
  Changes:
    - "Pick up items" will no longer fire at the same time as other actions. This fixes character picking up items when flipping blueprints. (https://forums.factorio.com/106680)
  Bugfixes:
    - Fixed not being able to select assembling machine recipe if Craft, Craft 5 and Craft all were not bound to any button (https://forums.factorio.com/106704)
    - Fixed another crash when downgrading ghost of assembling machine when target machine cannot craft recipe due to missing pipes.
    - Fixed that you could blueprint enemy force tile ghosts.
    - Fixed that the mod manager would occasionally download updates that are incompatible with the current game version. (https://forums.factorio.com/106719)
    - Fixed missing support for wind and ambient category for sound prototypes. (https://forums.factorio.com/106775)
    - Fixed selection tool rendering in the chart for ghost rails. (https://forums.factorio.com/106801)
    - Fixed enemy expansion would fail to expand into chunks with entities invisible to the enemy. (https://forums.factorio.com/106787)
    - Fixed some controls allowing binding to buttons that would not work. (https://forums.factorio.com/106721)
  Scripting:
    - Added dash_offset to LuaRendering::draw_line.
    - Added LuaFluidBox::get_fluid_system_contents() method.
    - Added LuaFluidBox::get_pipe_connections() method.
---------------------------------------------------------------------------------------------------
Version: 1.1.85
Date: 16. 06. 2023
  Changes:
    - Allow "Pick up items" and "Drop items" actions to be fired at the same time as other actions, in keyboard and mouse mode. (https://forums.factorio.com/106680)
  Bugfixes:
    - Fixed "Enter/leave vehicle" shortcut never allowing other shortcuts to use the same key combination. (https://forums.factorio.com/106663)
    - Fixed a crash when downgrading ghost of assembling machine when target machine cannot craft recipe due to missing pipes. (https://forums.factorio.com/106667)
    - Fixed IME no longer working on Windows. (https://forums.factorio.com/106681)
    - Fixed on_entity_color_changed not being raised for some entities. (https://forums.factorio.com/106677)
    - Fixed a crash when trying to start sound fade out when there are no audio devices. (https://forums.factorio.com/106685)
    - Fixed that Factorio wouldn't load on macOS versions prior to 10.15. (https://forums.factorio.com/106684)
---------------------------------------------------------------------------------------------------
Version: 1.1.84
Date: 15. 06. 2023
  Bugfixes:
    - Fixed a desync when reading cursor_display_location in on_gui_click.
    - Fixed macOS release missing files due to a third party library bug.
---------------------------------------------------------------------------------------------------
Version: 1.1.83
Date: 14. 06. 2023
  Features:
    - Added controller(gamepad) support. Change input method in Settings->Controls to play using a controller.
  Minor Features:
    - Added contextual hotkey hints. Enable it in Settings->Interface. Useful when playing using a controller.
    - When connecting wires to entities with multiple sides(combinator, power switch), the hovered side is highlighted.
  Changes:
    - Improved sounds fading in and out on game resume and pause.
  Bugfixes:
    - Fixed that migrating color type mod settings did not work correctly. (https://forums.factorio.com/106445)
    - Fixed cancel deconstruction of pipe would not remove colliding pipe to ground ghosts.
    - Fixed a crash related to construction robots delivering items and upgrading entities in the same tick.
    - Fixed LuaSurface::force_generate_chunk_requests() did not respect generate_with_lab_tiles. (https://forums.factorio.com/106484)
    - Fixed changing recipe from one using custom fluidbox indexes into one not using custom fluidbox indexes could result in incorrect fluidbox layout. (https://forums.factorio.com/106428)
    - Fixed some sounds (for example sounds from programmable speaker or rocket silo) not fading out on pause.
    - Fixed a crash when trying to change direction of a loader simulation with fluid energy source. (https://forums.factorio.com/106562)
    - Fixed a loader with energy source would not consume all the energy from internal buffer preventing out of fuel icon from showing up. (https://forums.factorio.com/106565)
    - Fixed god/editor/spectator/ghost controller movement in latency when game speed is greater than 1.
    - Fixed building underground belt over transport belt with target direction set would create incorrect undo action. (https://forums.factorio.com/106602)
  Modding:
    - Added CustomInputPrototype::controller_key_sequence and CustomInputPrototype::controller_alternative_key_sequence.
  Scripting:
    - Added LuaModSettingPrototype::type read.
    - Added on_entity_color_changed.
    - Added on_player_input_method_changed.
    - Added defines.game_controller_interaction.
    - Added LuaGuiElement::game_controller_interaction read/write.
    - Added LuaPlayer::input_method read.
    - Added LuaSurface::find_closest_logistic_network_by_position.
    - Added optional include_diagonal to LuaSurface::get_connected_tiles.
    - Added optional area to LuaSurface::get_connected_tiles.
    - Added cursor_display_location to custom input events and on_gui_click.
---------------------------------------------------------------------------------------------------
Version: 1.1.82
Date: 22. 05. 2023
  Changes:
    - Disabled the Command+W keyboard shortcut for closing the game window on Macs. Command+Q will still quit the application. (https://forums.factorio.com/105655)
    - On macOS, left and right variants of the Command and Option keys are differentiated when not bound as a modifier.
  Bugfixes:
    - Fixed a desync between ARM and x86 platforms when the pathfinder was overloaded. (https://forums.factorio.com/105953)
    - Fixed a crash when trivial smoke was defined with bad movement speed values. (https://forums.factorio.com/105970)
    - Fixed that startup color mod settings would appear as changeable during runtime.
    - Fixed multiple forces being unable to order deconstruction of the same forceless entity. (https://forums.factorio.com/100864)
    - Fixed deconstruction markers being visible to forces which did not order the deconstruction.
    - Fixed inconsistent rounding in tooltips caused by floating-point inaccuracy. (https://forums.factorio.com/105661)
    - Fixed that upgrading modules with fast-transfer could cause the returned modules to overlap with the inventory hand.
    - Fixed not being able to type in textboxes on steam deck. (https://forums.factorio.com/105988)
    - Fixed that dump-icon-sprites did not work correctly for icons using shift values. (https://forums.factorio.com/106069)
    - Fixed ghosts could be removed even if they do not collide with built entity. (https://forums.factorio.com/106071)
    - Fixed a crash when removing modded pipe-to-ground that connects to a shifted pipe-to-ground. (https://forums.factorio.com/106105)
    - Fixed a crash when a mod sets a train's schedule while a temporary stop with no wait conditions is being removed.
    - Fixed a crash when saving the game after a server disconnect with non-blocking saving enabled.
    - Fixed that blueprints could have duplicate logistic filters. (https://forums.factorio.com/105984)
    - Fixed that LocalisedString ignored 'correct' translation status of its parameters. (https://forums.factorio.com/104466)
    - Fixed that some PNGs loaded darker than intended on Macs, affecting some mods.
    - Fixed remapped modifier keys not registering properly in some environments. (https://forums.factorio.com/106031)
  Scripting:
    - Added optional surface parameter to LuaForce::rechart.
    - Added LuaGuiElement::auto_toggle read/write.
    - Added LuaGuiElement::toggled read/write.
    - Added on_cutscene_started and on_cutscene_finished.
    - BoundingBox accepts orientation from lua.
---------------------------------------------------------------------------------------------------
Version: 1.1.81
Date: 19. 04. 2023
  Changes:
    - Updated SDL to version 2.26.5.
    - Replace "Version" column in mods install menu with "Last highlighted"
  Bugfixes:
    - Fixed wind sound not changing its volume with zoom level.
    - Fixed that productivity values did not show correctly in some cases. (https://forums.factorio.com/105814)
    - Fixed texture compression artefacts on Apple Silicon Macs. (https://forums.factorio.com/104219)
    - Fixed that playing music with master volume and music volume set to 100% would mute all other sounds.
    - Fixed a crash when unit has a composite command with a dead unit group. (https://forums.factorio.com/105935)
    - Fixed that recipe category notification icons would draw under the category icon. (https://forums.factorio.com/105910)
    - Fixed that inserting invalid items into blueprint books through script would crash. (https://forums.factorio.com/105689)
    - Fixed being unable to copy or paste extremely large blueprint strings on Linux (https://forums.factorio.com/105915)
---------------------------------------------------------------------------------------------------
Version: 1.1.80
Date: 30. 03. 2023
  Bugfixes:
    - Fixed LuaRendering::draw_sprite and draw_animation throwing an exception when orientation_target was not given.
---------------------------------------------------------------------------------------------------
Version: 1.1.79
Date: 30. 03. 2023
  Bugfixes:
    - Fixed a crash when maximum-sounds is set below 16, for example by using --disable-audio or on failed audio initialization. (https://forums.factorio.com/105663)
    - Fixed that some effects would sometimes be performed twice in multiplayer when FPS is lower than UPS.
    - Fixed LuaSurface::find_entities_filtered would not accept force indexes. (https://forums.factorio.com/105688)
    - Fixed that solar panels on multiple surfaces would all produce electricity based on a daytime of one of the surfaces when they were part of a single electric network with a script created wire between surfaces. (https://forums.factorio.com/96830)
    - Fixed that loaders would spill their items when fast-replaced or upgraded.
    - Fixed valid path searches failing because a previously failed path with a wider bounding box was cached. (https://forums.factorio.com/104580)
    - Fixed the Lua event on_equipment_inserted would not be triggered by construction robots delivering the equipment item. (https://forums.factorio.com/105547)
    - Fixed the Lua events on_equipment_inserted and on_player_placed_equipment would not be triggered by dropping items into entities (using the 'drop item' key), or fast-transfer. (https://forums.factorio.com/105547)
  Scripting:
    - Added LuaRendering::use_target_orientation for Sprite, Animation, and Polygon.
    - Added on_gui_hover, on_gui_leave.
    - Added LuaGuiElement::raise_hover_events read/write.
---------------------------------------------------------------------------------------------------
Version: 1.1.78
Date: 20. 03. 2023
  Minor Features:
    - In the blueprint preview window, deselecting all train fuel items disables the 'Train fuel' option. (This was already the case for modules. https://forums.factorio.com/102804)
  Changes:
    - On macOS, when AZERTY keyboard layout is used, the shortcut for Undo will default to Cmd + Z instead of Cmd + W. (https://forums.factorio.com/105590)
  Bugfixes:
    - Fixed loader would ignore ElectricEnergySourcePrototype::buffer_capacity. (https://forums.factorio.com/105438)
    - Fixed rotating a loader would not update heat connections if it has any. (https://forums.factorio.com/105441)
    - Fixed migrating loader energy sources between types could fail to update energy source buffer size. (https://forums.factorio.com/105440)
    - Fixed migrating inserter energy source between types could fail to update energy source buffer size.
    - Fixed migrating pump energy source between types could fail to update energy source buffer size.
    - Fixed migrating radar energy source between types could fail to update energy source buffer size.
    - Fixed migrating reactor energy source between types could fail to update energy source buffer size.
    - Fixed double sound when transferring crafting materials from cursor stack into crafting machine or when taking items from the result slot.
    - Fixed a desync related to fluid energy source energy extraction when floating point rounding errors are involved.
    - Fixed a bad error message when registering custom hotkey events with filters. (https://forums.factorio.com/105281)
    - Fixed that color mod settings wouldn't migrate to the default value. (https://forums.factorio.com/105439)
    - Fixed that escape did not work to close the user-login GUI. (https://forums.factorio.com/103548)
    - Fixed that the CustomGuiElement "switch" type would fire the click event twice. (https://forums.factorio.com/102950)
    - Fixed a rare crash related to watching replays. (https://forums.factorio.com/104099)
    - Fixed consistency issue related to building loader ghosts over existing loader ghosts. (https://forums.factorio.com/102756)
    - Fixed spilling items would fail to spread items when surface had width or height set to more than 2^31. (https://forums.factorio.com/105493)
    - Fixed an AI Pathfinder desync when changing goal_pressure_ratio while the pathfinder was running. (https://forums.factorio.com/104323)
    - Fixed land mine was not colliding with rail signals. (https://forums.factorio.com/103683)
    - Fixed a crash when disconnecting and reconnecting a display on Wayland (https://forums.factorio.com/105489)
    - Fixed inconsistent clipboard behavior on Wayland (https://forums.factorio.com/105489)
    - Fixed that disabling permissions to move didn't work correctly in some cases (https://forums.factorio.com/105478)
    - Fixed furnace would stop crafting when recipe could not be deduced from ingredients and technology effects were being reset. (https://forums.factorio.com/104896)
    - Fixed a crash related to script creation of entities. (https://forums.factorio.com/105531)
    - Fixed module and fuel entries disappearing from blueprint preview when selectively disabled, instead of showing up with count 0. (https://forums.factorio.com/102804)
    - Fixed automatic targeting with spidertrons did not work if all ammo slots were not filled. (https://forums.factorio.com/105176)
    - Fixed technology title not updating when technology was researched. (https://forums.factorio.com/102282)
    - Fixed horizontal lines ending up too short when close to line-wrapping labels (https://forums.factorio.com/102254)
    - Fixed a crash related to migrating spider vehicle guns. (https://forums.factorio.com/105552)
    - Fixed loader ghosts would connect to transport belts even when they had different forces. (https://forums.factorio.com/105518)
    - Fixed a crash when moving blueprint book to blueprint library when there is also another book that will get under the cursor and tooltips are showing. (https://forums.factorio.com/102613)
    - Fixed that "item-with-inventory" would allow setting inventory_size to "dynamic". (https://forums.factorio.com/102823)
    - Fixed balance of several audio files. (https://forums.factorio.com/103870)
    - Fixed InserterPrototype would accept too large stack size bonuses. (https://forums.factorio.com/105627)
  Modding:
    - Added 'entity-ghost' and 'tile-ghost' selection tool modes.
    - Added chart.zoom_threshold_to_draw_spider_path utility constant.
  Scripting:
    - Added optional character parameter to LuaSurface::create_entity. Will simulate fast replacing using the character.
    - Added LuaEntityPrototype::max_power_output read support for burner generators.
    - Added LuaItemStack::use_capsule.
    - Added LuaEntity::beacons_count read.
    - Added LuaEntity::get_beacons().
    - Added LuaEntity::get_beacon_effect_receivers().
---------------------------------------------------------------------------------------------------
Version: 1.1.77
Date: 03. 03. 2023
  Graphics:
    - Added support for Wayland on Linux. To enable it, set SDL_VIDEODRIVER=wayland in your environment. (thanks to raiguard)
  Changes:
    - Music no longer fades out on technology screen. (https://forums.factorio.com/104760)
  Bugfixes:
    - Fixed 'on_string_translated' event having incorrect localised_string parameter for fallback groups.
    - Fixed that LuaPlayer::cursor_stack_temporary returned false for pasted blueprints. (https://forums.factorio.com/104354)
    - Fixed size issues related to mod relative GUIs. (https://forums.factorio.com/98151)
    - Fixed that item request proxies could be created through script with a count of 0. (https://forums.factorio.com/104886)
    - Fixed that electric energy interface entities didn't use the render layer defined in the prototype for animations. (https://forums.factorio.com/105000)
    - Fixed a memory corruption issue when saving under linux with async saving enabled. (https://forums.factorio.com/104600)
    - Fixed ping shown for a server in the multiplayer games browser sometimes not updating correctly.
    - Fixed the game would fail to load sprites with some mods when max texture size was set to 2048. (https://forums.factorio.com/104853)
    - Fixed centrifuge uranium glow effect flickering on and off on arm64 builds.
    - Fixed a scripting error in tips and tricks simulations related to mod migrations. (https://forums.factorio.com/104656)
    - Fixed a crash when downgrading specific entities in multiplayer. (https://forums.factorio.com/105005)
    - Fixed that LuaItemStack::transfer_stack didn't work correctly for inventories that went over normal item stack limits. (https://forums.factorio.com/105066)
    - Fixed TransportLine consistency issue when changing force of a linked-belt. (https://forums.factorio.com/105182)
    - Fixed a crash related to custom map generation. (https://forums.factorio.com/105215)
    - Fixed a crash with SDL's X11_XInput2. (https://forums.factorio.com/104267)
    - Fixed programmable speaker playing incorrect sound in certain scenarios. (https://forums.factorio.com/105255)
    - Fixed that create_spidertron() didn't scale lights correctly. (https://forums.factorio.com/101085)
    - Fixed LuaFluidBox::get_prototype would try to return fluidbox prototypes ignoring layout of fluidboxes when part of crafting machine. (https://forums.factorio.com/105338)
    - Fixed inserter could start moving to the drop target while still being in the pickup mode. (https://forums.factorio.com/104397)
    - Fixed multiple personal roboports discharging. (https://forums.factorio.com/105358)
    - Fixed that LuaLogisticNetwork::insert() wouldn't insert all of the requested items in some cases. (https://forums.factorio.com/103784)
  Modding:
    - Added a command line flag (dump-data) to dump data-raw to the script output folder as json.
    - Added a command line flag (dump-icon-sprites) to dump prototype icons to the script output folder.
    - Added a command line flag (dump-prototype-locale) to dump prototype locale to the script output folder.
    - Sprites with size close to 2048px (or 4096px when high resolution is enabled) will have forced "no-atlas" priority. (https://forums.factorio.com/99066)
    - Added LoaderPrototype::energy_source and energy_per_item.
    - Added support for "icon_horizontal_align" to sprite-button.
    - Added "color-setting" prototype.
  Scripting:
    - Added LuaControl::get_max_inventory_index() read.
    - Added LuaItemStack::entity_label and LuaItemStack::entity_color read.
    - Added "unlocks-recipe" to technology prototype filters.
    - ForceIdentification can now be specified by force index.
    - Added script_raised_teleported.
    - Added raise_teleported to LuaControl::teleport.
    - Added 'use_rich_text' parameter to LuaRendering::draw_text() and getter/setter functions.
    - Added 'has_item_inside' to LuaSurface::find_entities_filtered parameters. Will filter for entities that have the specified item inside them.
    - LuaFluidBox::get_prototype may return an array of LuaFluidBoxPrototype if the entity uses compound fluidboxes. (https://forums.factorio.com/105338)
---------------------------------------------------------------------------------------------------
Version: 1.1.76
Date: 13. 01. 2023
  Bugfixes:
    - Fixed a crash when trying to filter car/spider ammo slots. (https://forums.factorio.com/104769)
    - Fixed visual artifact in water when zoomed out.
    - Fixed 'on_entity_renamed' Lua event not including 'player_index' if copy-pasting to a train stop. (https://forums.factorio.com/104460)
---------------------------------------------------------------------------------------------------
Version: 1.1.75
Date: 11. 01. 2023
  Changes:
    - Added autosave slots to "The Rest" settings gui. (https://forums.factorio.com/104610)
  Bugfixes:
    - Fixed a crash with crafting machines using burner energy sources and items that produce burnt results. (https://forums.factorio.com/104343)
    - Fixed that the bonus GUI could show incorrect values for modded inserter bonuses. (https://forums.factorio.com/104273)
    - Fixed that additional layers of multi-layer recipe icons were tinted when building. (https://forums.factorio.com/104268)
    - Fixed that restoring a window minimized to the macOS dock would freeze the graphics. (https://forums.factorio.com/104221)
    - Fixed a crash related to failed audio initialization and switching audio devices.
    - Fixed a crash when creating surfaces during the chunk deleted event. (https://forums.factorio.com/104406)
    - Fixed that projectiles didn't draw oriented lights at the correct orientation. (https://forums.factorio.com/103173)
    - Fixed that the 'create_spidertron()' Lua function didn't set the correct minable result name. (https://forums.factorio.com/103923)
    - Fixed that 'item on ground' didn't show item amount in the tooltip. (https://forums.factorio.com/92321)
    - Fixed a crash when restarting after syncing mods with save if the mod(s) were disabled and the save had a valid replay. (https://forums.factorio.com/104461)
    - Fixed working sound's volume or speed not being matched to activity when fading, for example with pipes. (https://forums.factorio.com/104450)
    - Fixed overlaping red and green wires connected to a power switch. (https://forums.factorio.com/103456)
    - Fixed that moving a container with which a loader was interacting would not disconnect the loader.
    - Fixed that vehicle ammo slot filter selection would show ammos that the slot cannot accept. (https://forums.factorio.com/104635)
    - Fixed vehicle ammo slot style when filtered. (https://forums.factorio.com/104634)
    - Fixed train lights in preview would render for trains on surface a player is on, not for the surface being rendered. (https://forums.factorio.com/104619)
    - Fixed that cloning item entities wouldn't clone the to-be-looted flag. (https://forums.factorio.com/104659)
    - Fixed that boilers wouldn't consume fuel if fed fluid at maximum temperature. (https://forums.factorio.com/104670)
    - Fixed a desync related to custom blueprints. (https://forums.factorio.com/104717)
    - Fixed transport belts not decompressing overcompressed items in certain cases. (https://forums.factorio.com/104247)
    - Fixed drawing an extra shadow for health bars of items on ground and items on belts.
    - Fixed that connecting circuit or copper wires in map view did not work if the Build and Drag map controls conflicted. (https://forums.factorio.com/104694)
    - Fixed override_sound_type having no effect. (https://forums.factorio.com/104707)
  Scripting:
    - Added 'entity' to LuaPlayer::open_map and LuaPlayer::zoom_to_world, which specifies an entity to follow.
    - Added LuaRailPath::is_front read.
    - Added LuaEntityPrototype::alert_icon_scale read.
    - Added LuaBootstrap::get_prototype_history().
    - Added LuaGameScript::console_command_used read.
    - Added is_split to on_player_fast_transferred.
    - Added LuaPlayer::drag_target read.
    - Added LuaControl::surface_index and force_index read.
    - Added LuaEntity::inserter_target_pickup_count read.
  Modding:
    - Added LoaderPrototype::allow_rail_interaction and allow_container_interaction.
---------------------------------------------------------------------------------------------------
Version: 1.1.74
Date: 06. 12. 2022
  Bugfixes:
    - Fixed that LocalisedString didn't support fallback groups in some cases when parsed from Lua. (https://forums.factorio.com/104297, https://forums.factorio.com/104303)
    - Fixed a crash when a mod defines an entity that kills itself when created. (https://forums.factorio.com/104331)
  Modding:
    - Added CarPrototype::immune_to_cliff_impacts, true by default.
      If set to false - entity will take damage when it collides with cliff prototype entities.
  Scripting:
    - Added LuaPlayer::cursor_stack_temporary read/write.
    - Added LuaPlayer::request_translations() for batching translation requests.
---------------------------------------------------------------------------------------------------
Version: 1.1.73
Date: 01. 12. 2022
  Bugfixes:
    - Fixed items dropped on underground belts could be inserted at a wrong position when transport lines were facing east or south. (https://forums.factorio.com/104104)
    - Fixed DNS CNAME records confusing the SRV lookup on Windows (https://forums.factorio.com/104089)
    - Fixed a crash when hovering over some rich text tags and destroying the object they refer to. (https://forums.factorio.com/104149)
    - Fixed that "request from buffer chests" option wasn't copied between spidertrons. (https://forums.factorio.com/104046)
    - Fixed that "request from buffer chests" option in spidertrons reset to default when prototypes changed. (https://forums.factorio.com/104124)
    - Fixed directories in file dialogues not being sorted alphabetically on some systems. (https://forums.factorio.com/104053)
    - Fixed dropdown button font color when clicked. (https://forums.factorio.com/104249)
    - Fixed a crash when switching preferred audio device failed.
    - Fixed not being able to remove script areas in the map editor. (https://forums.factorio.com/104291)
  Modding:
    - Added fallback groups format for localised string which picks the first correct translation. (https://forums.factorio.com/71553)
    - Transparent black in RecipePrototype::crafting_machine_tint won't cause the tint to fallback to value of default_recipe_tint. (https://forums.factorio.com/104272)
---------------------------------------------------------------------------------------------------
Version: 1.1.72
Date: 11. 11. 2022
  Minor Features:
    - Improve mod update checking for large mod collections
  Graphics:
    - Loaders now show their item filters in alt mode.
  Bugfixes:
    - Fixed a crash when doing alt-reverse selections in zoomed-in map mode. (https://forums.factorio.com/104020)
  Scripting:
    - Added LuaInventory::is_full().
    - Added 'include_bar' parameter to LuaInventory::count_empty_stacks().
---------------------------------------------------------------------------------------------------
Version: 1.1.71
Date: 04. 11. 2022
  Minor Features:
    - Added preferred audio device output setting.
    - Added the current binary architecture to the main menu version string.
  Optimizations:
    - Added native support for Apple Silicon Macs.
  Bugfixes:
    - Fixed a crash when canceling deconstruction of a pipe to ground while the GUI was open. (https://forums.factorio.com/103728)
    - Fixed entity ghosts would draw wires even if prototype of inner entity disabled it. (https://forums.factorio.com/103765)
    - Fixed incorrect panning of CyclicSound (for example, flamethrower turret's stream sound). (https://forums.factorio.com/103865)
    - Fixed that ScriptRendering requested string localisation during on_init when it was not available. (https://forums.factorio.com/103745)
    - Fixed Generator tooltip ignoring fluid emissions multiplier. (https://forums.factorio.com/103847)
    - Fixed that teleporting cars between surfaces would create the build effect smoke. (https://forums.factorio.com/103972)
    - Fixed a crash related to undoing mining of another forces entities after the other force had been deleted. (https://forums.factorio.com/103966)
    - Fixed it was possible to acquire forbidden items in the Transport belt madness levels. (https://forums.factorio.com/103331)
    - Fixed that linked-belt was missing from the collision mask defaults. (https://forums.factorio.com/103849)
    - Removed 'Fuel emissions' label from Burner info panel. (https://forums.factorio.com/103942)
    - Fixed that expansion parties could destroy spidertrons while building new bases. (https://forums.factorio.com/103872)
  Modding:
    - Added Alt reverse selection support for selection tools. (https://forums.factorio.com/102470)
  Scripting:
    - Added LuaGuiElement::close_dropdown().
---------------------------------------------------------------------------------------------------
Version: 1.1.70
Date: 11. 10. 2022
  Minor Features:
    - Added mod portal bookmarks to install mods gui
  Bugfixes:
    - Fixed show-player-robots debug option would render lines for characters on other surfaces. (https://forums.factorio.com/103470)
    - Fixed using incorrect sound settings when there is no configuration file.
    - Fixed a crash related to teleporting spider vehicles with burner energy sources between surfaces.
    - Fixed that the return value of some lualib noise functions didn't have the metatable for noise expression arithmetic. (https://forums.factorio.com/103416)
    - Fixed simulation widgets showing savefiles trying to apply migrations in multiplayer. (https://forums.factorio.com/103528)
    - Fixed upgrading pair of underground belt ghosts that makes them in reach would flip one of them without updating rotation point of nearby belts. (https://forums.factorio.com/103564)
    - Fixed that logistic containers didn't deduplicate filters when importing them from untrusted sources which could crash the game. (https://forums.factorio.com/102882)
    - Fixed a hard crash when a mod called deconstruct_area() with mismatched force and the player undid deconstruction of tiles. (https://forums.factorio.com/103055)
    - Fixed highlight-box targeting entity not rendering before first update. (https://forums.factorio.com/103559)
    - Fixed spider-remote would lose connection when spider changes surface. (https://forums.factorio.com/103519)
    - Fixed SpidertronRemotePrototype was silently forcing stack size to 1 and not marking prototype as non stackable. (https://forums.factorio.com/103472)
    - Fixed that sounds with fade_out_ticks would synchronize when pausing the game while the sounds are fading out. (https://forums.factorio.com/103646)
    - Fixed idle sounds would synchronize when pausing the game. (https://forums.factorio.com/103648)
    - Fixed idle sounds for accumulators not starting in certain scenarios. (https://forums.factorio.com/103603)
    - Fixed idle sounds playing when they shouldn't for entities with max_sounds_per_type set.
    - Fixed inserters not highlighting the entity they would pick up from if said entity is a ghost while the inserter is not. (https://forums.factorio.com/100972)
    - Fixed a save's suggested save name not being updated when using non blocking saving. (https://forums.factorio.com/101610)
    - Fixed a crash when GUI style errors are found during loading. (https://forums.factorio.com/103688)
    - Fixed an item duplication when fast replacing underground belts with a damaged item. (https://forums.factorio.com/103711)
    - Fixed that loader could get stuck when feeding a burner generator. (https://forums.factorio.com/103719)
    - Fixed a crash when opening blueprint book item while tick is paused. (https://forums.factorio.com/103680)
    - Fixed a unit group that is building a base could have all its members distracted and still build a base. (https://forums.factorio.com/102586)
  Scripting:
    - Added LuaTechnology to LuaPlayer::opened.
    - Added LuaEntityPrototype::ammo_category read.
---------------------------------------------------------------------------------------------------
Version: 1.1.69
Date: 12. 09. 2022
  Graphics:
    - Updated transport belt icons.
  Bugfixes:
    - Fixed unregistering multiple events at once would not clear event filters. (https://forums.factorio.com/103207)
    - Fixed inactive mining drill playing its working sound for a moment when panning over it. (https://forums.factorio.com/103212)
    - Fixed a crash when pressing Alt+F4 or clicking the X button when in sound settings. (https://forums.factorio.com/103182)
    - Fixed a crash when changing the force of a logistic container marked for deconstruction. (https://forums.factorio.com/103278)
    - Fixed a crash in production score script when a rocket launch product has probabilistic amount. (https://forums.factorio.com/102649)
    - Fixed a crash in production score script when a resource entity is given no mineable products. (https://forums.factorio.com/103289)
    - Fixed collision mask util not ignoring other flags when checking "not-colliding-with-itself" masks. (https://forums.factorio.com/102684)
    - Fixed the player losing contents of the cursor when starting the round in tightspot scenario. (https://forums.factorio.com/102312)
    - Fixed wave defense losing all upgrades after some prototype changes. (https://forums.factorio.com/101241)
    - Fixed inactive entity working sound playing its fade-out when pausing and unpausing the game.
    - Fixed that mod ordering didn't work correctly when searching in the install mods GUI. (https://forums.factorio.com/103292)
    - Fixed that the 'starting points' in MapGenSettings wasn't loaded when importing a map exchange string. (https://forums.factorio.com/103356)
    - Fixed that event filters for on_pre_ghost_deconstructed and on_pre_ghost_upgraded weren't filtering correctly. (https://forums.factorio.com/103294)
    - Fixed that changing render threads to 1 while menu simulations were visible would crash the game. (https://forums.factorio.com/103361)
    - Fixed rocket silo would get stuck when rocket_parts was set during launch. (https://forums.factorio.com/103213)
    - Fixed smooth zoom behavior at high game speeds. (https://forums.factorio.com/102974)
    - Fixed a performance issue when many roboports re-activate at the same time. (https://forums.factorio.com/103383)
    - Fixed that the sync-mods-with-save GUI didn't work correctly when failing to download in some situations. (https://forums.factorio.com/103386)
    - Fixed solar panel equipment was unable to produce full expected power when solar multiplier was larger than 1. (https://forums.factorio.com/103066)
    - Fixed boiler's energy source buffer size was not updated when prototypes data changed. (https://forums.factorio.com/103008)
  Modding:
    - Added torso_bob_speed to the spider vehicle prototype.
  Scripting:
    - Added LuaEntityPrototype::torso_bob_speed read.
---------------------------------------------------------------------------------------------------
Version: 1.1.68
Date: 22. 08. 2022
  Bugfixes:
    - Fixed LuaControl::enable/disable_flashlight when LuaPlayer points at a player with CharacterController. (https://forums.factorio.com/103187)
    - Fixed incorrect fluid arrows on chemical plants, pumpjacks and oil refineries (https://forums.factorio.com/103191).
---------------------------------------------------------------------------------------------------
Version: 1.1.67
Date: 19. 08. 2022
  Minor Features:
    - Added support for SRV records on Linux and MacOS.
  Changes:
    - Updated the --audio-driver command line option description for Windows, and added the option for Linux and Mac.
    - Storage tanks can now show fluid connection info.
  Scripting:
    - Added LuaEntity::stop_spider().
  Modding:
    - Added FluidBox::hide_connection_info. When true the blue fluid connection arrows will not be drawn.
  Bugfixes:
    - Fixed a crash related to multiplayer latency and modded selection tools. (https://forums.factorio.com/103062)
    - Fixed an inserter activity progress being incorrect for certain orientations.
    - Fixed a sound instance leak. (https://forums.factorio.com/103045)
    - Fixed integer mod settings would allow decimal values. (https://forums.factorio.com/103092)
    - Fixed that renaming a spidertron wouldn't include the player during the Lua event. (https://forums.factorio.com/102993)
    - Fixed a lag spike when finishing selection of entities in chart view far from the center of the map. (https://forums.factorio.com/103134)
    - Fixed a crash related to copy tool when cursor stack was cleared during setup blueprint event. (https://forums.factorio.com/103124)
    - Fixed multiple instances of the same working sound syncing up, causing "phasing" artefacts.
    - Fixed fluid wagon fluid tooltips would round the amount shown incorrectly.
    - Fixed some sounds playing in fog-of-war when they shouldn't.
    - Fix modded entities not showing input-output fluid connection arrows (https://forums.factorio.com/103061).
---------------------------------------------------------------------------------------------------
Version: 1.1.66
Date: 19. 08. 2022
---------------------------------------------------------------------------------------------------
Version: 1.1.65
Date: 05. 08. 2022
  Bugfixes:
    - Fixed a crash related to audio. (https://forums.factorio.com/103033)
    - Fixed that it was possible to provide invalid path_resolution_modifier value to LuaSurface::request_path. (https://forums.factorio.com/103056)
    - Fixed double click interaction with number input. (https://forums.factorio.com/103011)
    - Fixed teleporting spidertrons across surfaces while also changing their position. (https://forums.factorio.com/103067)
    - Fixed manual filter insertion logic with modded container entities. (https://forums.factorio.com/103070)
---------------------------------------------------------------------------------------------------
Version: 1.1.64
Date: 02. 08. 2022
  Bugfixes:
    - Fixed a desync when using LuaGameScript::get_train_stops when there are multiple stops found.
    - Fixed a crash related to transport belts and item entities. (https://forums.factorio.com/103026)
    - Fixed linked container content was cleared when entity dies leaving a ghost. (https://forums.factorio.com/103029)
    - Fixed linked container content was cleared when fast-replacing through script. (https://forums.factorio.com/103021)
    - Fixed locomotives on curved rails would not snap to train stops. (https://forums.factorio.com/103020)
  Modding:
    - Added the entity prototype flag not-in-made-in to allow hiding things from the 'made in' recipe tooltip.
  Scripting:
    - Added LuaForce::color read.
    - Added LuaForce::custom_color read/write.
    - Added target to on_pre_ghost_upgraded.
    - Added target and direction to on_cancelled_upgrade.
    - Added LuaEquipmentGrid::find/count methods.
    - Added LuaEntityPrototype::tile_width/tile_height reads.
    - Added LuaEntity::tile_width/tile_height reads.
    - Added range_modifier, cooldown_modifier, consumption_modifier fields to AmmoType concept.
---------------------------------------------------------------------------------------------------
Version: 1.1.63
Date: 28. 07. 2022
  Changes:
    - Added PulseAudio driver for the SDL audio backend.
  Bugfixes:
    - Fixed a crash when trying to draw a wire connected linked container in a blueprint. (https://forums.factorio.com/102983)
    - Fixed linked containers with filters would not preserve filters while there are no containers placed. (https://forums.factorio.com/102988)
    - Fixed a crash when using SDL audio backend with configurations other than stereo. (https://forums.factorio.com/102980)
  Scripting:
    - Added LuaEquipmentGrid::unique_id read.
---------------------------------------------------------------------------------------------------
Version: 1.1.62
Date: 26. 07. 2022
  Minor Features:
    - Added support for SRV records on Windows.
  Changes:
    - Integrated SDL_Mixer for audio mixing, which is now the default mixer.
  Bugfixes:
    - Fixed a desync when canceling deconstruction of cliffs when a robot has already thrown the explosive. (https://forums.factorio.com/102216)
    - Fixed startup mod settings would show as being able to be reset while the game is running. (https://forums.factorio.com/102775)
    - Fixed an issue when installing mod dependencies related to base-game dependencies. (https://forums.factorio.com/102751)
    - Fixed an issue with biter AI that could freeze the game. (https://forums.factorio.com/102261)
    - Fixed a crash when viewing other player inventories when changing controllers. (https://forums.factorio.com/102863)
    - Fixed that the LuaPlayer::remove_alert 'prototype' parameter wouldn't accept an actual prototype instance. (https://forums.factorio.com/102860)
    - Fixed character inventory was not auto sorted when changing armor. (https://forums.factorio.com/102875)
    - Fixed that the reset-to-default tooltip for string mod settings wasn't fully localised. (https://forums.factorio.com/102847)
  Modding:
    - Modded tips and tricks information is remembered when the associated mods are temporarily removed/disabled.
    - Added support for container entities with filters by using inventory_type = "with_bar" or "with_filters_and_bar".
    - Added EntityPrototype::build_grid_size. Supported values are 1 (for 1x1 grid) and 2 (for 2x2 grid).
    - Added EntityPrototype::use_exact_mode.
    - Added support for circuit connections to linked containers.
  Scripting:
    - Added support to set player.opened to script inventories.
    - LuaEntity::get_connected_rail also returns rail_direction and rail_connection_direction going back to origin rail.
    - Added on_pre_ghost_upgraded event.
    - Added LuaEntity::get_rail_segment_rails.
    - Added LuaEntity::is_rail_in_same_rail_segment_as.
    - Added LuaEntity::is_rail_in_same_rail_block_as.
    - Added LuaEntity::get_parent_signals.
    - Added LuaEntity::get_child_signals.
    - Added LuaEntity::get_inbound_signals.
    - Added LuaEntity::get_outbound_signals.
    - Added LuaEntity::rocket_silo_status read and defines.rocket_silo_status
    - Added LuaBootstrap::register_metatable.
    - Added LuaLogisticNetwork::can_satisfy_request.
    - Added LuaLogisticNetwork::get_supply_counts.
    - Added LuaLogisticNetwork::get_supply_points.
    - Added LuaEntityPrototype::use_exact_mode read.
    - Added LuaEntityPrototype::active_energy_usage, idle_energy_usage, lamp_energy_usage reads.
    - Added rocket_silo_input, rocket_silo_output, rocket_silo_modules inventory defines.
---------------------------------------------------------------------------------------------------
Version: 1.1.61
Date: 23. 06. 2022
  Changes:
    - The game no longer requires re-entering server passwords when restarting to sync mods or mod settings.
    - When joining modded games mods and settings are synced at the same time reducing the number of restarts needed.
  Bugfixes:
    - Fixed server getting stuck at "Saving the map for player" for 20 seconds sometimes if a client disconnects shortly after connecting.
    - Fixed server getting stuck at "Saving the map for player" forever in some rare situations.
    - Fixed highlight box on curved-rail would not render selection box correctly. (https://forums.factorio.com/102601)
    - Fixed heavy-mode when character dies in multiplayer. (https://forums.factorio.com/102624)
    - Fixed that the "run forest, run" achievement could be unlocked by shooting trees instead of running them over. (https://forums.factorio.com/102623)
    - Fixed a crash when trying to read LuaEntity::neighbours on a WallConnectable when one of the neighbours is a ghost. (https://forums.factorio.com/102630)
    - Fixed recipe highlights in the assembling machine GUI. (https://forums.factorio.com/102612)
    - Fixed an issue with the prototype explorer GUI and guns. (https://forums.factorio.com/102658)
    - Fixed false-positive desyncs when using mods and running /c game.force_crc() or /toggle-heavy-mode (https://forums.factorio.com/102655)
    - Fixed a crash when defining a fluid stream prototype with zero particles. (https://forums.factorio.com/102679)
    - Fixed a GUI layering issue related to some error messages. (https://forums.factorio.com/102569)
    - Fixed not being able to open blueprint books in books through the quickbar. (https://forums.factorio.com/102681)
    - Fixed LuaSurface::find_entities_filtered would fail to find entities by collision mask if they only collide with tiles. (https://forums.factorio.com/102706)
    - Fixed that pump that cannot interact with fluid wagons would crash on save after position change. (https://forums.factorio.com/102643)
  Modding:
    - The mod settings GUI will now show the 'tooltip' icon for any settings that have tooltips.
    - Added a reset button to each mod setting in the mod settings GUI.
  Scripting:
    - Added LuaControl::crafting_queue_progress write.
    - Added LuaTile::tile_ghost.
    - Added 'to_be_deconstructed', and 'has_tile_ghost' filters to the options for LuaSurface::find_tiles_filtered.
    - Added LuaEntityPrototype::indexed_guns. It works as LuaEntityPrototype::guns but returns an array.
    - Collision-mask prototype filters for Entity, Tile and Decorative now support a 'contains-any' and 'contains-all' modes.
---------------------------------------------------------------------------------------------------
Version: 1.1.60
Date: 06. 06. 2022
  Optimizations:
    - Improved game startup time when using mods.
  Bugfixes:
    - Fixed that item requests didn't subtract items picked up from ground when reviving ghosts. (https://forums.factorio.com/102329)
    - Fixed burner inserter would not fuel itself when drop target was full. (https://forums.factorio.com/102449)
    - Fixed that inserters would report status other than "Waiting for space in destination" in certain cases. (https://forums.factorio.com/102225, https://forums.factorio.com/65351)
    - Fixed that Lua collision mask util didn't check for tile prototypes. (https://forums.factorio.com/102474)
    - Fixed that map pings would always round up the pinged location. (https://forums.factorio.com/102533)
    - Fixed that replays would always say mods didn't match. (https://forums.factorio.com/102526)
    - Fixed that canceling syncing mods with a save would exit the GUI.
    - Fixed that canceling syncing mods with a save through escape would leave the partially downloaded mods.
    - Fixed that the circular dependency error doesn't list all mods. (https://forums.factorio.com/102430)
    - Fixed a deadlock on loss of ConnectionAcceptOrDeny message. (https://forums.factorio.com/97596)
    - Fixed a desync when fast-replacing burner generators.
  Scripting:
    - Added LuaEntityPrototype::height, torso_rotation_speed, automatic_weapon_cycling, chain_shooting_cooldown_modifier, chunk_exploration_radius reads.
    - Added LuaEntityPrototype::animation_speed_coefficient.
    - Added LuaEntityPrototype::manual_range_modifier.
    - Added LuaEntityPrototype::dying_speed read.
    - Added sample_index parameter to LuaFlowStatistics::get_flow_count().
---------------------------------------------------------------------------------------------------
Version: 1.1.59
Date: 06. 05. 2022
  Bugfixes:
    - Quickbar shortcuts to items in blueprint books can be used again. (https://forums.factorio.com/102322)
    - Fixed grenade shadows.
    - Fixed it was possible to put blueprint book indirectly into itself (https://forums.factorio.com/102337)
---------------------------------------------------------------------------------------------------
Version: 1.1.58
Date: 02. 05. 2022
  Changes:
    - Significantly reduced the intensity of the red screen flash when the player character takes damage.
    - Changed fish so they won't swim into inactive chunks. (https://forums.factorio.com/102295)
    - Changed slowdown capsule and posion capsule icons to be matching in size. (https://forums.factorio.com/85558)
    - Added email authentication to login GUIs.
  Bugfixes:
    - Fixed that overwriting ItemRequestProxy item requests wasn't working properly in some cases when the same item was already requested. (https://forums.factorio.com/102022)
    - Fixed that loading a mod with a corrupted image file would crash the whole game on Linux. (https://forums.factorio.com/102067)
    - Fixed a crash with ghost overbuilding and script interactions. (https://forums.factorio.com/102136)
    - Fixed that infinite technologies didn't respect ignore_tech_cost_multiplier. (https://forums.factorio.com/102179)
    - Fixed that LuaEntity::belt_neighbours didn't work on ghosts. (https://forums.factorio.com/102178)
    - Fixed an issue with item-with-inventory extending inventories and quickbars. (https://forums.factorio.com/102095)
    - Fixed that a train stop helper would not draw when hovering inserters next to rails that were not straight connected to a train stop. (https://forums.factorio.com/101954)
    - Fixed a crash when fast replacing electric pole marked to be deconstructed when there is another ghost pole on top of it. (https://forums.factorio.com/101536)
    - Fixed a crash when creating a blueprint with connected electric pole while it has an upgrade target set to not electric pole. (https://forums.factorio.com/101375)
    - Removed a NaN check when loading map. (https://forums.factorio.com/102198)
    - Fixed a screenshot for save file preview would not account for a force of a player. (https://forums.factorio.com/102090)
    - Removed duplicated frame in grenade and cluster grenade animation. (https://forums.factorio.com/102060)
    - Fixed a map loading issue when changing mod dependencies and nothing else. (https://forums.factorio.com/102253)
    - Fixed a crash when trying to perform some actions while in multiplayer. (https://forums.factorio.com/101609)
    - Fixed rotating entities with non-symetric bounding boxes didn't work correctly. (https://forums.factorio.com/101611)
    - Fixed that already built pipes to ground could show removal indicators for pipes they are bridging when selected.
    - Fixed the runtime multiplayer settings GUI wouldn't fit on screen. (https://forums.factorio.com/102272)
    - Fixed that inserters could be flipped in some cases when they weren't supposed to allow it. (https://forums.factorio.com/102294)
    - Fixed that cliff deconstruction wasn't issued when the corrected cliff collision box overlapped with ghost entities. (https://forums.factorio.com/66400)
  Scripting:
    - Added on_research_cancelled.
    - Added on_player_reverse_selected_area.
---------------------------------------------------------------------------------------------------
Version: 1.1.57
Date: 29. 03. 2022
  Optimizations:
    - Improved overall performance by 5-10% when fully zoomed out.
  Bugfixes:
    - Fixed that some error messages wouldn't be translated. (https://forums.factorio.com/101815)
    - Fixed that biters might remain inactive when they should be activated. (https://forums.factorio.com/99989)
    - Fixed that units could teleport through cliffs if they bunched up close together. (https://forums.factorio.com/101834)
    - Fixed that setting LuaGuiElement::zoom to 0 would crash the game. (https://forums.factorio.com/101841)
    - Fixed a crash when changing mod options while the cursor hovers the "Back" button. (https://forums.factorio.com/101814)
    - Fixed a crash due to recursive chain signal update. (https://forums.factorio.com/101806)
    - Fixed that if a non-attack distraction command failed, it would raise the on_ai_command_completed event repeatedly. (https://forums.factorio.com/101870)
    - Fixed that opening web links in the Linux Steam build of the game could take unreasonably long. (https://forums.factorio.com/101339)
    - Fixed that logistic requests, item filters and similar could be set to the copy-paste tool when clicking the slot while holding that item. (https://forums.factorio.com/101861)
  Scripting:
    - Added LuaItemPrototype::reverse_* read for selection tool.
    - Added LuaEntity::radar_scan_progress read.
    - Added LuaEntityPrototype::logistic_parameters read.
    - Added LuaEntityPrototype::heat_buffer_prototype read.
    - Added LuaHeatEnergySourcePrototype::heat_buffer_prototype read.
---------------------------------------------------------------------------------------------------
Version: 1.1.56
Date: 09. 03. 2022
  Gui:
    - Some GUI fixes and improvements for screen resolutions under 1920x1080
    - Set the default GUI scale on the Steam Deck to 100%
  Bugfixes:
    - Fixed poison cloud sound fade out.
    - Fixed tooltips for vehicles would still show entry instructions even when no passengers are allowed. (https://forums.factorio.com/101689)
    - Fixed train stop names with different amounts of leading spaces being treated as equal in some cases but not in others. (https://forums.factorio.com/101660)
    - Fixed idle machines without idle sound counting towards the max_sounds_per_type limit. (https://forums.factorio.com/80745)
    - Fixed that changing the force of artillery wagons didn't work. (https://forums.factorio.com/101731)
    - Fixed a crash when using non-rectangular equipment. (https://forums.factorio.com/101778)
    - Fixed a crash when building underground belt or pipe ghosts over belts/pipes of other forces. (https://forums.factorio.com/101776)
    - Fixed character corpse armor variations being inconsistent with character armor variations. (https://forums.factorio.com/101781)
    - Fixed a consistency issue if a Lua event handler cancelled deconstruction of an entity that was marked for deconstruction as a result of fast-replace. (https://forums.factorio.com/100775)
---------------------------------------------------------------------------------------------------
Version: 1.1.55
Date: 23. 02. 2022
  Bugfixes:
    - Fixed that the Steam version wouldn't start on Linux and OSX.
---------------------------------------------------------------------------------------------------
Version: 1.1.54
Date: 23. 02. 2022
  Minor Features:
    - The multiplayer games browser can now filter games that are hosted on dedicated servers.
  Bugfixes:
    - Fixed west variation of Boiler and Heat exchanger graphics. (https://forums.factorio.com/100790)
    - Fixed save/load instability occuring when the game was saved after a robot threw cliff explosives but before the cliff exploded.
    - Fixed a crash when script tries to connect rolling stock during rolling stock destruction. (https://forums.factorio.com/101404)
    - Fixed LuaTransportLine::output_lines on a splitter's output transport line would incorrectly consider it an input transport line of that splitter. (https://forums.factorio.com/101435)
    - Fixed LuaTransportLine::input_lines would not return both input lines of a splitter.
    - Fixed that when train was created, a wrong end could be selected as a front when rolling stock at expected trains front was facing backward.
    - Fixed that it was possible to specify artillery-projectile as a place_result of an item. (https://forums.factorio.com/101448)
    - Fixed unnecessary disk writes when showing background simulations. (https://forums.factorio.com/101468)
    - Fixed that sometimes the host would not have admin rights when hosting a multiplayer game from a save.
    - Fixed LuaSurface::find_tiles_filtered would not cover bottom right tile.
    - Fixed that too many open RCON connections would crash the game. There is now a limit of maximum of 128 simultaneous RCON connections. (https://forums.factorio.com/101522)
    - Fixed a crash related to modded trains that could change travel direction due to air friction computation. (https://forums.factorio.com/101320)
    - Fixed energy consumers would get too much energy when supplied through multiple electric networks. (https://forums.factorio.com/101515)
    - Fixed a crash due to LuaLogisticCell not being invalidated when owner entity is being deleted. (https://forums.factorio.com/101550)
    - Fixed that non-lamp entities could be given the 'lamp' electric usage priority which would crash the game. (https://forums.factorio.com/101545)
    - Fixed locomotive placement would snap to wrong train stop when there are multiple stops available. (https://forums.factorio.com/101575)
    - Fixed that the whitelist button was enabled in the /config GUI. (https://forums.factorio.com/101230)
    - Fixed searching for items in controller gui would not highlight item stacks in the trash slots. (https://forums.factorio.com/101490)
    - Fixed that building underground belt ghosts with smart belt building would crash if ghosts are immediately revived by script. (https://forums.factorio.com/100619)
    - Fixed very high deconstruction_time_to_live value would lead to deconstruction orders expiring too soon. (https://forums.factorio.com/101605)
    - Fixed that a multiplayer client could desync several times in a row, making the server save the map for desync report multiple times.
    - Fixed that crafting recipes with products exceeding their stack limit would produce only a single full stack when crafting by hand. (https://forums.factorio.com/101614)
    - Fixed tips and tricks GUI staying open when changing controllers, and not being able to close it afterwards. (https://forums.factorio.com/100508)
    - Fixed PvP config for health bonus didn't apply correctly.
    - Fixed that if the game couldn't connect to a server due to corrupted data, it wouldn't show any error to the user. (https://forums.factorio.com/101654)
  Scripting:
    - Added 'is_military_target' filter to the options for LuaSurface::find_entities_filtered.
    - Added LuaFluidBox::get_fluid_system_id() method.
  Modding:
    - Added LocomotivePrototype::max_snap_to_train_stop_distance.
    - Added AutoplaceControl::can_be_disabled.
---------------------------------------------------------------------------------------------------
Version: 1.1.53
Date: 19. 01. 2022
  Bugfixes:
    - Fixed a crash that could happen if a unit failed in attacking another entity as a distraction. (https://forums.factorio.com/101286)
---------------------------------------------------------------------------------------------------
Version: 1.1.52
Date: 18. 01. 2022
  Bugfixes:
    - Fixed a crash related to LuaLazyLoadedValue trying to return LuaEntity pointing at EntityGhost's inner entity.
---------------------------------------------------------------------------------------------------
Version: 1.1.51
Date: 18. 01. 2022
  Changes:
    - When using /swap-players undo queues are now also swapped.
    - Improve performance of querying if an entity is registered for deconstruction from O(N) to O(1).
    - Adjusted default music volume.
  Bugfixes:
    - Fixed that if biters took damage from a forest fire, they would path toward the player who started it, no matter the distance. (https://forums.factorio.com/100894)
    - Fixed that replacing a tile between a colliding hidden tile (with check_collision_with_entities set to true) and an entity would not yield an item.
    - Fixed that LuaGameScript::ban_player would incorrectly use reason as a player name when given player was never in game. (https://forums.factorio.com/101053)
    - Fixed that the saving progress bar and other popups were placed behind the transparent pause overlay. (https://forums.factorio.com/100783)
    - Fixed a scenario could be created with temporary-state trains which were not properly deleted. (https://forums.factorio.com/101113)
    - Fixed a crash when using --map-settings while loading a multiplayer map. (https://forums.factorio.com/101089)
    - Fixed that trying to manually mine a resource that needs a mining fluid would sometimes produce sound of mining. (https://forums.factorio.com/100925)
    - Fixed script rendered arcs could be considered invisible when they were visible. (https://forums.factorio.com/101038)
    - Fixed that LuaEntity::belt_neighbours would return LuaEntity based on EntityGhost's inner entity, not the EntityGhost itself. (https://forums.factorio.com/101126)
    - Fixed fish preventing tiles building with check_collision_with_entities enabled.
    - Fixed that trains would not account for the train stop snap distance when already at the train stop with the back of a train. (https://forums.factorio.com/100779)
    - Fixed the intro music volume being set incorrectly.
    - Fixed that --start-server-load-latest when given an empty saves folder wouldn't work correctly. (https://forums.factorio.com/101119)
    - Fixed missing efficiency tooltip and incorrect fuel consumption tooltip value in generator equipment with burner energy source.
    - Fixed ghost electric poles connecting to ghost electric poles of other forces. Neutral force is exempt from this change. (https://forums.factorio.com/101021)
    - Fixed that biters would sometimes prefer running away over choosing another target. (https://forums.factorio.com/99767)
    - Fixed trains pathfinder would crash when a train is in a loop next to segment end and was requested to go to rail target in the middle of a loop. (https://forums.factorio.com/100645)
    - Fixed multi-level technologies showing the same saved progress in technology GUI. (https://forums.factorio.com/101060)
    - Fixed an icon of recipe notification on item group would show even if there are no recipes visible in a given context. (https://forums.factorio.com/101191)
    - Fixed a crash when defining too many icon variations. (https://forums.factorio.com/101245)
    - Fixed changing station name with rich text tags could crash when moving cursor by words. (https://forums.factorio.com/101216)
    - Fixed LuaBurner::inventory did not work correctly for some burner-energy-source entities. (https://forums.factorio.com/101255)
    - Fixed a crash caused by undoing an entity deconstruction which another player already cancelled. (https://forums.factorio.com/101251)
  Modding:
    - Added EntityPrototype::protected_from_tile_building, true by default.
      If set to false - entity won't block tile mining/building (with `TilePrototype::check_collision_with_entities` enabled).
    - Added LandMinePrototype::trigger_collision_mask.
    - Added EntityWithOwnerPrototype.
    - Added EntityWithOwnerPrototype::is_military_target and allow_run_time_change_of_is_military_target.
    - SimpleEntityWithForce now inherits from SimpleEntityWithOwner.
    - SpiderEnginePrototype::military_target is no longer used. If anything is provided it will make related SpiderVehiclePrototype to become a military target instead.
  Scripting:
    - Added LuaEntityPrototype::trigger_collision_mask read.
    - Added LuaEntity::is_military_target read. This deprecates LuaEntity::is_entity_with_force.
    - Added LuaEntityPrototype::is_entity_with_owner, is_military_target and allow_run_time_change_of_is_military_target read.
    - Added LuaEntity::get_spider_legs().
    - Added LuaEntity::neighbours read for cliffs.
---------------------------------------------------------------------------------------------------
Version: 1.1.50
Date: 21. 12. 2021
  Minor Features:
    - The permissions list in the permissions GUI can now be localised.
    - Removed feature where reactor collision box would increase when connected to neighbouring reactor (character can now walk in-between connected reactors)
  Bugfixes:
    - Fixed that biters could get stuck trying to attack an entity they were standing on. (https://forums.factorio.com/100269)
    - Fixed issue regarding placing an electric pole over a ghost of an electric pole connected to an enabled power switch. (https://forums.factorio.com/100388)
    - Fixed a crash related to units and mod events. (https://forums.factorio.com/100947)
    - Fixed ghost entities of other forces being considered valid drop targets. (https://forums.factorio.com/100880)
    - Fixed ghost electric poles connecting to electric poles of other forces. Neutral force is exempt from this fix, it can connect to everything. (https://forums.factorio.com/100922)
    - Fixed that LuaEntity::disconnect_neighbour was unable to disconnect specified pair of electric poles when they were on different surfaces.
    - Fixed gate cloning related to opened state. (https://forums.factorio.com/100862)
    - Fixed that on_game_created_from_scenario event didn't fire after pressing "Save and Play" from map editor. (https://forums.factorio.com/100624)
  Modding:
    - Added TilePrototype::check_collision_with_entities, false by default.
      If set to true - checks for collisions with entities before building or unearthing the tile.
    - Removed ReactorPrototype::neighbour_collision_increase.
---------------------------------------------------------------------------------------------------
Version: 1.1.49
Date: 07. 12. 2021
  Bugfixes:
    - Fixed transport belts picking up items on ground when rotated. (https://forums.factorio.com/100693)
    - Fixed that game.map_settings.path_finder.fwd2bwd_ratio could be set to nonsensical values. (https://forums.factorio.com/100785)
    - Fixed main menu track playing only once. (https://forums.factorio.com/100787)
    - Fixed that units could get stuck close to their goal. (https://forums.factorio.com/100348)
    - Fixed that the small research bar in a technology slot wouldn't show for the technology currently in research. (https://forums.factorio.com/100789)
    - Fixed a crash which was caused by early garbage collection of LuaObject because LuaObject method closures didn't hold a back reference to the object. (https://forums.factorio.com/57490)
    - Fixed barelling recipe icons having incorrect tint with index-based fluid color definitions. (https://forums.factorio.com/100815)
    - Fixed barelling recipe icons having incorrect alpha with fluid color definitions in 0-255 range.
  Scripting:
    - LuaObjects are now saved using binary format instead of previous format with intermediate Lua table.
      This speeds up general handling of LuaObjects and makes saving and loading with a lot of them noticable faster.
    - LuaObject::isluaobject now returns true instead of a magic string.
    - Clarified LuaGameScript::finished. (https://forums.factorio.com/99764)
    - Added LuaGameScript::finished_but_continuing read.
    - Added LuaGameScript::reset_game_state() method.
    - Implemented new website for Lua API documentation.
---------------------------------------------------------------------------------------------------
Version: 1.1.48
Date: 24. 11. 2021
  Modding:
    - Changed tip trigger name from "unlocked-recipe" to "unlock-recipe" to be consistent with the way other triggers are named.
---------------------------------------------------------------------------------------------------
Version: 1.1.47
Date: 22. 11. 2021
  Bugfixes:
    - Added tip about power pole coverage when drag-building.
    - Fixed that the distance between first and second pole in the dragging electric poles tutorial was 6 tiles instead of 7.
    - Fixed LuaGameScript::save_atlas() function would crash the headless server. (https://forums.factorio.com/100629)
    - Fixed possibility for the victory screen to be hidden behind other GUIs under specific circumstances (https://forums.factorio.com/100242)
    - Fixed generator and fluid energy source tooltip showing 0 fluid consumption if burning fluids with 0 fuel value or consuming fluids with temperature close to the default. (https://forums.factorio.com/100370)
    - Fixed the inserter "hand stack size" tooltip missing if the research-based bonus value was 1. Now it is shown if the value is greater than 0. (https://forums.factorio.com/100663)
    - Fixed the inserter "hand stack size" tooltip ignoring stack_size_bonus prototype property.
    - Fixed cloning linked-container would clear its inventory.
  Modding:
    - Added FluidEnergySourcePrototype::destroy_non_fuel_fluid, true by default.
    - Added GeneratorPrototype::destroy_non_fuel_fluid, true by default.
  Scripting:
    - Added LuaEntityPrototype::inserter_stack_size_bonus read.
    - Added LuaFluidEnergySourcePrototype::destroy_non_fuel_fluid read.
    - Added LuaStyle::bar_width read/write.
    - Added LuaPlayer::show_on_map read/write.
    - Reworked table saving and loading to be non-recursive. This allows to have extreme table nesting inside of `global` variable.
---------------------------------------------------------------------------------------------------
Version: 1.1.46
Date: 05. 11. 2021
  Bugfixes:
    - Fixed "create-trivial-smoke" triggers being interpreted as "create-entity" triggers in the prototype explorer which could cause a crash. (https://forums.factorio.com/100495)
    - Added migration for saves with inserters that have NaN hand height or hand length.
  Scripting:
    - Added LuaGuiElement::swap_children().
  Modding:
    - Sub items are now removed from items used in hand-crafting.
---------------------------------------------------------------------------------------------------
Version: 1.1.45
Date: 28. 10. 2021
  Bugfixes:
    - Added migration for saves with particles that have NaN movement vector.
---------------------------------------------------------------------------------------------------
Version: 1.1.44
Date: 27. 10. 2021
  Bugfixes:
    - Fixed that setting the scale parameter to zero in a spidertron leg definition would cause a "double value not in range for fixed point number" error. (https://forums.factorio.com/100394)
    - Fixed crash when destroying a vehicle on the same frame a tooltip is created for the vehicle's weapon and ammo bar. (https://forums.factorio.com/100122)
    - Fixed that building an entity over other forces' ghosts and undoing would transfer ownership of those ghosts to the undoer's force.
    - Fixed a crash when setting inserters to require no power when rotating/extending. (https://forums.factorio.com/100407)
---------------------------------------------------------------------------------------------------
Version: 1.1.43
Date: 26. 10. 2021
  Changes:
    - Reduced multiplayer latency on very good connections by up to 66ms(4 ticks). (https://forums.factorio.com/71901)
    - Changed multiplayer latency calculation to be smoother. This should reduce multiplayer stutter on bad connections.
    - Changed default network send rate from 30 to 60 packets per second and added an option to configure the rate in server-settings.json.
  Bugfixes:
    - Add a 70% damage bonus to discharge defenses with Energy Weapons Damage 6 and 7. (https://forums.factorio.com/100149)
    - Fixed flamethrower turrets not reporting the correct damage bonuses
    - Fixed gun turret tooltips showing the ammo in the middle of the other stats
    - Fixed artillery wagon and artillery turret tooltips not showing the damage of the loaded ammo
    - Fixed drawing wall filler when hovering mouse over ghosts. (https://forums.factorio.com/100243)
    - Fixed crash when trying to connect wire after wire type in cursor stack was changed by script. (https://forums.factorio.com/100220)
    - Fixed roboport would not output signals for 1 tick when electric pole was mined while having circuit wire from same circuit network. (https://forums.factorio.com/100221)
    - Fixed that the pole drag building skip trigger didn't work, so the tip was always shown even when the player used drag building.
    - Fixed LuaItemStack::get_tile_filter would incorrectly return entity filters. (https://forums.factorio.com/100288)
    - Fixed mining drill GUI not being openable if the drill didn't have module slots or energy source with GUI. (https://forums.factorio.com/100282)
    - Fixed a crash when using 0-length debug names in Lua bytecode. (https://forums.factorio.com/100321)
  Modding:
    - Added TurretPrototype::energy_glow_animation_flicker_strength.
    - Removed obsolete pollution-visualization sprite, which was replaced by pollution_color utility constant.
  Scripting:
    - Added LuaEntity::connected_rail_direction read.
    - Added TrainScheduleRecord::rail_direction.
---------------------------------------------------------------------------------------------------
Version: 1.1.42
Date: 11. 10. 2021
  Bugfixes:
    - Fixed an API error when checking for updates for a large number of mods. (https://forums.factorio.com/99801)
    - Fixed that inserters wouldn't remove burnt result items from assembling machine recipes with no item outputs. (https://forums.factorio.com/99799)
    - Fixed vehicle weapon slots GUI not highlighting with the corresponding ammo slot when selected
    - Fixed tank cannon weapon showing a "1" in the vehicle weapon slots GUI
    - Fixed that entities not containing certain collision masks would never collide with tiles. (https://forums.factorio.com/100132)
    - Fixed a crash when opening the tutorials GUI through Lua command. (https://forums.factorio.com/100166)
    - Rocket silo no longer drains more energy at night. (https://forums.factorio.com/100109)
    - Fix tank cannon showing smaller range than the cannon shells. (https://forums.factorio.com/100049)
    - Fix ugly death GUI when the game is paused in MP. (https://forums.factorio.com/100080)
    - Fix 'Game finished' GUI had an incorrect tooltip for the green button. (https://forums.factorio.com/99921)
    - Fixed that copy paste entity tips were dependant on the copy-paste tool tip instead of copy paste entity category.
  Modding:
    - Added OffshorePumpPrototype::check_bounding_box_collides_with_tiles.
    - RocketSiloPrototype::lamp_energy_usage now can be zero.
  Scripting:
    - Added freeplay remote interface to read the value of `skip_intro`. (https://forums.factorio.com/100169)
---------------------------------------------------------------------------------------------------
Version: 1.1.41
Date: 23. 09. 2021
  Bugfixes:
    - Fixed false positive tile corruption detection when 255 tile prototypes were defined. (https://forums.factorio.com/100036)
    - Fixed pollution overlay misalignment at certain zoom level/map position combinations. (https://forums.factorio.com/99705)
---------------------------------------------------------------------------------------------------
Version: 1.1.40
Date: 22. 09. 2021
  Features:
    - Added auth server bans feature for multiplayer games.
      When enabled this will inform the Factorio.com authentication server of ban and unban commands issued in multiplayer sessions.
      Designed to combat griefers in multiplayer games, it will also query the authentication server for a ban recommendation when a user tries to connect.
  Bugfixes:
    - Fixed that trigger prototype flag filters didn't work correctly when an entity had no flags set. (https://forums.factorio.com/99773)
    - Fixed a crash after inserting fuel into burner inserter while it was already trying to fuel itself. (https://forums.factorio.com/99858)
    - Fixed that unrelated entities were highlighted when using a cut tool. (https://forums.factorio.com/99720)
    - Fixed that in editor mode undoing deconstructions did not instantly revive affected entities. (https://forums.factorio.com/99622)
    - Fixed that setting the direction of a script created character entity didn't work correctly. (https://forums.factorio.com/99887)
    - Fixed that items with fuel value would be put into furnace fuel inventory when there was enough fuel but item could be smelted. (https://forums.factorio.com/99924)
    - Fixed inserters picking up items on ground marked for deconstruction. (https://forums.factorio.com/99770)
    - Fixed that the low power tip didn't show in some circumstances.
    - Tweaked some of the triggers to show/skip tutorials related to drag building.
    - Fixed that Furnace's working_visualisations would not apply recipe tint on fadeout. (https://forums.factorio.com/99997)
    - Fixed crash due to usage of standard library function that is missing on macOS 10.11. (https://forums.factorio.com/100012)
---------------------------------------------------------------------------------------------------
Version: 1.1.39
Date: 01. 09. 2021
  Bugfixes:
    - Fixed that rotating belt direction when dragging allowed "stash" the rotate and continue in the original direction. (https://forums.factorio.com/99572)
    - Fixed that loading a game that was saved during drag building didn't clear the internal drag building state causing blueprint snapping not working properly. (https://forums.factorio.com/99496)
    - Fixed that LuaGameScript::check_prototype_translations() didn't check technologies. (https://forums.factorio.com/99672)
    - Fixed that items with data would not stack properly in crafting machine source inventory when recipe requires more than a stack of ingredient. (https://forums.factorio.com/99708)
    - Fixed that pasting a blueprint over existing train could cause a desync. (https://forums.factorio.com/99592)
    - Fixed that it was possible to interact with locomotive's fuel slots while out of reach. (https://forums.factorio.com/99731)
    - Fixed wrong status text when a mining drill drop target is marked for deconstruction. (https://forums.factorio.com/99679)
    - Fixed wrong mining drill status when a resource is depleted while the mining drill is missing the required fluid. (https://forums.factorio.com/99527)
    - Fixed the blueprint snap-to-grid reference point being drawn behind entities in some situations. (https://forums.factorio.com/99704)
  Scripting:
    - LuaEntityPrototype::resource_categories now supports characters.
    - Added on_equipment_inserted and on_equipment_removed events that fire any time any equipment is added/removed from a grid.
---------------------------------------------------------------------------------------------------
Version: 1.1.38
Date: 18. 08. 2021
  Changes:
    - New Titillium style font for Cyrillic languages.
  Bugfixes:
    - Fixed inconsistency when fast-replacing ghosts with circuit connections. (https://forums.factorio.com/98948)
    - Fixed an issue with drag-building electric poles with long wire reach. (https://forums.factorio.com/99205)
    - Fixed a crash related to tutorials and modding. (https://forums.factorio.com/99385)
    - Fixed an issue with LuaEntity::set_request_slot() and duplicates. (https://forums.factorio.com/99209)
    - Fixed that picking blueprints from the library through quickbar slots didn't fire the Lua cursor stack changed event. (https://forums.factorio.com/99573)
    - Fixed items with durability/ammo wouldn't merge properly in some cases. (https://forums.factorio.com/99087)
    - Fixed a roboport "recharging" icon appearing when not connected to the electric network. (https://forums.factorio.com/99582)
    - Fixed an issue with roboports left in recharging state when revived from ghosts. (https://forums.factorio.com/99582)
    - Fixed an issue where an error sound played when pasting onto a power switch from anything other than another power switch (https://forums.factorio.com/99378)
    - Fixed that the non-blocking saving option would be reset when resuming a multiplayer game using the continue button. (https://forums.factorio.com/99035)
    - Fixed 'Close preview' button having cut off text in some locales. (https://forums.factorio.com/99551)
    - Fixed a crash when deleting surfaces with script-connected electric poles. (https://forums.factorio.com/99641)
  Scripting:
    - Added LuaEntity and LuaUnitGroup::set_distraction_command.
    - Added LuaSurface::find_nearest_enemy_entity_with_owner().
    - Added LuaForce::is_friend() and is_enemy().
---------------------------------------------------------------------------------------------------
Version: 1.1.37
Date: 04. 08. 2021
  Bugfixes:
    - Fixed several issues related to latency state and quickbar.
    - Fixed underground belt related tips and tricks performing incorrectly. (https://forums.factorio.com/99320)
    - Fixed forced autosave flag would persist into loading another map if the current map got terminated due to script error before performing the autosave. (https://forums.factorio.com/99360)
    - Fixed a crash when loading some corrupt save files. (https://forums.factorio.com/99382)
    - Fixed a crash when using specific mods. (https://forums.factorio.com/99408)
    - Fixed that disabled mod dependencies would get re-downloaded when installing mods. (https://forums.factorio.com/99343)
    - Fixed starting message dialog was darkened in the Sandbox scenario. (https://forums.factorio.com/99287)
    - Fixed the missing dots icon on the tiny shortcut bar expand button.
    - Fixed that repeated clicking on the Snap to grid checkbox in the blueprint setup gui didn't work unless the mouse moved away and back. (https://forums.factorio.com/99396)
    - Removed references to iron-axe and steel-axe from the PvP scenario config. (https://forums.factorio.com/99308)
    - Fixed inserters filters would get cleared in some cases when building from blueprints. (https://forums.factorio.com/99363)
  Modding:
    - Changed mining drill storage_slots to be automatic.
    - Added destroy_action to logistic and construction robot prototypes.
    - Inserters can now pull from the main output and burnt result inventory of an entity.
  Scripting:
    - Added LuaControl::is_cursor_empty(). Returns if the cursor is empty, taking into account items, ghost cursor, and items from the blueprint library.
    - Added on_worker_robot_expired event. Called when a worker (construction or logistic) robot expires through a lack of energy.
---------------------------------------------------------------------------------------------------
Version: 1.1.36
Date: 12. 07. 2021
  Bugfixes:
    - Fixed belt drag building on the edge of building reach. (https://forums.factorio.com/97178)
    - Fixed that canceling upgrade of underground belt didn't make the corresponding operation with the (potentially) connected belt on the other side.
    - Fixed making blueprint from underground belt with direction upgrade order.
    - Fixed technology icons of flamethrower and rocketry. (https://forums.factorio.com/98821)
    - Fixed hang when deleting blueprint/deconstruction/upgrade planner or blueprint book held by an inserter. (https://forums.factorio.com/98329)
    - Fixed hang when trying to delete blueprint/deconstruction/upgrade planner or blueprint book that was moved to different inventory in the meantime. (https://forums.factorio.com/98329)
    - Fixed pressing delete key in save/load game menus multiple times would pop-up confirmation dialog multiple times. (https://forums.factorio.com/98100)
    - Fixed that the close map generator preview button icon was too large. (https://forums.factorio.com/98545)
    - Fixed that the show/close map generator preview button didn't loose hover after the preview was shown.
    - Fixed that Cut and copy paste tools select trains in the standard selection mode, even when trains are ignored in this mode. (https://forums.factorio.com/98344)
    - Fixed crash related to wrong identification of non-default values in the mod settings gui. (https://forums.factorio.com/98903)
    - Fixed that linked custom inputs didn't work for some game controls. (https://forums.factorio.com/98851)
    - Fixed that the train fuel tab didn't work right for clients in multiplayer. (https://forums.factorio.com/98377)
    - Fixed a crash when using the prototype explorer GUI after just changing mods. (https://forums.factorio.com/98736)
    - Fixed rare corner case related to removal of mods and entities in more than 1 electric network. (https://forums.factorio.com/98576)
    - Fixed item product overload logic when using variable output items. (https://forums.factorio.com/98833)
    - Fixed crash when starting game without base mod and with --disable-prototype-history. (https://forums.factorio.com/98968)
    - Fixed a crash when using set_stack in blueprint books. (https://forums.factorio.com/98967)
    - Fixed a crash when cloning script-disabled beacons. (https://forums.factorio.com/98960)
    - Fixed a crash when using repeat_count with frame_sequence in animation definition. (https://forums.factorio.com/98904)
    - Fixed a crash when trying to build a rolling stock between other rolling stocks from a single train. (https://forums.factorio.com/99054)
    - Fixed ghost entities had reflections on water.
    - Fixed a desync related to processing on_gui_opened event of opening blueprint records in multiplayer games.
    - Fixed a crash when trying to pick a fluid wagon with fluid in clone tool. (https://forums.factorio.com/99081)
    - Fixed that copying assembling machine recipes didn't update fluidbox temperature filters in some cases. (https://forums.factorio.com/99111)
    - Fixed that robots could sometimes leave roboports very slowly if they were called to work in the middle of descending into a roboport. (https://forums.factorio.com/98902)
    - Fixed trains GUI status button tooltip not updating. (https://forums.factorio.com/99130)
    - Fixed LuaPlayer::build_from_cursor would flip direction when every other building underground belts/pipes. (https://forums.factorio.com/99074)
    - Fixed Train GUI wait condition bars display with 0 slot cargo wagons. (https://forums.factorio.com/99075)
    - Fixed in-game EULA showing HTML character sequences. (https://forums.factorio.com/99123)
  Scripting:
    - Fixed clearing LuaCustomChartTag.icon by writing nil or empty SignalID.
    - Added LuaPlayer::start_selection and clear_selection.
    - Added freeplay remote interface methods for adjusting the crashsite.
  Modding:
    - Added overlay layer to the tree variation definitions. (https://forums.factorio.com/98052)
    - Fixed parameter substitution when used with standard parameter (https://forums.factorio.com/98175)
    - Removed unused equipment prototype property "ability_icon".
    - Added select_group_row_count, select_slot_row_count, inventory_width, module_inventory_width, tooltip_monitor_edge_border,
      normalised_achievement_icon_size, tutorial_notice_icon_size and flying_text_ttl to utility constants.
---------------------------------------------------------------------------------------------------
Version: 1.1.35
Date: 16. 06. 2021
  Bugfixes:
    - Fixed multiple issues related to placing blueprints with electric poles near other electric poles or ghost thereof. (https://forums.factorio.com/97398)
    - Fixed a lighting issue with QCK Prism mousepads. (https://forums.factorio.com/98393)
    - Fixed recipe notifications when a recipe is hidden from hand crafting. (https://forums.factorio.com/98328)
    - Fixed that units dying wouldn't contain the unit group they were part of. (https://forums.factorio.com/98142)
    - Fixed a crash when migrating entities across types in some cases. (https://forums.factorio.com/97882)
    - Fixed several crashes when writing to disk fails. (https://forums.factorio.com/98386)
    - Fixed that searching descriptions of some items didn't work correctly. (https://forums.factorio.com/98378)
    - Fixed that fast-replacing gates would remove wall control behaviors. (https://forums.factorio.com/98369)
    - Fixed desync related to manually fast replacing both ends of underground belt in a way, that they don't connect in the end.
    - Fixed desync related to fast manually fast replacing both ends of underground belt in a way, that they don't connect in the end.
    - Fixed a crash when trying to edit the whitelist on a server while autosave happens. (https://forums.factorio.com/98447)
    - Fixed counting tiles when part of search area hits non existing chunks. (https://forums.factorio.com/98684)
    - Fixed that gate technology had no description. (https://forums.factorio.com/98683)
    - Fixed loaders would leave a gap on belt when items started moving. (https://forums.factorio.com/98703)
    - Fixed nuke did not vaporize things in the epicenter of the blast and would leave corpses and remnants behind.
    - Fixed a crash when using items with inventories that contain construction robots. (https://forums.factorio.com/98706)
    - Fixed a crash when making a new game from a scenario with the map editor in a vehicle. (https://forums.factorio.com/98682)
    - Fixed not being able to leave large cars with certain shape. (https://forums.factorio.com/98729)
    - Fixed that using large values in the map editor "tick custom" field didn't work correctly. (https://forums.factorio.com/98798)
    - Fixed that radar coverage preview wasn't visible when the mouse was above invisible parts of the GUI. (https://forums.factorio.com/97500)
    - Fixed Terrain water checkbox in map generation settings didn't have the tooltip info icon. (https://forums.factorio.com/97953)
    - Fixed that the mining drill GUI couldn't be moved off screen. (https://forums.factorio.com/98113)
    - Fixed science pack requirement objective in supply challenge. (https://forums.factorio.com/98267)
    - Fixed that tooltips of slots in the statistics GUIs didn't account for force bonuses. (https://forums.factorio.com/97931)
    - Fixed that upgrading underground belts marked for upgrade didn't properly upgrade the (potentially) connected belts on the other side. (https://forums.factorio.com/98849)
    - Fixed LuaEntityPrototype::module_inventory_size would return nil when entity has 65535 slots for modules. (https://forums.factorio.com/98867)
  Scripting:
    - Added a machine-readable JSON format of the runtime documentation, which can be used by developer tools to provide code completion and related functionality.
    - Added vertical_alignment parameter for LuaRendering::draw_text.
---------------------------------------------------------------------------------------------------
Version: 1.1.34
Date: 24. 05. 2021
  Scripting:
    - Added LuaEntityPrototype::air_resistance read.
  Bugfixes:
    - Fixed black border in spidertron technology icon. (https://forums.factorio.com/98224)
    - Fixed that having non standard UI scale would render screen white. (https://forums.factorio.com/98218)
    - Fixed that train could get stuck in destination_full state with available goals when a train stop was built next to ghost rail. (https://forums.factorio.com/98310)
    - Fixed that LuaPlayer::disable_alert() didn't work for custom alerts. (https://forums.factorio.com/98261)
    - Fixed that piercing damage didn't work correctly with turrets. (https://forums.factorio.com/98134)
    - Fixed that LuaSurface::clone_brush() didn't clone entities correctly. (https://forums.factorio.com/98197)
    - Fixed trees with not-flammable flag would still catch on fire. (https://forums.factorio.com/98414)
    - Fixed blueprints and copy-paste tools didn't capture planned direction changes of entities. (https://forums.factorio.com/98172)
    - Fixed that changing train stop limit would not set last player. (https://forums.factorio.com/98441)
    - Fixed desync when beacons lose power. (https://forums.factorio.com/98445)
    - Fixed spidertron item icon would look different after changing the spidertron color back to its default value. (https://forums.factorio.com/98204)
    - Fixed that Tips and tricks trigger related to setting up a logistic chest request was also triggered when setting up the personal request.
    - Fixed that achievements could block the finished game window.
    - Fixed crash when loading font wingding.ttf. (https://forums.factorio.com/98492)
---------------------------------------------------------------------------------------------------
Version: 1.1.33
Date: 03. 05. 2021
  Graphics:
    - Reworked all technology icons, and provided higher resolutions used by high GUI scale.
    - Changed item icons for armors, to match the progression and tech icons better.
  Changes:
    - Armor stages on the player character show as 1st with Light armor, and as 2nd with Modular armor.
  Bugfixes:
    - Roboport normal resolution graphics have been updated to be a downscale from the high resolution graphics. (https://forums.factorio.com/97848)
    - Fixed cut-tool showing distinct selection color when holding shift. (https://forums.factorio.com/97864)
    - Fixed armor rich text tags not using the correct icon. (https://forums.factorio.com/97138)
    - Fixed pumpjack showing item drop indication arrows. (https://forums.factorio.com/97421)
    - Fixed being unable to confirm the migrated content window if there was a game GUI open behind it. (https://forums.factorio.com/97458)
    - Fixed a bad Lua event when invalidating the owning players controller during the gui closed event. (https://forums.factorio.com/97425)
    - Fixed scaling of icons on buttons with more than 200% UI scale.
    - Fixed issue where ghosts overlapping with non-ghost entity in cloned area is not cloned. (fixes https://forums.factorio.com/97861)
    - Fixed using upgrade planner without explicit filters on entities marked for upgrade would not upgrade the existing upgrade orders.
    - Fixed a crash with mods and chunk generation in some cases. (https://forums.factorio.com/98002)
    - Fixed the wrong technology level shown on the icon in the currently selected technology.
    - Fixed the missing notification (i) icon on the recipe group button, when there are more groups, so the tabs are shown as buttons instead.
    - Fixed a crash when trying to undo actions done on a surface that was deleted in the meantime. (https://forums.factorio.com/98105)
    - Fixed that train would sometimes NO_PATH during repath while in intersection where the path passes through a block that is already occupied by that train. (https://forums.factorio.com/98150)
    - Fixed a crash when the link_id of a linked container is changed while a non-admin has the GUI open. (https://forums.factorio.com/98154)
  Modding:
    - Added "add" and "remove" modes to the Infinity pipe and Heat interface.
  Scripting:
    - Removed the "tile-build" SoundPath type. It has been replaced with "tile-build-small", "tile-build-medium", "tile-build-large",
      allowing mods to specify which size they want to refer to.
    - Added LuaEntityPrototype::related_underground_belt read.
    - Added "add" and "remove" modes to `InfinityPipeFilter` and `HeatSetting.`
---------------------------------------------------------------------------------------------------
Version: 1.1.32
Date: 14. 04. 2021
  Bugfixes:
    - Fixed color blending with a fully transparent color would produce slightly darker original color. (https://forums.factorio.com/97813)
    - Fixed that clicking gps tags in chat would also trigger chart drag causing chart to be not centered on gps tag. (https://forums.factorio.com/97839)
    - Fixed market gui would show wrong numbers when an offer has the same item multiple times. (https://forums.factorio.com/97477)
    - Fixed turret range could sometimes render long line to the top left corner of game window.
---------------------------------------------------------------------------------------------------
Version: 1.1.31
Date: 13. 04. 2021
  Bugfixes:
    - Fixed various issues related to how chat tags are open. (https://forums.factorio.com/97141)
    - Fixed that replays would break after winning the game. (https://forums.factorio.com/96774)
    - Fixed that listbox would loose focus when clicking on other widgets that can't be focused anyway.
    - Fixed GUI crash when furnaces would select recipes that have more products than it's output inventory size. (https://forums.factorio.com/97314)
    - Fixed that fluids could be purged from the whole fluid system in certain cases. (https://forums.factorio.com/97338)
    - Fixed a crash when loading save files in some cases. (https://forums.factorio.com/97363)
    - Fixed locale related to deconstruction planner tile selection mode. (https://forums.factorio.com/97653)
    - Fixed advanced rail signal tutorial losing items held in the cursor. (https://forums.factorio.com/97662)
    - Fixed Alt+F4 would close the game on Windows even when other modifier keys were pressed. (https://forums.factorio.com/97710)
    - Fixed that NAT-punching didn't work correctly. (https://forums.factorio.com/97688)
    - Fixed that some infinite crafting recipes didn't work as intermediates. (https://forums.factorio.com/96775)
    - Fixed crash when an entity marked for an upgrade is selected for another upgrade in multiplayer in some cases. (https://forums.factorio.com/97586)
  Modding:
    - Added defines.prototypes which contains all prototype type names (eg: defines.prototypes.entity = { container, furnace, assembling-machine, ... })
---------------------------------------------------------------------------------------------------
Version: 1.1.30
Date: 24. 03. 2021
  Bugfixes:
    - Fixed that building by moving ignored the position where the player built the last entity. (https://forums.factorio.com/97179)
    - Fixed a crash that could happen when viewing the tooltip for certain types of ammo. (https://forums.factorio.com/97276)
    - Fixed that ammo tooltips sometimes wouldn't show damage info. (https://forums.factorio.com/97277)
---------------------------------------------------------------------------------------------------
Version: 1.1.29
Date: 24. 03. 2021
---------------------------------------------------------------------------------------------------
Version: 1.1.28
Date: 24. 03. 2021
  Minor Features:
    - Blueprints and copy paste of entities with upgrade order are created based on the upgrade order instead of the current entity. (https://forums.factorio.com/73287)
    - Enabled upgrading entities marked for upgrade, in which case, the upgrade target is used as the source entity for the upgrade planner filters.
    - The announcement of player death now contains GPS tag with the location.
  Balancing:
    - Increased the tank braking power from 400kw to 800kw. Before this change, the tank acceleration (600kw) was actually even greater than the braking force.
  Bugfixes:
    - Fixed incorrect color lookup table interpolation for ambient light around noon.
    - Fixed that built electric pole from map view was also opened with the same click with alternative key binding. (https://forums.factorio.com/96607)
    - Fixed that laser and fluid turret bonus, wasn't shown properly in the tooltip. This bonus is not used in vanilla which uses ammo category bonus. (https://forums.factorio.com/96566)
    - Fixed that part of the flamethrower turret and flamethrower ammo turret description, which describes the properties of the flame bound
      to its targets didn't show the bonus damage from upgrades. (https://forums.factorio.com/96566)
    - Fixed that mod install could cause removal of blueprint entities if it didn't remove the entity, but just made it not acceptable
      to be used in blueprint. (https://forums.factorio.com/96852)
    - Fixed that the confirm load game dialog with 2 green arrow buttons had tooltips with (E) to confirm, while the E to confirm doesn't work
      here as it would be ambiguous. (https://forums.factorio.com/96904)
    - Fixed crash related to using smart ghost belt building with a mod that specifies belt without related underground belt. (https://forums.factorio.com/96875)
    - Fixed that renaming Spidertron didn't trigger on_entity_renamed. (https://forums.factorio.com/96955)
    - Fixed that disabling side menu guis through script would sometimes leave an empty frame. (https://forums.factorio.com/96991)
    - Fixed that crafting machines wouldn't wake up when the speed effect was changed in some situations. (https://forums.factorio.com/96457)
    - Fixed that focus-search didn't in some GUIs work while in the map editor. (https://forums.factorio.com/96909)
    - Fixed that chat icon selector didn't remember the last opened tab when used outside the game.
    - Fixed that pressing Escape with the chat icon selector opened in a dialog outside the game closed the whole dialog instead of closing just the selector window.
    - Fixed that pressing Control + F to search in the chat icon selector that is opened on top of a non-game window that already had search activated the bottom window search.
    - Fixed that enabled train stops would cause schedule records for trains on different surfaces to be rendered as available. (https://forums.factorio.com/96799)
    - Fixed rare crash when using Map editor -> Convert save. (https://forums.factorio.com/97188)
    - Fixed electric pole connection consistency issue related to fast replace of modded entities. (https://forums.factorio.com/96929)
  Modding:
    - Added mod dependency modifier "~", which marks the mod as required, but doesn't affect mod loading order, so these kind of
      dependencies can be circular.
    - Prototype/EntityWithHealth::healing_per_tick is now also used by trees, so their automatic healing is no longer hardcoded. (https://forums.factorio.com/97082)
    - Loaders are now able to take or insert more than 1 item per transport line per tick. (https://forums.factorio.com/81447)
  Gui:
    - Tweaked search in the install mods GUI, so the search order prioritizes the results more naturally.
    - Unified the search button in the mod settings GUI.
    - Improved some descriptions in Map Generator GUI. (https://forums.factorio.com/97131)
---------------------------------------------------------------------------------------------------
Version: 1.1.27
Date: 11. 03. 2021
  Bugfixes:
    - Fixed trees and stones would block placement of wall ghosts. (https://forums.factorio.com/96529)
    - Fixed interaction with entities from zoomed-to-world view in editor. (https://forums.factorio.com/96530)
    - Fixed spidertrons with burner energy sources didn't interact with auto-trash correctly. (https://forums.factorio.com/96461)
    - Fixed a crash when viewing styles in the prototype explorer GUI. (https://forums.factorio.com/96638)
    - Fixed a crash when fast-replacing electric pole ghosts with non-electric-poles. (https://forums.factorio.com/96652)
    - Fixed that robots building trains with equipment grids didn't work correctly. (https://forums.factorio.com/96666)
    - Fixed that changes in mod settings textboxes weren't highlighted when hovering reset/back button. (https://forums.factorio.com/96715)
    - Fixed that pressing Escape in mod settings with unconfirmed changes didn't open the confirmation dialog as in other settings.
    - Fixed crash when mod destroys currently opened locomotive and creates and opens new one right away.  (https://forums.factorio.com/96707)
    - Fixed mods gui for case when the mod title can't fit the space. (https://forums.factorio.com/96687)
    - Fixed unloadable save related to underground belts in a weird state. (https://forums.factorio.com/96685)
    - Fixed corner case of drawing wires between ghosts and non-ghost entities. (https://forums.factorio.com/96728)
    - Fixed a crash when using upgrade planners through the Lua API. (https://forums.factorio.com/96778)
    - Fixed wrong entity selection in multiplayer when using ghost cursor with rail. (https://forums.factorio.com/96443)
    - Fixed accumulator charged status for some extreme cases. (https://forums.factorio.com/96578)
  Modding:
    - Limited the name and title of the mod to 100 characters.
---------------------------------------------------------------------------------------------------
Version: 1.1.26
Date: 01. 03. 2021
  Bugfixes:
    - Fixed that all entity GUIs in the map editor entity-editor and spectator controller were invisible.
    - Fixed Train overview GUI not updating the list remark. (https://forums.factorio.com/96262)
    - Fixed typos in Construction robot tip. (https://forums.factorio.com/96360)
    - Fixed a crash when quitting while using the linked-container entity type with power armor in it.
    - Fixed that sounds could sometimes be heard when they shouldn't. (https://forums.factorio.com/96343)
    - Fixed regenerating tile variations during save migration would not break up old large tiles and would only reset their variations to 0.
    - Fixed "probability" property of size variants in the tile definition was ignored when "weights" property was left out.
    - Fixed searching mod settings tab would leave tabs disabled. (https://forums.factorio.com/96489)
    - Fixed a crash of transport line migration in some cases of mod removal. (https://forums.factorio.com/96342)
    - Fixed that train stop gui could indicate more trains than there are when trains are removed or merged while gui is opened. (https://forums.factorio.com/96519)
    - Fixed a conflict between setting the players cursor through script and holding blueprint library blueprints. (https://forums.factorio.com/96452)
    - Fixed that building entity with multiple items to place would take unrelated items from inventory. (https://forums.factorio.com/96536)
  Minor Features:
    - Control click on the load button in the load game dialog forces loading in "prototypes changed" mode, which can be useful to avoid some specific problems,
      and also to force consistency check on load.
  Modding:
    - Added CustomInputPrototype::include_selected_prototype when true the event will include
      selected_prototype = {base_type=, derived_type=, name=} when applicable.
  Scripting:
    - Added LuaCustomInputPrototype::enabled_while_spectating, enabled_while_in_cutscene, include_selected_prototype, and item_to_spawn read.
---------------------------------------------------------------------------------------------------
Version: 1.1.25
Date: 17. 02. 2021
  Bugfixes:
    - Changed defines.flow_precision_index.one_second to five_seconds since that's what it actually is.
    - Fixed crash related to loading that trigger migration to remove invalid upgrades.
    - Fixed that confirming the low value in logistic request didn't update the value. (https://forums.factorio.com/96234)
    - Fixed that E to confirm didn't work in the game reconnect dialog. (https://forums.factorio.com/96292)
---------------------------------------------------------------------------------------------------
Version: 1.1.24
Date: 16. 02. 2021
  Bugfixes:
    - Fixed a crash related to building instant blueprints in editor. (https://forums.factorio.com/96197)
    - Fixed a visual in blueprint building preview when building walls over walls. (https://forums.factorio.com/96212)
---------------------------------------------------------------------------------------------------
Version: 1.1.23
Date: 16. 02. 2021
  Bugfixes:
    - Fixed a crash that could happen when certain sound effects would play. (https://forums.factorio.com/96177)
---------------------------------------------------------------------------------------------------
Version: 1.1.22
Date: 15. 02. 2021
  Optimizations:
    - Improved performance when building blueprints in multiplayer. (https://forums.factorio.com/95901)
  Bugfixes:
    - Fixed Artillery wagon and turret showing wrong tooltip title in deconstruction planner. (https://forums.factorio.com/95847)
    - Fixed control setting buttons wouldn't have a tooltip when they started without a set value. (https://forums.factorio.com/95874)
    - Possible fix for multiplayer server crashing when a client tries to connect. (https://forums.factorio.com/95773)
    - Fixed a crash in multiplayer when upgrading or deconstructing. (https://forums.factorio.com/95948)
    - Removed and tweaked some hidden locale to hopefully make 100% possible. (https://forums.factorio.com/95743)
    - Added explicit values to the circuit network range specification in the tips and tricks. (https://forums.factorio.com/95829)
    - Fixed that the copy and paste tips and tricks simulation wasn't working properly. (https://forums.factorio.com/95978)
    - Fixed that LuaFlowStatistics::get_flow_count didn't work correctly. (https://forums.factorio.com/96022)
    - Fixed that instant blueprint building in the map editor didn't work with undo. (https://forums.factorio.com/96015)
    - Fixed missing status for wall controlling gate by circuit network. (https://forums.factorio.com/95875)
    - Fixed a crash when saving when using LuaItemStack::create_grid() on stacks with a count > 1. (https://forums.factorio.com/96053)
    - Fixed that enter to confirm a logistic request count didn't work. (https://forums.factorio.com/95845)
    - Fixed pole dragging corner case. (https://forums.factorio.com/95790)
    - Fixed padding in the sync mods with save window when scroll is activated.
    - Fixed invalid "Can't reach" message when using ghost cursor to build rails in the latency state.
    - Fixed wrong status of rail signal next to rail with wrong direction.
    - Fixed that manual rotation of entity with rotation upgrade order didn't clear that order. (https://forums.factorio.com/95807)
    - Fixed in calculation of required modules when combining real and requested modules during blueprint creation. (https://forums.factorio.com/96033)
    - Fixed that blueprint containing only entities placeable off grid was built off grid even with snap to grid specified. (https://forums.factorio.com/96084)
    - Fixed crash caused by scrolling blueprint book in a blueprint shelf that is not yet synchronised. (https://forums.factorio.com/96110)
    - Fixed that tips & tricks simulation sounds were continuing to play when switched to a tutorial. (https://forums.factorio.com/96108)
    - Fixed that player could get stuck by entities created in the tutorials. (https://forums.factorio.com/96107)
    - Fixed some unnecessary error sounds in a special cases when building power poles. (https://forums.factorio.com/96100)
    - Fixed that exiting high speed moving train could result in a player being stuck. (https://forums.factorio.com/96092)
    - Fixed mod dependency tooltips in some cases. (https://forums.factorio.com/96145)
    - Fixed that the upper 1/3 part of the color picker button in the train stop gui didn't work. (https://forums.factorio.com/96149)
    - Fixed walls would not be buildable on valid positions in some cases. (https://forums.factorio.com/96043)
    - Fixed crash related to modded underground pipe ghosts with multiple connections with different lengths. (https://forums.factorio.com/96134)
    - Fixed that it was sometimes possible for an entity to attack an entity on a different surface. (https://forums.factorio.com/96094)
    - Fixed inaccurate range indicator in spidertron. (https://forums.factorio.com/95808)
    - Fixed that some sounds that were audible when viewing a certain part of the map in map view wouldn't stop when closing the map view. (https://forums.factorio.com/96021)
  Changes:
    - Added shortcut info tooltips to to all of the relevant confirm buttons and close buttons.
    - Lowered editor surface changing shortcut to not be in the way if Control + <number> is used for something. (https://forums.factorio.com/96121)
    - Changed personal logistic requests for ammo so they don't get delivered to the spidertron you're driving. (https://forums.factorio.com/95741)
  Scripting:
    - Added move_stuck_players bool parameter (false by default) to the create_entity method.
---------------------------------------------------------------------------------------------------
Version: 1.1.21
Date: 05. 02. 2021
  Bugfixes:
    - Fixed crash related to using belt traversing in latency state. (https://forums.factorio.com/95693)
    - Fixed crash triggered by desync while entities are marked for upgrade in latency state.
    - Fixed non precise belt traversing behaviour in latency state.
    - Fixed a desync related to upgrading entities in the latency state.
    - Fixed upgrading unpaired underground belt by smart ghost building.
---------------------------------------------------------------------------------------------------
Version: 1.1.20
Date: 04. 02. 2021
  Changes:
    - Added hotkey (default O) to toggle the train overview GUI.
  Bugfixes:
    - Fixed that gates would open for spidertron. (https://forums.factorio.com/94992)
    - Fixed tank weapon cooldown rendering. (https://forums.factorio.com/95013)
    - Fixed that changing the force of a player or spidertron would lose logistic requests. (https://forums.factorio.com/95096)
    - Fixed that deleting the last scenario didn't correctly clear name, description and preview in the new game gui. (https://forums.factorio.com/95243)
    - Fixed that it wasn't possible to manually merge trains in chests. (https://forums.factorio.com/95281)
    - Fixed a crash when rendering rich text tooltips in some cases. (https://forums.factorio.com/95294)
    - Fixed the Trains/Train stop GUI showing trains on other surfaces. (https://forums.factorio.com/95366)
    - Fixed player dying in a scenario inside simulation widget would end currently running scenario. (https://forums.factorio.com/95285)
    - Fixed that create_entities_from_blueprint_string didn't insert train fuel. (https://forums.factorio.com/95286)
    - Fixed that building blueprints in the game next to uncharted areas didn't work as expected. (https://forums.factorio.com/95056)
    - Fixed biters and groups in Wave defense overloading the pathfinder. (https://forums.factorio.com/95542)
    - Building gets interrupted when moving between map and game view. (https://forums.factorio.com/95187)
    - Fixed building error message spam when building transport belts over obstacle. (https://forums.factorio.com/95402)
    - Fixed that undoing deconstruction of building with modules created extra module request. (https://forums.factorio.com/95466)
    - Fixed inconsistency related to building out of reach and moving. (https://forums.factorio.com/95310)
    - Fixed that the selected map generator preset was not correctly saved when generating a map for multiplayer or map editor. (https://forums.factorio.com/95277)
    - Fixed that the map generator GUI would only save it's state when pressing Next/Play. (https://forums.factorio.com/95277)
    - Fixed that dropping single items into machines using modules didn't clear the module requests. (https://forums.factorio.com/95564)
    - Fixed that the stations list wasn't sorted using natural sort order. (https://forums.factorio.com/95261)
    - Fixed the blueprint import with odd odd grid offsets. (https://forums.factorio.com/95614)
    - Fixed that the game didn't show name of the item in the request slot tooltip when it is disabled for being already set. (https://forums.factorio.com/95370)
    - Fixed that the undo button tooltip didn't update when clicked. (https://forums.factorio.com/95259)
    - Fixed bad tooltip indentation when instruction can't fit one line. (https://forums.factorio.com/95242)
    - Fixed overbuilding underground pipe ghosts with real pipes underground pipes. (https://forums.factorio.com/95038)
    - Fixed inconsistency in direction selection when being a client in a multiplayer game. (https://forums.factorio.com/95330)
    - Fixed that overbuilding pole out of reach didn't consider the pole to be part of the drag building logic. (https://forums.factorio.com/95365)
    - Fixed that the "Continue" button wouldn't remember whether the last game was single-player or multi-player when non-blocking saving was enabled. (https://forums.factorio.com/92804)
    - Fixed rare electric network migration error related to loading save without all the related mods. (https://forums.factorio.com/95478)
  Scripting:
    - Added on_research_reversed.
---------------------------------------------------------------------------------------------------
Version: 1.1.19
Date: 26. 01. 2021
  Bugfixes:
    - Fixed certain build by dragging inconsistencies.
    - Fixed that force-building blueprint from blueprint library near a train stop could add the stop into the schedule instead of building the blueprint. (https://forums.factorio.com/94940)
    - Fixed desync/consistency issue related to drag building ghost electric pole, while the previous pole is built by robots before the next ghost is built.
    - Fixed build distance check related to rotation of rectangular entities. (https://forums.factorio.com/94967)
---------------------------------------------------------------------------------------------------
Version: 1.1.18
Date: 25. 01. 2021
  Bugfixes:
    - Fixed a crash related to tips & tricks simulations.
---------------------------------------------------------------------------------------------------
Version: 1.1.17
Date: 25. 01. 2021
  Bugfixes:
    - Limited blueprint building to charted areas - still regardless of fog of war. (https://forums.factorio.com/94933)
    - Fixed the ability to build belts outside placement range in situations where it shouldn't be possible. (https://forums.factorio.com/94912)
    - Fixed that modded rapid trains could cause consistency issues with rails. Trains faster than 7386.3km/h will be limited to that speed. (https://forums.factorio.com/94924)
  Scripting:
    - Added on_entity_logistic_slot_changed for player and vehicle personal logistics.
---------------------------------------------------------------------------------------------------
Version: 1.1.16
Date: 25. 01. 2021
  Bugfixes:
    - Fixed possible crashes when building train wagons near train wagon ghosts that are not on rails.
    - Fixed that the search didn't work correctly in the prototypes GUI in some cases. (https://forums.factorio.com/94889)
    - Fixed that extra warning sound was played when upgrading underground from the exit side. (https://forums.factorio.com/94887)
---------------------------------------------------------------------------------------------------
Version: 1.1.15
Date: 24. 01. 2021
  Changes:
    - Allowed to build blueprints anywhere regardless fog of war.
      Deconstruction planner, blueprint creation and related actions are still limited by the fog of war, so you can't easily make
      changes to the blueprint built out of fog of war, but this still feels like a better solution compared to having to use non-chart
      building of huge blueprints when no radar coverage is available.
  Bugfixes:
    - Fixed that ghost reversion orders prevented manual reversion of existing underground belt. (https://forums.factorio.com/94834)
    - Fixed that clicking near the train stop in a map mode with a spidertron remote with control settings that have conflicting
      the send click and open click opened the station instead of sending the spidertron. (https://forums.factorio.com/94814)
    - Fixed that the fast belt traversing tutorial didn't work when the option was turned off.
    - Fixed that ghosted wagons weren't properly considered for snapping. (https://forums.factorio.com/94835)
    - Fixed logic of searching for free space to exit car when the car was just destroyed, which could lead into passengers being
      stuck when the car was surrounded at the time of destruction. (https://forums.factorio.com/94845)
    - Fixed script error if you lose supply challenge in multiplayer. (https://forums.factorio.com/94847)
    - Tweaked the tips & tricks simulation to be more prepared for mods.
    - Made it possible to fast-revive cargo wagons. (https://forums.factorio.com/94851)
    - Fixed plural localisation error in supply challenge. (https://forums.factorio.com/94855)
    - Fixed multiplayer desync related to electric pole ghost building.
    - Fixed that pump was using double the energy when transferring to fluid wagon, which could, with the combination of the limited
      energy buffer, limit the speed of transfer to the wagon, and result in a flickery change of pump speed reporting. (https://forums.factorio.com/94852)
    - Fixed the entity transfer tutorial to work properly when mods change stack sizes of some of the related items. (https://forums.factorio.com/93833)
    - Fixed 'Move between labs' tip erroring with some mods. (https://forums.factorio.com/92809)
---------------------------------------------------------------------------------------------------
Version: 1.1.14
Date: 23. 01. 2021
  Optimizations:
    - Improved save-game speed by up to 2x depending on the save file size.
  Bugfixes:
    - Fixed that ghost reversion orders prevented manual reversion. (https://forums.factorio.com/94776)
    - Fixed application of the forced ghost mode that removes trees/rocks/cliffs in the way when ghost building. (https://forums.factorio.com/94784)
    - Fixed that undo didn't work for upgrade order created by ghost overbuilding.
    - Fixed extra collision message for ghost drag-building belts. (https://forums.factorio.com/94777)
    - Fixed crash related to rolling stock drag building. (https://forums.factorio.com/94785)
    - Fixed not loadable saves related to invalid blueprint settings when entities are migrated in a certain way. (https://forums.factorio.com/94767)
    - Added missing tips and trick entries related to fast belt bending and belt traversing.
